<?xml version="1.0" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PerlIO::via::QuotedPrint - PerlIO layer for quoted-printable strings</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rev="made" href="mailto:root@localhost" />
</head>

<body style="background-color: white">
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;PerlIO::via::QuotedPrint - PerlIO layer for quoted-printable strings</span></strong></big>
</td></tr>
</table>

<p><a name="__index__"></a></p>
<!-- INDEX BEGIN -->

<ul>

	<li><a href="#name">NAME</a></li>
	<li><a href="#synopsis">SYNOPSIS</a></li>
	<li><a href="#description">DESCRIPTION</a></li>
	<li><a href="#required_modules">REQUIRED MODULES</a></li>
	<li><a href="#see_also">SEE ALSO</a></li>
	<li><a href="#acknowledgements">ACKNOWLEDGEMENTS</a></li>
	<li><a href="#copyright">COPYRIGHT</a></li>
</ul>
<!-- INDEX END -->

<hr />
<p>
</p>
<h1><a name="name">NAME</a></h1>
<p>PerlIO::via::QuotedPrint - PerlIO layer for quoted-printable strings</p>
<p>
</p>
<hr />
<h1><a name="synopsis">SYNOPSIS</a></h1>
<pre>
 use PerlIO::via::QuotedPrint;</pre>
<pre>
 open( my $in,'&lt;:via(QuotedPrint)','file.qp' )
  or die &quot;Can't open file.qp for reading: $!\n&quot;;
 
 open( my $out,'&gt;:via(QuotedPrint)','file.qp' )
  or die &quot;Can't open file.qp for writing: $!\n&quot;;</pre>
<p>
</p>
<hr />
<h1><a name="description">DESCRIPTION</a></h1>
<p>This module implements a PerlIO layer that works on files encoded in the
quoted-printable format.  It will decode from quoted-printable while reading
from a handle, and it will encode as quoted-printable while writing to a handle.</p>
<p>
</p>
<hr />
<h1><a name="required_modules">REQUIRED MODULES</a></h1>
<pre>
 MIME::QuotedPrint (any)</pre>
<p>
</p>
<hr />
<h1><a name="see_also">SEE ALSO</a></h1>
<p><a href="../via.html">the PerlIO::via manpage</a>, <a href="../../MIME/QuotedPrint.html">the MIME::QuotedPrint manpage</a>, <a href="Base64.html">the PerlIO::via::Base64 manpage</a>,
<a href="MD5.html">the PerlIO::via::MD5 manpage</a>, <a href="StripHTML.html">the PerlIO::via::StripHTML manpage</a>, <a href="Rotate.html">the PerlIO::via::Rotate manpage</a>.</p>
<p>
</p>
<hr />
<h1><a name="acknowledgements">ACKNOWLEDGEMENTS</a></h1>
<p>Based on example that was initially added to MIME::QuotedPrint.pm for the
5.8.0 distribution of Perl.</p>
<p>
</p>
<hr />
<h1><a name="copyright">COPYRIGHT</a></h1>
<p>Copyright (c) 2002-2003 Elizabeth Mattijsen.  All rights reserved.  This
library is free software; you can redistribute it and/or modify it under
the same terms as Perl itself.</p>
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;PerlIO::via::QuotedPrint - PerlIO layer for quoted-printable strings</span></strong></big>
</td></tr>
</table>

</body>

</html>
