<?xml version="1.0" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>WWW::RobotRules::AnyDBM_File - Persistent RobotRules</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rev="made" href="mailto:root@localhost" />
</head>

<body style="background-color: white">
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;WWW::RobotRules::AnyDBM_File - Persistent RobotRules</span></strong></big>
</td></tr>
</table>

<p><a name="__index__"></a></p>
<!-- INDEX BEGIN -->

<ul>

	<li><a href="#name">NAME</a></li>
	<li><a href="#synopsis">SYNOPSIS</a></li>
	<li><a href="#description">DESCRIPTION</a></li>
	<li><a href="#see_also">SEE ALSO</a></li>
	<li><a href="#authors">AUTHORS</a></li>
</ul>
<!-- INDEX END -->

<hr />
<p>
</p>
<h1><a name="name">NAME</a></h1>
<p>WWW::RobotRules::AnyDBM_File - Persistent RobotRules</p>
<p>
</p>
<hr />
<h1><a name="synopsis">SYNOPSIS</a></h1>
<pre>
 require WWW::RobotRules::AnyDBM_File;
 require LWP::RobotUA;</pre>
<pre>
 # Create a robot useragent that uses a diskcaching RobotRules
 my $rules = new WWW::RobotRules::AnyDBM_File 'my-robot/1.0', 'cachefile';
 my $ua = new WWW::RobotUA 'my-robot/1.0', 'me@foo.com', $rules;</pre>
<pre>
 # Then just use $ua as usual
 $res = $ua-&gt;request($req);</pre>
<p>
</p>
<hr />
<h1><a name="description">DESCRIPTION</a></h1>
<p>This is a subclass of <em>WWW::RobotRules</em> that uses the AnyDBM_File
package to implement persistent diskcaching of <em>robots.txt</em> and host
visit information.</p>
<p>The constructor (the <code>new()</code> method) takes an extra argument specifying
the name of the DBM file to use.  If the DBM file already exists, then
you can specify undef as agent name as the name can be obtained from
the DBM database.</p>
<p>
</p>
<hr />
<h1><a name="see_also">SEE ALSO</a></h1>
<p><a href="../RobotRules.html">the WWW::RobotRules manpage</a>, <a href="../../LWP/RobotUA.html">the LWP::RobotUA manpage</a></p>
<p>
</p>
<hr />
<h1><a name="authors">AUTHORS</a></h1>
<p>Hakan Ardo &lt;<a href="mailto:hakan@munin.ub2.lu.se>">hakan@munin.ub2.lu.se></a>, Gisle Aas &lt;<a href="mailto:aas@sn.no>">aas@sn.no></a></p>
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;WWW::RobotRules::AnyDBM_File - Persistent RobotRules</span></strong></big>
</td></tr>
</table>

</body>

</html>
