<?xml version="1.0" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>perl56delta - what's new for perl v5.6.0</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rev="made" href="mailto:root@localhost" />
</head>

<body style="background-color: white">
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;perl56delta - what's new for perl v5.6.0</span></strong></big>
</td></tr>
</table>

<p><a name="__index__"></a></p>
<!-- INDEX BEGIN -->

<ul>

	<li><a href="#name">NAME</a></li>
	<li><a href="#description">DESCRIPTION</a></li>
	<li><a href="#core_enhancements">Core Enhancements</a></li>
	<ul>

		<li><a href="#interpreter_cloning__threads__and_concurrency">Interpreter cloning, threads, and concurrency</a></li>
		<li><a href="#lexically_scoped_warning_categories">Lexically scoped warning categories</a></li>
		<li><a href="#unicode_and_utf8_support">Unicode and UTF-8 support</a></li>
		<li><a href="#support_for_interpolating_named_characters">Support for interpolating named characters</a></li>
		<li><a href="#our_declarations">``our'' declarations</a></li>
		<li><a href="#support_for_strings_represented_as_a_vector_of_ordinals">Support for strings represented as a vector of ordinals</a></li>
		<li><a href="#improved_perl_version_numbering_system">Improved Perl version numbering system</a></li>
		<li><a href="#new_syntax_for_declaring_subroutine_attributes">New syntax for declaring subroutine attributes</a></li>
		<li><a href="#file_and_directory_handles_can_be_autovivified">File and directory handles can be autovivified</a></li>
		<li><a href="#open___with_more_than_two_arguments"><code>open()</code> with more than two arguments</a></li>
		<li><a href="#64bit_support">64-bit support</a></li>
		<li><a href="#large_file_support">Large file support</a></li>
		<li><a href="#long_doubles">Long doubles</a></li>
		<li><a href="#more_bits">``more bits''</a></li>
		<li><a href="#enhanced_support_for_sort___subroutines">Enhanced support for <code>sort()</code> subroutines</a></li>
		<li><a href="#sort__coderef__foo_allowed"><code>sort $coderef @foo</code> allowed</a></li>
		<li><a href="#file_globbing_implemented_internally">File globbing implemented internally</a></li>
		<li><a href="#support_for_check_blocks">Support for CHECK blocks</a></li>
		<li><a href="#posix_character_class_syntax_______supported">POSIX character class syntax [: :] supported</a></li>
		<li><a href="#better_pseudorandom_number_generator">Better pseudo-random number generator</a></li>
		<li><a href="#improved_qw___operator">Improved <code>qw//</code> operator</a></li>
		<li><a href="#better_worstcase_behavior_of_hashes">Better worst-case behavior of hashes</a></li>
		<li><a href="#pack___format__z__supported"><code>pack()</code> format 'Z' supported</a></li>
		<li><a href="#pack___format_modifier_____supported"><code>pack()</code> format modifier '!' supported</a></li>
		<li><a href="#pack___and_unpack___support_counted_strings"><code>pack()</code> and <code>unpack()</code> support counted strings</a></li>
		<li><a href="#comments_in_pack___templates">Comments in <code>pack()</code> templates</a></li>
		<li><a href="#weak_references">Weak references</a></li>
		<li><a href="#binary_numbers_supported">Binary numbers supported</a></li>
		<li><a href="#lvalue_subroutines">Lvalue subroutines</a></li>
		<li><a href="#some_arrows_may_be_omitted_in_calls_through_references">Some arrows may be omitted in calls through references</a></li>
		<li><a href="#boolean_assignment_operators_are_legal_lvalues">Boolean assignment operators are legal lvalues</a></li>
		<li><a href="#exists___is_supported_on_subroutine_names"><code>exists()</code> is supported on subroutine names</a></li>
		<li><a href="#exists___and_delete___are_supported_on_array_elements"><code>exists()</code> and <code>delete()</code> are supported on array elements</a></li>
		<li><a href="#pseudohashes_work_better">Pseudo-hashes work better</a></li>
		<li><a href="#automatic_flushing_of_output_buffers">Automatic flushing of output buffers</a></li>
		<li><a href="#better_diagnostics_on_meaningless_filehandle_operations">Better diagnostics on meaningless filehandle operations</a></li>
		<li><a href="#where_possible__buffered_data_discarded_from_duped_input_filehandle">Where possible, buffered data discarded from duped input filehandle</a></li>
		<li><a href="#eof___has_the_same_old_magic_as___"><code>eof()</code> has the same old magic as &lt;&gt;</a></li>
		<li><a href="#binmode___can_be_used_to_set__crlf_and__raw_modes"><code>binmode()</code> can be used to set :crlf and :raw modes</a></li>
		<li><a href="#t_filetest_recognizes_utf8_encoded_files_as_text"><code>-T</code> filetest recognizes UTF-8 encoded files as ``text''</a></li>
		<li><a href="#system____backticks_and_pipe_open_now_reflect_exec___failure">system(), backticks and pipe open now reflect <code>exec()</code> failure</a></li>
		<li><a href="#improved_diagnostics">Improved diagnostics</a></li>
		<li><a href="#diagnostics_follow_stderr">Diagnostics follow STDERR</a></li>
		<li><a href="#more_consistent_closeonexec_behavior">More consistent close-on-exec behavior</a></li>
		<li><a href="#syswrite___easeofuse"><code>syswrite()</code> ease-of-use</a></li>
		<li><a href="#better_syntax_checks_on_parenthesized_unary_operators">Better syntax checks on parenthesized unary operators</a></li>
		<li><a href="#bit_operators_support_full_native_integer_width">Bit operators support full native integer width</a></li>
		<li><a href="#improved_security_features">Improved security features</a></li>
		<li><a href="#more_functional_bareword_prototype____">More functional bareword prototype (*)</a></li>
		<li><a href="#require_and_do_may_be_overridden"><code>require</code> and <code>do</code> may be overridden</a></li>
		<li><a href="#__x_variables_may_now_have_names_longer_than_one_character">$^X variables may now have names longer than one character</a></li>
		<li><a href="#new_variable___c_reflects_c_switch">New variable $^C reflects <code>-c</code> switch</a></li>
		<li><a href="#new_variable___v_contains_perl_version_as_a_string">New variable $^V contains Perl version as a string</a></li>
		<li><a href="#optional_y2k_warnings">Optional Y2K warnings</a></li>
		<li><a href="#arrays_now_always_interpolate_into_doublequoted_strings">Arrays now always interpolate into double-quoted strings</a></li>
		<li><a href="#__and____provide_starting_ending_offsets_of_regex_matches">@- and @+ provide starting/ending offsets of regex matches</a></li>
	</ul>

	<li><a href="#modules_and_pragmata">Modules and Pragmata</a></li>
	<ul>

		<li><a href="#modules">Modules</a></li>
		<li><a href="#pragmata">Pragmata</a></li>
	</ul>

	<li><a href="#utility_changes">Utility Changes</a></li>
	<ul>

		<li><a href="#dprofpp">dprofpp</a></li>
		<li><a href="#find2perl">find2perl</a></li>
		<li><a href="#h2xs">h2xs</a></li>
		<li><a href="#perlcc">perlcc</a></li>
		<li><a href="#perldoc">perldoc</a></li>
		<li><a href="#the_perl_debugger">The Perl Debugger</a></li>
	</ul>

	<li><a href="#improved_documentation">Improved Documentation</a></li>
	<li><a href="#performance_enhancements">Performance enhancements</a></li>
	<ul>

		<li><a href="#simple_sort___using____a______b___and_the_like_are_optimized">Simple <code>sort()</code> using { $a &lt;=&gt; $b } and the like are optimized</a></li>
		<li><a href="#optimized_assignments_to_lexical_variables">Optimized assignments to lexical variables</a></li>
		<li><a href="#faster_subroutine_calls">Faster subroutine calls</a></li>
		<li><a href="#delete____each____values___and_hash_iteration_are_faster">delete(), each(), <code>values()</code> and hash iteration are faster</a></li>
	</ul>

	<li><a href="#installation_and_configuration_improvements">Installation and Configuration Improvements</a></li>
	<ul>

		<li><a href="#dusethreads_means_something_different">-Dusethreads means something different</a></li>
		<li><a href="#new_configure_flags">New Configure flags</a></li>
		<li><a href="#threadedness_and_64bitness_now_more_daring">Threadedness and 64-bitness now more daring</a></li>
		<li><a href="#long_doubles">Long Doubles</a></li>
		<li><a href="#dusemorebits">-Dusemorebits</a></li>
		<li><a href="#duselargefiles">-Duselargefiles</a></li>
		<li><a href="#installusrbinperl">installusrbinperl</a></li>
		<li><a href="#socks_support">SOCKS support</a></li>
		<li><a href="#a_flag"><code>-A</code> flag</a></li>
		<li><a href="#enhanced_installation_directories">Enhanced Installation Directories</a></li>
	</ul>

	<li><a href="#platform_specific_changes">Platform specific changes</a></li>
	<ul>

		<li><a href="#supported_platforms">Supported platforms</a></li>
		<li><a href="#dos">DOS</a></li>
		<li><a href="#os390__openedition_mvs_">OS390 (OpenEdition MVS)</a></li>
		<li><a href="#vms">VMS</a></li>
		<li><a href="#win32">Win32</a></li>
	</ul>

	<li><a href="#significant_bug_fixes">Significant bug fixes</a></li>
	<ul>

		<li><a href="#_handle__on_empty_files">&lt;HANDLE&gt; on empty files</a></li>
		<li><a href="#eval_______improvements"><code>eval '...'</code> improvements</a></li>
		<li><a href="#all_compilation_errors_are_true_errors">All compilation errors are true errors</a></li>
		<li><a href="#implicitly_closed_filehandles_are_safer">Implicitly closed filehandles are safer</a></li>
		<li><a href="#behavior_of_list_slices_is_more_consistent">Behavior of list slices is more consistent</a></li>
		<li><a href="#_____prototype_and__foo_a_"><code>(\$)</code> prototype and <code>$foo{a}</code></a></li>
		<li><a href="#goto__sub_and_autoload"><code>goto &amp;sub</code> and AUTOLOAD</a></li>
		<li><a href="#bareword_allowed_under_use_integer"><code>-bareword</code> allowed under <code>use integer</code></a></li>
		<li><a href="#failures_in_destroy__">Failures in <code>DESTROY()</code></a></li>
		<li><a href="#locale_bugs_fixed">Locale bugs fixed</a></li>
		<li><a href="#memory_leaks">Memory leaks</a></li>
		<li><a href="#spurious_subroutine_stubs_after_failed_subroutine_calls">Spurious subroutine stubs after failed subroutine calls</a></li>
		<li><a href="#taint_failures_under_u">Taint failures under <code>-U</code></a></li>
		<li><a href="#end_blocks_and_the_c_switch">END blocks and the <code>-c</code> switch</a></li>
		<li><a href="#potential_to_leak_data_filehandles">Potential to leak DATA filehandles</a></li>
	</ul>

	<li><a href="#new_or_changed_diagnostics">New or Changed Diagnostics</a></li>
	<li><a href="#new_tests">New tests</a></li>
	<li><a href="#incompatible_changes">Incompatible Changes</a></li>
	<ul>

		<li><a href="#perl_source_incompatibilities">Perl Source Incompatibilities</a></li>
		<li><a href="#c_source_incompatibilities">C Source Incompatibilities</a></li>
		<li><a href="#compatible_c_source_api_changes">Compatible C Source API Changes</a></li>
		<li><a href="#binary_incompatibilities">Binary Incompatibilities</a></li>
	</ul>

	<li><a href="#known_problems">Known Problems</a></li>
	<ul>

		<li><a href="#thread_test_failures">Thread test failures</a></li>
		<li><a href="#ebcdic_platforms_not_supported">EBCDIC platforms not supported</a></li>
		<li><a href="#in_64bit_hpux_the_lib_io_multihomed_test_may_hang">In 64-bit HP-UX the lib/io_multihomed test may hang</a></li>
		<li><a href="#nextstep_3_3_posix_test_failure">NEXTSTEP 3.3 POSIX test failure</a></li>
		<li><a href="#tru64__aka_digital_unix__aka_dec_osf_1__lib_sdbm_test_failure_with_gcc">Tru64 (aka Digital UNIX, aka DEC OSF/1) lib/sdbm test failure with gcc</a></li>
		<li><a href="#unicos_mk_cc_failures_during_configure_run">UNICOS/mk CC failures during Configure run</a></li>
		<li><a href="#arrow_operator_and_arrays">Arrow operator and arrays</a></li>
		<li><a href="#experimental_features">Experimental features</a></li>
	</ul>

	<li><a href="#obsolete_diagnostics">Obsolete Diagnostics</a></li>
	<li><a href="#reporting_bugs">Reporting Bugs</a></li>
	<li><a href="#see_also">SEE ALSO</a></li>
	<li><a href="#history">HISTORY</a></li>
</ul>
<!-- INDEX END -->

<hr />
<p>
</p>
<h1><a name="name">NAME</a></h1>
<p>perl56delta - what's new for perl v5.6.0</p>
<p>
</p>
<hr />
<h1><a name="description">DESCRIPTION</a></h1>
<p>This document describes differences between the 5.005 release and the 5.6.0
release.</p>
<p>
</p>
<hr />
<h1><a name="core_enhancements">Core Enhancements</a></h1>
<p>
</p>
<h2><a name="interpreter_cloning__threads__and_concurrency">Interpreter cloning, threads, and concurrency</a></h2>
<p>Perl 5.6.0 introduces the beginnings of support for running multiple
interpreters concurrently in different threads.  In conjunction with
the <code>perl_clone()</code> API call, which can be used to selectively duplicate
the state of any given interpreter, it is possible to compile a
piece of code once in an interpreter, clone that interpreter
one or more times, and run all the resulting interpreters in distinct
threads.</p>
<p>On the Windows platform, this feature is used to emulate <code>fork()</code> at the
interpreter level.  See <a href="perlfork.html">the perlfork manpage</a> for details about that.</p>
<p>This feature is still in evolution.  It is eventually meant to be used
to selectively clone a subroutine and data reachable from that
subroutine in a separate interpreter and run the cloned subroutine
in a separate thread.  Since there is no shared data between the
interpreters, little or no locking will be needed (unless parts of
the symbol table are explicitly shared).  This is obviously intended
to be an easy-to-use replacement for the existing threads support.</p>
<p>Support for cloning interpreters and interpreter concurrency can be
enabled using the -Dusethreads Configure option (see win32/Makefile for
how to enable it on Windows.)  The resulting perl executable will be
functionally identical to one that was built with -Dmultiplicity, but
the <code>perl_clone()</code> API call will only be available in the former.</p>
<p>-Dusethreads enables the cpp macro USE_ITHREADS by default, which in turn
enables Perl source code changes that provide a clear separation between
the op tree and the data it operates with.  The former is immutable, and
can therefore be shared between an interpreter and all of its clones,
while the latter is considered local to each interpreter, and is therefore
copied for each clone.</p>
<p>Note that building Perl with the -Dusemultiplicity Configure option
is adequate if you wish to run multiple <strong>independent</strong> interpreters
concurrently in different threads.  -Dusethreads only provides the
additional functionality of the <code>perl_clone()</code> API call and other
support for running <strong>cloned</strong> interpreters concurrently.</p>
<pre>
    NOTE: This is an experimental feature.  Implementation details are
    subject to change.</pre>
<p>
</p>
<h2><a name="lexically_scoped_warning_categories">Lexically scoped warning categories</a></h2>
<p>You can now control the granularity of warnings emitted by perl at a finer
level using the <code>use warnings</code> pragma.  <a href="../../warnings.html">the warnings manpage</a> and <a href="perllexwarn.html">the perllexwarn manpage</a>
have copious documentation on this feature.</p>
<p>
</p>
<h2><a name="unicode_and_utf8_support">Unicode and UTF-8 support</a></h2>
<p>Perl now uses UTF-8 as its internal representation for character
strings.  The <code>utf8</code> and <code>bytes</code> pragmas are used to control this support
in the current lexical scope.  See <a href="perlunicode.html">the perlunicode manpage</a>, <a href="../../utf8.html">the utf8 manpage</a> and <a href="../../bytes.html">the bytes manpage</a> for
more information.</p>
<p>This feature is expected to evolve quickly to support some form of I/O
disciplines that can be used to specify the kind of input and output data
(bytes or characters).  Until that happens, additional modules from CPAN
will be needed to complete the toolkit for dealing with Unicode.</p>
<pre>
    NOTE: This should be considered an experimental feature.  Implementation
    details are subject to change.</pre>
<p>
</p>
<h2><a name="support_for_interpolating_named_characters">Support for interpolating named characters</a></h2>
<p>The new <code>\N</code> escape interpolates named characters within strings.
For example, <code>&quot;Hi! \N{WHITE SMILING FACE}&quot;</code> evaluates to a string
with a unicode smiley face at the end.</p>
<p>
</p>
<h2><a name="our_declarations">``our'' declarations</a></h2>
<p>An ``our'' declaration introduces a value that can be best understood
as a lexically scoped symbolic alias to a global variable in the
package that was current where the variable was declared.  This is
mostly useful as an alternative to the <code>vars</code> pragma, but also provides
the opportunity to introduce typing and other attributes for such
variables.  See <a href="perlfunc.html#our">our in the perlfunc manpage</a>.</p>
<p>
</p>
<h2><a name="support_for_strings_represented_as_a_vector_of_ordinals">Support for strings represented as a vector of ordinals</a></h2>
<p>Literals of the form <code>v1.2.3.4</code> are now parsed as a string composed
of characters with the specified ordinals.  This is an alternative, more
readable way to construct (possibly unicode) strings instead of
interpolating characters, as in <code>&quot;\x{1}\x{2}\x{3}\x{4}&quot;</code>.  The leading
<code>v</code> may be omitted if there are more than two ordinals, so <code>1.2.3</code> is
parsed the same as <code>v1.2.3</code>.</p>
<p>Strings written in this form are also useful to represent version ``numbers''.
It is easy to compare such version ``numbers'' (which are really just plain
strings) using any of the usual string comparison operators <code>eq</code>, <code>ne</code>,
<code>lt</code>, <code>gt</code>, etc., or perform bitwise string operations on them using <code>|</code>,
<code>&amp;</code>, etc.</p>
<p>In conjunction with the new <code>$^V</code> magic variable (which contains
the perl version as a string), such literals can be used as a readable way
to check if you're running a particular version of Perl:</p>
<pre>
    # this will parse in older versions of Perl also
    if ($^V and $^V gt v5.6.0) {
        # new features supported
    }</pre>
<p><code>require</code> and <code>use</code> also have some special magic to support such
literals, but this particular usage should be avoided because it leads to
misleading error messages under versions of Perl which don't support vector
strings.  Using a true version number will ensure correct behavior in all
versions of Perl:</p>
<pre>
    require 5.006;    # run time check for v5.6
    use 5.006_001;    # compile time check for v5.6.1</pre>
<p>Also, <code>sprintf</code> and <code>printf</code> support the Perl-specific format flag <code>%v</code>
to print ordinals of characters in arbitrary strings:</p>
<pre>
    printf &quot;v%vd&quot;, $^V;         # prints current version, such as &quot;v5.5.650&quot;
    printf &quot;%*vX&quot;, &quot;:&quot;, $addr;  # formats IPv6 address
    printf &quot;%*vb&quot;, &quot; &quot;, $bits;  # displays bitstring</pre>
<p>See <a href="perldata.html#scalar_value_constructors">Scalar value constructors in the perldata manpage</a> for additional information.</p>
<p>
</p>
<h2><a name="improved_perl_version_numbering_system">Improved Perl version numbering system</a></h2>
<p>Beginning with Perl version 5.6.0, the version number convention has been
changed to a ``dotted integer'' scheme that is more commonly found in open
source projects.</p>
<p>Maintenance versions of v5.6.0 will be released as v5.6.1, v5.6.2 etc.
The next development series following v5.6.0 will be numbered v5.7.x,
beginning with v5.7.0, and the next major production release following
v5.6.0 will be v5.8.0.</p>
<p>The English module now sets $PERL_VERSION to $^V (a string value) rather
than <code>$]</code> (a numeric value).  (This is a potential incompatibility.
Send us a report via perlbug if you are affected by this.)</p>
<p>The v1.2.3 syntax is also now legal in Perl.
See <a href="#support_for_strings_represented_as_a_vector_of_ordinals">Support for strings represented as a vector of ordinals</a> for more on that.</p>
<p>To cope with the new versioning system's use of at least three significant
digits for each version component, the method used for incrementing the
subversion number has also changed slightly.  We assume that versions older
than v5.6.0 have been incrementing the subversion component in multiples of
10.  Versions after v5.6.0 will increment them by 1.  Thus, using the new
notation, 5.005_03 is the ``same'' as v5.5.30, and the first maintenance
version following v5.6.0 will be v5.6.1 (which should be read as being
equivalent to a floating point value of 5.006_001 in the older format,
stored in <code>$]</code>).</p>
<p>
</p>
<h2><a name="new_syntax_for_declaring_subroutine_attributes">New syntax for declaring subroutine attributes</a></h2>
<p>Formerly, if you wanted to mark a subroutine as being a method call or
as requiring an automatic <code>lock()</code> when it is entered, you had to declare
that with a <code>use attrs</code> pragma in the body of the subroutine.
That can now be accomplished with declaration syntax, like this:</p>
<pre>
    sub mymethod : locked method;
    ...
    sub mymethod : locked method {
        ...
    }</pre>
<pre>
    sub othermethod :locked :method;
    ...
    sub othermethod :locked :method {
        ...
    }</pre>
<p>(Note how only the first <code>:</code> is mandatory, and whitespace surrounding
the <code>:</code> is optional.)</p>
<p><em>AutoSplit.pm</em> and <em>SelfLoader.pm</em> have been updated to keep the attributes
with the stubs they provide.  See <a href="../../attributes.html">the attributes manpage</a>.</p>
<p>
</p>
<h2><a name="file_and_directory_handles_can_be_autovivified">File and directory handles can be autovivified</a></h2>
<p>Similar to how constructs such as <code>$x-&gt;[0]</code> autovivify a reference,
handle constructors (open(), opendir(), pipe(), socketpair(), sysopen(),
socket(), and <code>accept())</code> now autovivify a file or directory handle
if the handle passed to them is an uninitialized scalar variable.  This
allows the constructs such as <a href="#item_open"><code>open(my $fh, ...)</code></a> and <a href="#item_open"><code>open(local $fh,...)</code></a>
to be used to create filehandles that will conveniently be closed
automatically when the scope ends, provided there are no other references
to them.  This largely eliminates the need for typeglobs when opening
filehandles that must be passed around, as in the following example:</p>
<pre>
    sub myopen {
        open my $fh, &quot;@_&quot;
             or die &quot;Can't open '@_': $!&quot;;
        return $fh;
    }</pre>
<pre>
    {
        my $f = myopen(&quot;&lt;/etc/motd&quot;);
        print &lt;$f&gt;;
        # $f implicitly closed here
    }</pre>
<p>
</p>
<h2><a name="open___with_more_than_two_arguments"><a href="#item_open"><code>open()</code></a> with more than two arguments</a></h2>
<p>If <a href="#item_open"><code>open()</code></a> is passed three arguments instead of two, the second argument
is used as the mode and the third argument is taken to be the file name.
This is primarily useful for protecting against unintended magic behavior
of the traditional two-argument form.  See <a href="perlfunc.html#open">open in the perlfunc manpage</a>.</p>
<p>
</p>
<h2><a name="64bit_support">64-bit support</a></h2>
<p>Any platform that has 64-bit integers either</p>
<pre>
        (1) natively as longs or ints
        (2) via special compiler flags
        (3) using long long or int64_t</pre>
<p>is able to use ``quads'' (64-bit integers) as follows:</p>
<ul>
<li>
<p>constants (decimal, hexadecimal, octal, binary) in the code</p>
</li>
<li>
<p>arguments to <code>oct()</code> and <code>hex()</code></p>
</li>
<li>
<p>arguments to print(), <code>printf()</code> and <code>sprintf()</code> (flag prefixes ll, L, q)</p>
</li>
<li>
<p>printed as such</p>
</li>
<li>
<p><code>pack()</code> and <code>unpack()</code> ``q'' and ``Q'' formats</p>
</li>
<li>
<p>in basic arithmetics: + - * / % (NOTE: operating close to the limits
of the integer values may produce surprising results)</p>
</li>
<li>
<p>in bit arithmetics: &amp; | ^ ~ &lt;&lt; &gt;&gt; (NOTE: these used to be forced 
to be 32 bits wide but now operate on the full native width.)</p>
</li>
<li>
<p><a href="#item_vec"><code>vec()</code></a></p>
</li>
</ul>
<p>Note that unless you have the case (a) you will have to configure
and compile Perl using the -Duse64bitint Configure flag.</p>
<pre>
    NOTE: The Configure flags -Duselonglong and -Duse64bits have been
    deprecated.  Use -Duse64bitint instead.</pre>
<p>There are actually two modes of 64-bitness: the first one is achieved
using Configure -Duse64bitint and the second one using Configure
-Duse64bitall.  The difference is that the first one is minimal and
the second one maximal.  The first works in more places than the second.</p>
<p>The <code>use64bitint</code> does only as much as is required to get 64-bit
integers into Perl (this may mean, for example, using ``long longs'')
while your memory may still be limited to 2 gigabytes (because your
pointers could still be 32-bit).  Note that the name <code>64bitint</code> does
not imply that your C compiler will be using 64-bit <code>int</code>s (it might,
but it doesn't have to): the <code>use64bitint</code> means that you will be
able to have 64 bits wide scalar values.</p>
<p>The <code>use64bitall</code> goes all the way by attempting to switch also
integers (if it can), longs (and pointers) to being 64-bit.  This may
create an even more binary incompatible Perl than -Duse64bitint: the
resulting executable may not run at all in a 32-bit box, or you may
have to reboot/reconfigure/rebuild your operating system to be 64-bit
aware.</p>
<p>Natively 64-bit systems like Alpha and Cray need neither -Duse64bitint
nor -Duse64bitall.</p>
<p>Last but not least: note that due to Perl's habit of always using
floating point numbers, the quads are still not true integers.
When quads overflow their limits (0...18_446_744_073_709_551_615 unsigned,
-9_223_372_036_854_775_808...9_223_372_036_854_775_807 signed), they
are silently promoted to floating point numbers, after which they will
start losing precision (in their lower digits).</p>
<pre>
    NOTE: 64-bit support is still experimental on most platforms.
    Existing support only covers the LP64 data model.  In particular, the
    LLP64 data model is not yet supported.  64-bit libraries and system
    APIs on many platforms have not stabilized--your mileage may vary.</pre>
<p>
</p>
<h2><a name="large_file_support">Large file support</a></h2>
<p>If you have filesystems that support ``large files'' (files larger than
2 gigabytes), you may now also be able to create and access them from
Perl.</p>
<pre>
    NOTE: The default action is to enable large file support, if
    available on the platform.</pre>
<p>If the large file support is on, and you have a Fcntl constant
O_LARGEFILE, the O_LARGEFILE is automatically added to the flags
of sysopen().</p>
<p>Beware that unless your filesystem also supports ``sparse files'' seeking
to umpteen petabytes may be inadvisable.</p>
<p>Note that in addition to requiring a proper file system to do large
files you may also need to adjust your per-process (or your
per-system, or per-process-group, or per-user-group) maximum filesize
limits before running Perl scripts that try to handle large files,
especially if you intend to write such files.</p>
<p>Finally, in addition to your process/process group maximum filesize
limits, you may have quota limits on your filesystems that stop you
(your user id or your user group id) from using large files.</p>
<p>Adjusting your process/user/group/file system/operating system limits
is outside the scope of Perl core language.  For process limits, you
may try increasing the limits using your shell's limits/limit/ulimit
command before running Perl.  The BSD::Resource extension (not
included with the standard Perl distribution) may also be of use, it
offers the getrlimit/setrlimit interface that can be used to adjust
process resource usage limits, including the maximum filesize limit.</p>
<p>
</p>
<h2><a name="long_doubles">Long doubles</a></h2>
<p>In some systems you may be able to use long doubles to enhance the
range and precision of your double precision floating point numbers
(that is, Perl's numbers).  Use Configure -Duselongdouble to enable
this support (if it is available).</p>
<p>
</p>
<h2><a name="more_bits">``more bits''</a></h2>
<p>You can ``Configure -Dusemorebits'' to turn on both the 64-bit support
and the long double support.</p>
<p>
</p>
<h2><a name="enhanced_support_for_sort___subroutines">Enhanced support for <code>sort()</code> subroutines</a></h2>
<p>Perl subroutines with a prototype of <code>($$)</code>, and XSUBs in general, can
now be used as sort subroutines.  In either case, the two elements to
be compared are passed as normal parameters in @_.  See <a href="perlfunc.html#sort">sort in the perlfunc manpage</a>.</p>
<p>For unprototyped sort subroutines, the historical behavior of passing 
the elements to be compared as the global variables $a and $b remains
unchanged.</p>
<p>
</p>
<h2><a name="sort__coderef__foo_allowed"><code>sort $coderef @foo</code> allowed</a></h2>
<p><code>sort()</code> did not accept a subroutine reference as the comparison
function in earlier versions.  This is now permitted.</p>
<p>
</p>
<h2><a name="file_globbing_implemented_internally">File globbing implemented internally</a></h2>
<p>Perl now uses the File::Glob implementation of the <code>glob()</code> operator
automatically.  This avoids using an external csh process and the
problems associated with it.</p>
<pre>
    NOTE: This is currently an experimental feature.  Interfaces and
    implementation are subject to change.</pre>
<p>
</p>
<h2><a name="support_for_check_blocks">Support for CHECK blocks</a></h2>
<p>In addition to <code>BEGIN</code>, <code>INIT</code>, <code>END</code>, <code>DESTROY</code> and <code>AUTOLOAD</code>,
subroutines named <code>CHECK</code> are now special.  These are queued up during
compilation and behave similar to END blocks, except they are called at
the end of compilation rather than at the end of execution.  They cannot
be called directly.</p>
<p>
</p>
<h2><a name="posix_character_class_syntax_______supported">POSIX character class syntax [: :] supported</a></h2>
<p>For example to match alphabetic characters use /[[:alpha:]]/.
See <a href="perlre.html">the perlre manpage</a> for details.</p>
<p>
</p>
<h2><a name="better_pseudorandom_number_generator">Better pseudo-random number generator</a></h2>
<p>In 5.005_0x and earlier, perl's <code>rand()</code> function used the C library
<code>rand(3)</code> function.  As of 5.005_52, Configure tests for drand48(),
random(), and <code>rand()</code> (in that order) and picks the first one it finds.</p>
<p>These changes should result in better random numbers from rand().</p>
<p>
</p>
<h2><a name="improved_qw___operator">Improved <code>qw//</code> operator</a></h2>
<p>The <code>qw//</code> operator is now evaluated at compile time into a true list
instead of being replaced with a run time call to <code>split()</code>.  This
removes the confusing misbehaviour of <code>qw//</code> in scalar context, which
had inherited that behaviour from split().</p>
<p>Thus:</p>
<pre>
    $foo = ($bar) = qw(a b c); print &quot;$foo|$bar\n&quot;;</pre>
<p>now correctly prints ``3|a'', instead of ``2|a''.</p>
<p>
</p>
<h2><a name="better_worstcase_behavior_of_hashes">Better worst-case behavior of hashes</a></h2>
<p>Small changes in the hashing algorithm have been implemented in
order to improve the distribution of lower order bits in the
hashed value.  This is expected to yield better performance on
keys that are repeated sequences.</p>
<p>
</p>
<h2><a name="pack___format__z__supported"><code>pack()</code> format 'Z' supported</a></h2>
<p>The new format type 'Z' is useful for packing and unpacking null-terminated
strings.  See <a href="perlfunc.html#pack">pack in the perlfunc manpage</a>.</p>
<p>
</p>
<h2><a name="pack___format_modifier_____supported"><code>pack()</code> format modifier '!' supported</a></h2>
<p>The new format type modifier '!' is useful for packing and unpacking
native shorts, ints, and longs.  See <a href="perlfunc.html#pack">pack in the perlfunc manpage</a>.</p>
<p>
</p>
<h2><a name="pack___and_unpack___support_counted_strings"><code>pack()</code> and <code>unpack()</code> support counted strings</a></h2>
<p>The template character '/' can be used to specify a counted string
type to be packed or unpacked.  See <a href="perlfunc.html#pack">pack in the perlfunc manpage</a>.</p>
<p>
</p>
<h2><a name="comments_in_pack___templates">Comments in <code>pack()</code> templates</a></h2>
<p>The '#' character in a template introduces a comment up to
end of the line.  This facilitates documentation of <code>pack()</code>
templates.</p>
<p>
</p>
<h2><a name="weak_references">Weak references</a></h2>
<p>In previous versions of Perl, you couldn't cache objects so as
to allow them to be deleted if the last reference from outside 
the cache is deleted.  The reference in the cache would hold a
reference count on the object and the objects would never be
destroyed.</p>
<p>Another familiar problem is with circular references.  When an
object references itself, its reference count would never go
down to zero, and it would not get destroyed until the program
is about to exit.</p>
<p>Weak references solve this by allowing you to ``weaken'' any
reference, that is, make it not count towards the reference count.
When the last non-weak reference to an object is deleted, the object
is destroyed and all the weak references to the object are
automatically undef-ed.</p>
<p>To use this feature, you need the Devel::WeakRef package from CPAN, which
contains additional documentation.</p>
<pre>
    NOTE: This is an experimental feature.  Details are subject to change.</pre>
<p>
</p>
<h2><a name="binary_numbers_supported">Binary numbers supported</a></h2>
<p>Binary numbers are now supported as literals, in s?printf formats, and
<code>oct()</code>:</p>
<pre>
    $answer = 0b101010;
    printf &quot;The answer is: %b\n&quot;, oct(&quot;0b101010&quot;);</pre>
<p>
</p>
<h2><a name="lvalue_subroutines">Lvalue subroutines</a></h2>
<p>Subroutines can now return modifiable lvalues.
See <a href="perlsub.html#lvalue_subroutines">Lvalue subroutines in the perlsub manpage</a>.</p>
<pre>
    NOTE: This is an experimental feature.  Details are subject to change.</pre>
<p>
</p>
<h2><a name="some_arrows_may_be_omitted_in_calls_through_references">Some arrows may be omitted in calls through references</a></h2>
<p>Perl now allows the arrow to be omitted in many constructs
involving subroutine calls through references.  For example,
<code>$foo[10]-&gt;('foo')</code> may now be written <code>$foo[10]('foo')</code>.
This is rather similar to how the arrow may be omitted from
<code>$foo[10]-&gt;{'foo'}</code>.  Note however, that the arrow is still
required for <code>foo(10)-&gt;('bar')</code>.</p>
<p>
</p>
<h2><a name="boolean_assignment_operators_are_legal_lvalues">Boolean assignment operators are legal lvalues</a></h2>
<p>Constructs such as <code>($a ||= 2) += 1</code> are now allowed.</p>
<p>
</p>
<h2><a name="exists___is_supported_on_subroutine_names"><code>exists()</code> is supported on subroutine names</a></h2>
<p>The <code>exists()</code> builtin now works on subroutine names.  A subroutine
is considered to exist if it has been declared (even if implicitly).
See <a href="perlfunc.html#exists">exists in the perlfunc manpage</a> for examples.</p>
<p>
</p>
<h2><a name="exists___and_delete___are_supported_on_array_elements"><code>exists()</code> and <a href="#item_delete"><code>delete()</code></a> are supported on array elements</a></h2>
<p>The <code>exists()</code> and <a href="#item_delete"><code>delete()</code></a> builtins now work on simple arrays as well.
The behavior is similar to that on hash elements.</p>
<p><code>exists()</code> can be used to check whether an array element has been
initialized.  This avoids autovivifying array elements that don't exist.
If the array is tied, the <code>EXISTS()</code> method in the corresponding tied
package will be invoked.</p>
<p><a href="#item_delete"><code>delete()</code></a> may be used to remove an element from the array and return
it.  The array element at that position returns to its uninitialized
state, so that testing for the same element with <code>exists()</code> will return
false.  If the element happens to be the one at the end, the size of
the array also shrinks up to the highest element that tests true for
exists(), or 0 if none such is found.  If the array is tied, the <code>DELETE()</code> 
method in the corresponding tied package will be invoked.</p>
<p>See <a href="perlfunc.html#exists">exists in the perlfunc manpage</a> and <a href="perlfunc.html#delete">delete in the perlfunc manpage</a> for examples.</p>
<p>
</p>
<h2><a name="pseudohashes_work_better">Pseudo-hashes work better</a></h2>
<p>Dereferencing some types of reference values in a pseudo-hash,
such as <code>$ph-&gt;{foo}[1]</code>, was accidentally disallowed.  This has
been corrected.</p>
<p>When applied to a pseudo-hash element, <code>exists()</code> now reports whether
the specified value exists, not merely if the key is valid.</p>
<p><a href="#item_delete"><code>delete()</code></a> now works on pseudo-hashes.  When given a pseudo-hash element
or slice it deletes the values corresponding to the keys (but not the keys
themselves).  See <a href="perlref.html#pseudohashes__using_an_array_as_a_hash">Pseudo-hashes: Using an array as a hash in the perlref manpage</a>.</p>
<p>Pseudo-hash slices with constant keys are now optimized to array lookups
at compile-time.</p>
<p>List assignments to pseudo-hash slices are now supported.</p>
<p>The <code>fields</code> pragma now provides ways to create pseudo-hashes, via
fields::new() and fields::phash().  See <a href="../../fields.html">the fields manpage</a>.</p>
<pre>
    NOTE: The pseudo-hash data type continues to be experimental.
    Limiting oneself to the interface elements provided by the
    fields pragma will provide protection from any future changes.</pre>
<p>
</p>
<h2><a name="automatic_flushing_of_output_buffers">Automatic flushing of output buffers</a></h2>
<p>fork(), exec(), system(), qx//, and pipe open()s now flush buffers
of all files opened for output when the operation was attempted.  This
mostly eliminates confusing buffering mishaps suffered by users unaware
of how Perl internally handles I/O.</p>
<p>This is not supported on some platforms like Solaris where a suitably
correct implementation of <code>fflush(NULL)</code> isn't available.</p>
<p>
</p>
<h2><a name="better_diagnostics_on_meaningless_filehandle_operations">Better diagnostics on meaningless filehandle operations</a></h2>
<p>Constructs such as <a href="#item_open"><code>open(&lt;FH&gt;)</code></a> and <code>close(&lt;FH&gt;)</code>
are compile time errors.  Attempting to read from filehandles that
were opened only for writing will now produce warnings (just as
writing to read-only filehandles does).</p>
<p>
</p>
<h2><a name="where_possible__buffered_data_discarded_from_duped_input_filehandle">Where possible, buffered data discarded from duped input filehandle</a></h2>
<p><a href="#item_open"><code>open(NEW, &quot;&lt;&amp;OLD&quot;)</code></a> now attempts to discard any data that
was previously read and buffered in <code>OLD</code> before duping the handle.
On platforms where doing this is allowed, the next read operation
on <code>NEW</code> will return the same data as the corresponding operation
on <code>OLD</code>.  Formerly, it would have returned the data from the start
of the following disk block instead.</p>
<p>
</p>
<h2><a name="eof___has_the_same_old_magic_as___"><code>eof()</code> has the same old magic as &lt;&gt;</a></h2>
<p><code>eof()</code> would return true if no attempt to read from <code>&lt;&gt;</code> had
yet been made.  <code>eof()</code> has been changed to have a little magic of its
own, it now opens the <code>&lt;&gt;</code> files.</p>
<p>
</p>
<h2><a name="binmode___can_be_used_to_set__crlf_and__raw_modes"><code>binmode()</code> can be used to set :crlf and :raw modes</a></h2>
<p><code>binmode()</code> now accepts a second argument that specifies a discipline
for the handle in question.  The two pseudo-disciplines ``:raw'' and
``:crlf'' are currently supported on DOS-derivative platforms.
See <a href="perlfunc.html#binmode">binmode in the perlfunc manpage</a> and <a href="../../open.html">the open manpage</a>.</p>
<p>
</p>
<h2><a name="t_filetest_recognizes_utf8_encoded_files_as_text"><code>-T</code> filetest recognizes UTF-8 encoded files as ``text''</a></h2>
<p>The algorithm used for the <code>-T</code> filetest has been enhanced to
correctly identify UTF-8 content as ``text''.</p>
<p>
</p>
<h2><a name="system____backticks_and_pipe_open_now_reflect_exec___failure">system(), backticks and pipe open now reflect <code>exec()</code> failure</a></h2>
<p>On Unix and similar platforms, system(), <code>qx()</code> and open(FOO, ``cmd |'')
etc., are implemented via <code>fork()</code> and exec().  When the underlying
<code>exec()</code> fails, earlier versions did not report the error properly,
since the <code>exec()</code> happened to be in a different process.</p>
<p>The child process now communicates with the parent about the
error in launching the external command, which allows these
constructs to return with their usual error value and set $!.</p>
<p>
</p>
<h2><a name="improved_diagnostics">Improved diagnostics</a></h2>
<p>Line numbers are no longer suppressed (under most likely circumstances)
during the global destruction phase.</p>
<p>Diagnostics emitted from code running in threads other than the main
thread are now accompanied by the thread ID.</p>
<p>Embedded null characters in diagnostics now actually show up.  They
used to truncate the message in prior versions.</p>
<p>$foo::a and $foo::b are now exempt from ``possible typo'' warnings only
if <code>sort()</code> is encountered in package <code>foo</code>.</p>
<p>Unrecognized alphabetic escapes encountered when parsing quote
constructs now generate a warning, since they may take on new
semantics in later versions of Perl.</p>
<p>Many diagnostics now report the internal operation in which the warning
was provoked, like so:</p>
<pre>
    Use of uninitialized value in concatenation (.) at (eval 1) line 1.
    Use of uninitialized value in print at (eval 1) line 1.</pre>
<p>Diagnostics  that occur within eval may also report the file and line
number where the eval is located, in addition to the eval sequence
number and the line number within the evaluated text itself.  For
example:</p>
<pre>
    Not enough arguments for scalar at (eval 4)[newlib/perl5db.pl:1411] line 2, at EOF</pre>
<p>
</p>
<h2><a name="diagnostics_follow_stderr">Diagnostics follow STDERR</a></h2>
<p>Diagnostic output now goes to whichever file the <code>STDERR</code> handle
is pointing at, instead of always going to the underlying C runtime
library's <code>stderr</code>.</p>
<p>
</p>
<h2><a name="more_consistent_closeonexec_behavior">More consistent close-on-exec behavior</a></h2>
<p>On systems that support a close-on-exec flag on filehandles, the
flag is now set for any handles created by pipe(), socketpair(),
socket(), and accept(), if that is warranted by the value of $^F
that may be in effect.  Earlier versions neglected to set the flag
for handles created with these operators.  See <a href="perlfunc.html#pipe">pipe in the perlfunc manpage</a>,
<a href="perlfunc.html#socketpair">socketpair in the perlfunc manpage</a>, <a href="perlfunc.html#socket">socket in the perlfunc manpage</a>, <a href="perlfunc.html#accept">accept in the perlfunc manpage</a>,
and <a href="perlvar.html#__f">$^F in the perlvar manpage</a>.</p>
<p>
</p>
<h2><a name="syswrite___easeofuse"><code>syswrite()</code> ease-of-use</a></h2>
<p>The length argument of <code>syswrite()</code> has become optional.</p>
<p>
</p>
<h2><a name="better_syntax_checks_on_parenthesized_unary_operators">Better syntax checks on parenthesized unary operators</a></h2>
<p>Expressions such as:</p>
<pre>
    print defined(&amp;foo,&amp;bar,&amp;baz);
    print uc(&quot;foo&quot;,&quot;bar&quot;,&quot;baz&quot;);
    undef($foo,&amp;bar);</pre>
<p>used to be accidentally allowed in earlier versions, and produced
unpredictable behaviour.  Some produced ancillary warnings
when used in this way; others silently did the wrong thing.</p>
<p>The parenthesized forms of most unary operators that expect a single
argument now ensure that they are not called with more than one
argument, making the cases shown above syntax errors.  The usual
behaviour of:</p>
<pre>
    print defined &amp;foo, &amp;bar, &amp;baz;
    print uc &quot;foo&quot;, &quot;bar&quot;, &quot;baz&quot;;
    undef $foo, &amp;bar;</pre>
<p>remains unchanged.  See <a href="perlop.html">the perlop manpage</a>.</p>
<p>
</p>
<h2><a name="bit_operators_support_full_native_integer_width">Bit operators support full native integer width</a></h2>
<p>The bit operators (&amp; | ^ ~ &lt;&lt; &gt;&gt;) now operate on the full native
integral width (the exact size of which is available in $Config{ivsize}).
For example, if your platform is either natively 64-bit or if Perl
has been configured to use 64-bit integers, these operations apply
to 8 bytes (as opposed to 4 bytes on 32-bit platforms).
For portability, be sure to mask off the excess bits in the result of
unary <code>~</code>, e.g., <code>~$x &amp; 0xffffffff</code>.</p>
<p>
</p>
<h2><a name="improved_security_features">Improved security features</a></h2>
<p>More potentially unsafe operations taint their results for improved
security.</p>
<p>The <code>passwd</code> and <code>shell</code> fields returned by the getpwent(), getpwnam(),
and <code>getpwuid()</code> are now tainted, because the user can affect their own
encrypted password and login shell.</p>
<p>The variable modified by shmread(), and messages returned by <code>msgrcv()</code>
(and its object-oriented interface IPC::SysV::Msg::rcv) are also tainted,
because other untrusted processes can modify messages and shared memory
segments for their own nefarious purposes.</p>
<p>
</p>
<h2><a name="more_functional_bareword_prototype____">More functional bareword prototype (*)</a></h2>
<p>Bareword prototypes have been rationalized to enable them to be used
to override builtins that accept barewords and interpret them in
a special way, such as <code>require</code> or <code>do</code>.</p>
<p>Arguments prototyped as <code>*</code> will now be visible within the subroutine
as either a simple scalar or as a reference to a typeglob.
See <a href="perlsub.html#prototypes">Prototypes in the perlsub manpage</a>.</p>
<p>
</p>
<h2><a name="require_and_do_may_be_overridden"><code>require</code> and <code>do</code> may be overridden</a></h2>
<p><code>require</code> and <code>do 'file'</code> operations may be overridden locally
by importing subroutines of the same name into the current package 
(or globally by importing them into the CORE::GLOBAL:: namespace).
Overriding <code>require</code> will also affect <code>use</code>, provided the override
is visible at compile-time.
See <a href="perlsub.html#overriding_builtin_functions">Overriding Built-in Functions in the perlsub manpage</a>.</p>
<p>
</p>
<h2><a name="__x_variables_may_now_have_names_longer_than_one_character">$^X variables may now have names longer than one character</a></h2>
<p>Formerly, $^X was synonymous with ${``\cX''}, but $^XY was a syntax
error.  Now variable names that begin with a control character may be
arbitrarily long.  However, for compatibility reasons, these variables
<em>must</em> be written with explicit braces, as <code>${^XY}</code> for example.
<code>${^XYZ}</code> is synonymous with ${``\cXYZ''}.  Variable names with more
than one control character, such as <code>${^XY^Z}</code>, are illegal.</p>
<p>The old syntax has not changed.  As before, `^X' may be either a
literal control-X character or the two-character sequence `caret' plus
`X'.  When braces are omitted, the variable name stops after the
control character.  Thus <code>&quot;$^XYZ&quot;</code> continues to be synonymous with
<code>$^X . &quot;YZ&quot;</code> as before.</p>
<p>As before, lexical variables may not have names beginning with control
characters.  As before, variables whose names begin with a control
character are always forced to be in package `main'.  All such variables
are reserved for future extensions, except those that begin with
<code>^_</code>, which may be used by user programs and are guaranteed not to
acquire special meaning in any future version of Perl.</p>
<p>
</p>
<h2><a name="new_variable___c_reflects_c_switch">New variable $^C reflects <code>-c</code> switch</a></h2>
<p><code>$^C</code> has a boolean value that reflects whether perl is being run
in compile-only mode (i.e. via the <code>-c</code> switch).  Since
BEGIN blocks are executed under such conditions, this variable
enables perl code to determine whether actions that make sense
only during normal running are warranted.  See <a href="perlvar.html">the perlvar manpage</a>.</p>
<p>
</p>
<h2><a name="new_variable___v_contains_perl_version_as_a_string">New variable $^V contains Perl version as a string</a></h2>
<p><code>$^V</code> contains the Perl version number as a string composed of
characters whose ordinals match the version numbers, i.e. v5.6.0.
This may be used in string comparisons.</p>
<p>See <code>Support for strings represented as a vector of ordinals</code> for an
example.</p>
<p>
</p>
<h2><a name="optional_y2k_warnings">Optional Y2K warnings</a></h2>
<p>If Perl is built with the cpp macro <code>PERL_Y2KWARN</code> defined,
it emits optional warnings when concatenating the number 19
with another number.</p>
<p>This behavior must be specifically enabled when running Configure.
See <em>INSTALL</em> and <em>README.Y2K</em>.</p>
<p>
</p>
<h2><a name="arrays_now_always_interpolate_into_doublequoted_strings">Arrays now always interpolate into double-quoted strings</a></h2>
<p>In double-quoted strings, arrays now interpolate, no matter what.  The
behavior in earlier versions of perl 5 was that arrays would interpolate
into strings if the array had been mentioned before the string was
compiled, and otherwise Perl would raise a fatal compile-time error.
In versions 5.000 through 5.003, the error was</p>
<pre>
        Literal @example now requires backslash</pre>
<p>In versions 5.004_01 through 5.6.0, the error was</p>
<pre>
        In string, @example now must be written as \@example</pre>
<p>The idea here was to get people into the habit of writing
<code>&quot;fred\@example.com&quot;</code> when they wanted a literal <code>@</code> sign, just as
they have always written <code>&quot;Give me back my \$5&quot;</code> when they wanted a
literal <code>$</code> sign.</p>
<p>Starting with 5.6.1, when Perl now sees an <code>@</code> sign in a
double-quoted string, it <em>always</em> attempts to interpolate an array,
regardless of whether or not the array has been used or declared
already.  The fatal error has been downgraded to an optional warning:</p>
<pre>
        Possible unintended interpolation of @example in string</pre>
<p>This warns you that <code>&quot;fred@example.com&quot;</code> is going to turn into
<code>fred.com</code> if you don't backslash the <code>@</code>.
See <a href="http://www.plover.com/~mjd/perl/at-error.html">http://www.plover.com/~mjd/perl/at-error.html</a> for more details
about the history here.</p>
<p>
</p>
<h2><a name="__and____provide_starting_ending_offsets_of_regex_matches">@- and @+ provide starting/ending offsets of regex matches</a></h2>
<p>The new magic variables @- and @+ provide the starting and ending
offsets, respectively, of $&amp;, $1, $2, etc.  See <a href="perlvar.html">the perlvar manpage</a> for
details.</p>
<p>
</p>
<hr />
<h1><a name="modules_and_pragmata">Modules and Pragmata</a></h1>
<p>
</p>
<h2><a name="modules">Modules</a></h2>
<dl>
<dt><strong><a name="item_attributes">attributes</a></strong>

<dd>
<p>While used internally by Perl as a pragma, this module also
provides a way to fetch subroutine and variable attributes.
See <a href="../../attributes.html">the attributes manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_b">B</a></strong>

<dd>
<p>The Perl Compiler suite has been extensively reworked for this
release.  More of the standard Perl testsuite passes when run
under the Compiler, but there is still a significant way to
go to achieve production quality compiled executables.</p>
</dd>
<dd>
<pre>
    NOTE: The Compiler suite remains highly experimental.  The
    generated code may not be correct, even when it manages to execute
    without errors.</pre>
</dd>
</li>
<dt><strong><a name="item_benchmark">Benchmark</a></strong>

<dd>
<p>Overall, Benchmark results exhibit lower average error and better timing
accuracy.</p>
</dd>
<dd>
<p>You can now run tests for <em>n</em> seconds instead of guessing the right
number of tests to run: e.g., timethese(-5, ...) will run each 
code for at least 5 CPU seconds.  Zero as the ``number of repetitions''
means ``for at least 3 CPU seconds''.  The output format has also
changed.  For example:</p>
</dd>
<dd>
<pre>
   use Benchmark;$x=3;timethese(-5,{a=&gt;sub{$x*$x},b=&gt;sub{$x**2}})</pre>
</dd>
<dd>
<p>will now output something like this:</p>
</dd>
<dd>
<pre>
   Benchmark: running a, b, each for at least 5 CPU seconds...
            a:  5 wallclock secs ( 5.77 usr +  0.00 sys =  5.77 CPU) @ 200551.91/s (n=1156516)
            b:  4 wallclock secs ( 5.00 usr +  0.02 sys =  5.02 CPU) @ 159605.18/s (n=800686)</pre>
</dd>
<dd>
<p>New features: ``each for at least N CPU seconds...'', ``wallclock secs'',
and the ``@ operations/CPU second (n=operations)''.</p>
</dd>
<dd>
<p><code>timethese()</code> now returns a reference to a hash of Benchmark objects containing
the test results, keyed on the names of the tests.</p>
</dd>
<dd>
<p><code>timethis()</code> now returns the iterations field in the Benchmark result object
instead of 0.</p>
</dd>
<dd>
<p>timethese(), timethis(), and the new <code>cmpthese()</code> (see below) can also take
a format specifier of 'none' to suppress output.</p>
</dd>
<dd>
<p>A new function <code>countit()</code> is just like <code>timeit()</code> except that it takes a
TIME instead of a COUNT.</p>
</dd>
<dd>
<p>A new function <code>cmpthese()</code> prints a chart comparing the results of each test
returned from a <code>timethese()</code> call.  For each possible pair of tests, the
percentage speed difference (iters/sec or seconds/iter) is shown.</p>
</dd>
<dd>
<p>For other details, see <a href="../../Benchmark.html">the Benchmark manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_byteloader">ByteLoader</a></strong>

<dd>
<p>The ByteLoader is a dedicated extension to generate and run
Perl bytecode.  See <a href="../../ByteLoader.html">the ByteLoader manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_constant">constant</a></strong>

<dd>
<p>References can now be used.</p>
</dd>
<dd>
<p>The new version also allows a leading underscore in constant names, but
disallows a double leading underscore (as in ``__LINE__'').  Some other names
are disallowed or warned against, including BEGIN, END, etc.  Some names
which were forced into main:: used to fail silently in some cases; now they're
fatal (outside of main::) and an optional warning (inside of main::).
The ability to detect whether a constant had been set with a given name has
been added.</p>
</dd>
<dd>
<p>See <a href="../../constant.html">the constant manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_charnames">charnames</a></strong>

<dd>
<p>This pragma implements the <code>\N</code> string escape.  See <a href="../../charnames.html">the charnames manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_data_3a_3adumper">Data::Dumper</a></strong>

<dd>
<p>A <code>Maxdepth</code> setting can be specified to avoid venturing
too deeply into deep data structures.  See <a href="../../Data/Dumper.html">the Data::Dumper manpage</a>.</p>
</dd>
<dd>
<p>The XSUB implementation of <code>Dump()</code> is now automatically called if the
<code>Useqq</code> setting is not in use.</p>
</dd>
<dd>
<p>Dumping <code>qr//</code> objects works correctly.</p>
</dd>
</li>
<dt><strong><a name="item_db">DB</a></strong>

<dd>
<p><a href="#item_db"><code>DB</code></a> is an experimental module that exposes a clean abstraction
to Perl's debugging API.</p>
</dd>
</li>
<dt><strong><a name="item_db_file">DB_File</a></strong>

<dd>
<p>DB_File can now be built with Berkeley DB versions 1, 2 or 3.
See <code>ext/DB_File/Changes</code>.</p>
</dd>
</li>
<dt><strong><a name="item_devel_3a_3adprof">Devel::DProf</a></strong>

<dd>
<p>Devel::DProf, a Perl source code profiler has been added.  See
<a href="../../Devel/DProf.html">the Devel::DProf manpage</a> and <a href="#dprofpp">the dprofpp manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_devel_3a_3apeek">Devel::Peek</a></strong>

<dd>
<p>The Devel::Peek module provides access to the internal representation
of Perl variables and data.  It is a data debugging tool for the XS programmer.</p>
</dd>
</li>
<dt><strong><a name="item_dumpvalue">Dumpvalue</a></strong>

<dd>
<p>The Dumpvalue module provides screen dumps of Perl data.</p>
</dd>
</li>
<dt><strong><a name="item_dynaloader">DynaLoader</a></strong>

<dd>
<p>DynaLoader now supports a <code>dl_unload_file()</code> function on platforms that
support unloading shared objects using dlclose().</p>
</dd>
<dd>
<p>Perl can also optionally arrange to unload all extension shared objects
loaded by Perl.  To enable this, build Perl with the Configure option
<code>-Accflags=-DDL_UNLOAD_ALL_AT_EXIT</code>.  (This maybe useful if you are
using Apache with mod_perl.)</p>
</dd>
</li>
<dt><strong><a name="item_english">English</a></strong>

<dd>
<p>$PERL_VERSION now stands for <code>$^V</code> (a string value) rather than for <code>$]</code>
(a numeric value).</p>
</dd>
</li>
<dt><strong><a name="item_env">Env</a></strong>

<dd>
<p>Env now supports accessing environment variables like PATH as array
variables.</p>
</dd>
</li>
<dt><strong><a name="item_fcntl">Fcntl</a></strong>

<dd>
<p>More Fcntl constants added: F_SETLK64, F_SETLKW64, O_LARGEFILE for
large file (more than 4GB) access (NOTE: the O_LARGEFILE is
automatically added to <code>sysopen()</code> flags if large file support has been
configured, as is the default), Free/Net/OpenBSD locking behaviour
flags F_FLOCK, F_POSIX, Linux F_SHLCK, and O_ACCMODE: the combined
mask of O_RDONLY, O_WRONLY, and O_RDWR.  The <code>seek()/sysseek()</code>
constants SEEK_SET, SEEK_CUR, and SEEK_END are available via the
<code>:seek</code> tag.  The <code>chmod()/stat()</code> S_IF* constants and S_IS* functions
are available via the <code>:mode</code> tag.</p>
</dd>
</li>
<dt><strong><a name="item_file_3a_3acompare">File::Compare</a></strong>

<dd>
<p>A <code>compare_text()</code> function has been added, which allows custom
comparison functions.  See <a href="../../File/Compare.html">the File::Compare manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_file_3a_3afind">File::Find</a></strong>

<dd>
<p>File::Find now works correctly when the <code>wanted()</code> function is either
autoloaded or is a symbolic reference.</p>
</dd>
<dd>
<p>A bug that caused File::Find to lose track of the working directory
when pruning top-level directories has been fixed.</p>
</dd>
<dd>
<p>File::Find now also supports several other options to control its
behavior.  It can follow symbolic links if the <code>follow</code> option is
specified.  Enabling the <code>no_chdir</code> option will make File::Find skip
changing the current directory when walking directories.  The <code>untaint</code>
flag can be useful when running with taint checks enabled.</p>
</dd>
<dd>
<p>See <a href="../../File/Find.html">the File::Find manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_file_3a_3aglob">File::Glob</a></strong>

<dd>
<p>This extension implements BSD-style file globbing.  By default,
it will also be used for the internal implementation of the <code>glob()</code>
operator.  See <a href="../../File/Glob.html">the File::Glob manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_file_3a_3aspec">File::Spec</a></strong>

<dd>
<p>New methods have been added to the File::Spec module: <code>devnull()</code> returns
the name of the null device (/dev/null on Unix) and <code>tmpdir()</code> the name of
the temp directory (normally /tmp on Unix).  There are now also methods
to convert between absolute and relative filenames: <code>abs2rel()</code> and
rel2abs().  For compatibility with operating systems that specify volume
names in file paths, the splitpath(), splitdir(), and <code>catdir()</code> methods
have been added.</p>
</dd>
</li>
<dt><strong><a name="item_file_3a_3aspec_3a_3afunctions">File::Spec::Functions</a></strong>

<dd>
<p>The new File::Spec::Functions modules provides a function interface
to the File::Spec module.  Allows shorthand</p>
</dd>
<dd>
<pre>
    $fullname = catfile($dir1, $dir2, $file);</pre>
</dd>
<dd>
<p>instead of</p>
</dd>
<dd>
<pre>
    $fullname = File::Spec-&gt;catfile($dir1, $dir2, $file);</pre>
</dd>
</li>
<dt><strong><a name="item_getopt_3a_3along">Getopt::Long</a></strong>

<dd>
<p>Getopt::Long licensing has changed to allow the Perl Artistic License
as well as the GPL. It used to be GPL only, which got in the way of
non-GPL applications that wanted to use Getopt::Long.</p>
</dd>
<dd>
<p>Getopt::Long encourages the use of Pod::Usage to produce help
messages. For example:</p>
</dd>
<dd>
<pre>
    use Getopt::Long;
    use Pod::Usage;
    my $man = 0;
    my $help = 0;
    GetOptions('help|?' =&gt; \$help, man =&gt; \$man) or pod2usage(2);
    pod2usage(1) if $help;
    pod2usage(-exitstatus =&gt; 0, -verbose =&gt; 2) if $man;</pre>
</dd>
<dd>
<pre>
    __END__</pre>
</dd>
<dd>
<pre>
    =head1 NAME</pre>
</dd>
<dd>
<pre>
    sample - Using Getopt::Long and Pod::Usage</pre>
</dd>
<dd>
<pre>
    =head1 SYNOPSIS</pre>
</dd>
<dd>
<pre>
    sample [options] [file ...]</pre>
</dd>
<dd>
<pre>
     Options:
       -help            brief help message
       -man             full documentation</pre>
</dd>
<dd>
<pre>
    =head1 OPTIONS</pre>
</dd>
<dd>
<pre>
    =over 8</pre>
</dd>
<dd>
<pre>
    =item B&lt;-help&gt;</pre>
</dd>
<dd>
<pre>
    Print a brief help message and exits.</pre>
</dd>
<dd>
<pre>
    =item B&lt;-man&gt;</pre>
</dd>
<dd>
<pre>
    Prints the manual page and exits.</pre>
</dd>
<dd>
<pre>
    =back</pre>
</dd>
<dd>
<pre>
    =head1 DESCRIPTION</pre>
</dd>
<dd>
<pre>
    B&lt;This program&gt; will read the given input file(s) and do something
    useful with the contents thereof.</pre>
</dd>
<dd>
<pre>
    =cut</pre>
</dd>
<dd>
<p>See <a href="../../Pod/Usage.html">the Pod::Usage manpage</a> for details.</p>
</dd>
<dd>
<p>A bug that prevented the non-option call-back &lt;&gt; from being
specified as the first argument has been fixed.</p>
</dd>
<dd>
<p>To specify the characters &lt; and &gt; as option starters, use &gt;&lt;. Note,
however, that changing option starters is strongly deprecated.</p>
</dd>
</li>
<dt><strong><a name="item_io">IO</a></strong>

<dd>
<p><code>write()</code> and <code>syswrite()</code> will now accept a single-argument
form of the call, for consistency with Perl's syswrite().</p>
</dd>
<dd>
<p>You can now create a TCP-based IO::Socket::INET without forcing
a connect attempt.  This allows you to configure its options
(like making it non-blocking) and then call <code>connect()</code> manually.</p>
</dd>
<dd>
<p>A bug that prevented the IO::Socket::protocol() accessor
from ever returning the correct value has been corrected.</p>
</dd>
<dd>
<p>IO::Socket::connect now uses non-blocking IO instead of <code>alarm()</code>
to do connect timeouts.</p>
</dd>
<dd>
<p>IO::Socket::accept now uses <code>select()</code> instead of <code>alarm()</code> for doing
timeouts.</p>
</dd>
<dd>
<p>IO::Socket::INET-&gt;new now sets $! correctly on failure. $@ is
still set for backwards compatibility.</p>
</dd>
</li>
<dt><strong><a name="item_jpl">JPL</a></strong>

<dd>
<p>Java Perl Lingo is now distributed with Perl.  See jpl/README
for more information.</p>
</dd>
</li>
<dt><strong><a name="item_lib">lib</a></strong>

<dd>
<p><code>use lib</code> now weeds out any trailing duplicate entries.
<code>no lib</code> removes all named entries.</p>
</dd>
</li>
<dt><strong><a name="item_math_3a_3abigint">Math::BigInt</a></strong>

<dd>
<p>The bitwise operations <code>&lt;&lt;</code>, <code>&gt;&gt;</code>, <code>&amp;</code>, <code>|</code>,
and <code>~</code> are now supported on bigints.</p>
</dd>
</li>
<dt><strong><a name="item_math_3a_3acomplex">Math::Complex</a></strong>

<dd>
<p>The accessor methods Re, Im, arg, abs, rho, and theta can now also
act as mutators (accessor $z-&gt;Re(), mutator $z-&gt;Re(3)).</p>
</dd>
<dd>
<p>The class method <code>display_format</code> and the corresponding object method
<code>display_format</code>, in addition to accepting just one argument, now can
also accept a parameter hash.  Recognized keys of a parameter hash are
<code>&quot;style&quot;</code>, which corresponds to the old one parameter case, and two
new parameters: <code>&quot;format&quot;</code>, which is a printf()-style format string
(defaults usually to <code>&quot;%.15g&quot;</code>, you can revert to the default by
setting the format string to <code>undef</code>) used for both parts of a
complex number, and <code>&quot;polar_pretty_print&quot;</code> (defaults to true),
which controls whether an attempt is made to try to recognize small
multiples and rationals of pi (2pi, pi/2) at the argument (angle) of a
polar complex number.</p>
</dd>
<dd>
<p>The potentially disruptive change is that in list context both methods
now <em>return the parameter hash</em>, instead of only the value of the
<code>&quot;style&quot;</code> parameter.</p>
</dd>
</li>
<dt><strong><a name="item_math_3a_3atrig">Math::Trig</a></strong>

<dd>
<p>A little bit of radial trigonometry (cylindrical and spherical),
radial coordinate conversions, and the great circle distance were added.</p>
</dd>
</li>
<dt><strong><a name="item_pod_3a_3aparser_2c_pod_3a_3ainputobjects">Pod::Parser, Pod::InputObjects</a></strong>

<dd>
<p>Pod::Parser is a base class for parsing and selecting sections of
pod documentation from an input stream.  This module takes care of
identifying pod paragraphs and commands in the input and hands off the
parsed paragraphs and commands to user-defined methods which are free
to interpret or translate them as they see fit.</p>
</dd>
<dd>
<p>Pod::InputObjects defines some input objects needed by Pod::Parser, and
for advanced users of Pod::Parser that need more about a command besides
its name and text.</p>
</dd>
<dd>
<p>As of release 5.6.0 of Perl, Pod::Parser is now the officially sanctioned
``base parser code'' recommended for use by all pod2xxx translators.
Pod::Text (pod2text) and Pod::Man (pod2man) have already been converted
to use Pod::Parser and efforts to convert Pod::HTML (pod2html) are already
underway.  For any questions or comments about pod parsing and translating
issues and utilities, please use the <a href="mailto:pod-people@perl.org">pod-people@perl.org</a> mailing list.</p>
</dd>
<dd>
<p>For further information, please see <a href="../../Pod/Parser.html">the Pod::Parser manpage</a> and <a href="../../Pod/InputObjects.html">the Pod::InputObjects manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_pod_3a_3achecker_2c_podchecker">Pod::Checker, podchecker</a></strong>

<dd>
<p>This utility checks pod files for correct syntax, according to
<a href="perlpod.html">the perlpod manpage</a>.  Obvious errors are flagged as such, while warnings are
printed for mistakes that can be handled gracefully.  The checklist is
not complete yet.  See <a href="../../Pod/Checker.html">the Pod::Checker manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_pod_3a_3aparseutils_2c_pod_3a_3afind">Pod::ParseUtils, Pod::Find</a></strong>

<dd>
<p>These modules provide a set of gizmos that are useful mainly for pod
translators.  <a href="../../Pod/Find.html">Pod::Find</a> traverses directory structures and
returns found pod files, along with their canonical names (like
<code>File::Spec::Unix</code>).  <a href="../../Pod/ParseUtils.html">Pod::ParseUtils</a> contains
<strong>Pod::List</strong> (useful for storing pod list information), <strong>Pod::Hyperlink</strong>
(for parsing the contents of <code>L&lt;&gt;</code> sequences) and <strong>Pod::Cache</strong>
(for caching information about pod files, e.g., link nodes).</p>
</dd>
</li>
<dt><strong><a name="item_pod_3a_3aselect_2c_podselect">Pod::Select, podselect</a></strong>

<dd>
<p>Pod::Select is a subclass of Pod::Parser which provides a function
named ``podselect()'' to filter out user-specified sections of raw pod
documentation from an input stream. podselect is a script that provides
access to Pod::Select from other scripts to be used as a filter.
See <a href="../../Pod/Select.html">the Pod::Select manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_pod_3a_3ausage_2c_pod2usage">Pod::Usage, pod2usage</a></strong>

<dd>
<p>Pod::Usage provides the function ``pod2usage()'' to print usage messages for
a Perl script based on its embedded pod documentation.  The <code>pod2usage()</code>
function is generally useful to all script authors since it lets them
write and maintain a single source (the pods) for documentation, thus
removing the need to create and maintain redundant usage message text
consisting of information already in the pods.</p>
</dd>
<dd>
<p>There is also a pod2usage script which can be used from other kinds of
scripts to print usage messages from pods (even for non-Perl scripts
with pods embedded in comments).</p>
</dd>
<dd>
<p>For details and examples, please see <a href="../../Pod/Usage.html">the Pod::Usage manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_pod_3a_3atext_and_pod_3a_3aman">Pod::Text and Pod::Man</a></strong>

<dd>
<p>Pod::Text has been rewritten to use Pod::Parser.  While <code>pod2text()</code> is
still available for backwards compatibility, the module now has a new
preferred interface.  See <a href="../../Pod/Text.html">the Pod::Text manpage</a> for the details.  The new Pod::Text
module is easily subclassed for tweaks to the output, and two such
subclasses (Pod::Text::Termcap for man-page-style bold and underlining
using termcap information, and Pod::Text::Color for markup with ANSI color
sequences) are now standard.</p>
</dd>
<dd>
<p>pod2man has been turned into a module, Pod::Man, which also uses
Pod::Parser.  In the process, several outstanding bugs related to quotes
in section headers, quoting of code escapes, and nested lists have been
fixed.  pod2man is now a wrapper script around this module.</p>
</dd>
</li>
<dt><strong><a name="item_sdbm_file">SDBM_File</a></strong>

<dd>
<p>An EXISTS method has been added to this module (and <code>sdbm_exists()</code> has
been added to the underlying sdbm library), so one can now call exists
on an SDBM_File tied hash and get the correct result, rather than a
runtime error.</p>
</dd>
<dd>
<p>A bug that may have caused data loss when more than one disk block
happens to be read from the database in a single <code>FETCH()</code> has been
fixed.</p>
</dd>
</li>
<dt><strong><a name="item_sys_3a_3asyslog">Sys::Syslog</a></strong>

<dd>
<p>Sys::Syslog now uses XSUBs to access facilities from syslog.h so it
no longer requires syslog.ph to exist.</p>
</dd>
</li>
<dt><strong><a name="item_sys_3a_3ahostname">Sys::Hostname</a></strong>

<dd>
<p>Sys::Hostname now uses XSUBs to call the C library's <code>gethostname()</code> or
<code>uname()</code> if they exist.</p>
</dd>
</li>
<dt><strong><a name="item_term_3a_3aansicolor">Term::ANSIColor</a></strong>

<dd>
<p>Term::ANSIColor is a very simple module to provide easy and readable
access to the ANSI color and highlighting escape sequences, supported by
most ANSI terminal emulators.  It is now included standard.</p>
</dd>
</li>
<dt><strong><a name="item_time_3a_3alocal">Time::Local</a></strong>

<dd>
<p>The <code>timelocal()</code> and <code>timegm()</code> functions used to silently return bogus
results when the date fell outside the machine's integer range.  They
now consistently <code>croak()</code> if the date falls in an unsupported range.</p>
</dd>
</li>
<dt><strong><a name="item_win32">Win32</a></strong>

<dd>
<p>The error return value in list context has been changed for all functions
that return a list of values.  Previously these functions returned a list
with a single element <code>undef</code> if an error occurred.  Now these functions
return the empty list in these situations.  This applies to the following
functions:</p>
</dd>
<dd>
<pre>
    Win32::FsType
    Win32::GetOSVersion</pre>
</dd>
<dd>
<p>The remaining functions are unchanged and continue to return <code>undef</code> on
error even in list context.</p>
</dd>
<dd>
<p>The Win32::SetLastError(ERROR) function has been added as a complement
to the Win32::GetLastError() function.</p>
</dd>
<dd>
<p>The new Win32::GetFullPathName(FILENAME) returns the full absolute
pathname for FILENAME in scalar context.  In list context it returns
a two-element list containing the fully qualified directory name and
the filename.  See <a href="../../File/Spec/Win32.html">the Win32 manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_xsloader">XSLoader</a></strong>

<dd>
<p>The XSLoader extension is a simpler alternative to DynaLoader.
See <a href="../../XSLoader.html">the XSLoader manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_dbm_filters">DBM Filters</a></strong>

<dd>
<p>A new feature called ``DBM Filters'' has been added to all the
DBM modules--DB_File, GDBM_File, NDBM_File, ODBM_File, and SDBM_File.
DBM Filters add four new methods to each DBM module:</p>
</dd>
<dd>
<pre>
    filter_store_key
    filter_store_value
    filter_fetch_key
    filter_fetch_value</pre>
</dd>
<dd>
<p>These can be used to filter key-value pairs before the pairs are
written to the database or just after they are read from the database.
See <a href="perldbmfilter.html">the perldbmfilter manpage</a> for further information.</p>
</dd>
</li>
</dl>
<p>
</p>
<h2><a name="pragmata">Pragmata</a></h2>
<p><code>use attrs</code> is now obsolete, and is only provided for
backward-compatibility.  It's been replaced by the <code>sub : attributes</code>
syntax.  See <a href="perlsub.html#subroutine_attributes">Subroutine Attributes in the perlsub manpage</a> and <a href="../../attributes.html">the attributes manpage</a>.</p>
<p>Lexical warnings pragma, <code>use warnings;</code>, to control optional warnings.
See <a href="perllexwarn.html">the perllexwarn manpage</a>.</p>
<p><code>use filetest</code> to control the behaviour of filetests (<code>-r</code> <code>-w</code>
...).  Currently only one subpragma implemented, ``use filetest
'access';'', that uses <code>access(2)</code> or equivalent to check permissions
instead of using <code>stat(2)</code> as usual.  This matters in filesystems
where there are ACLs (access control lists): the <code>stat(2)</code> might lie,
but <code>access(2)</code> knows better.</p>
<p>The <a href="#item_open"><code>open</code></a> pragma can be used to specify default disciplines for
handle constructors (e.g. <a href="#item_open"><code>open())</code></a> and for qx//.  The two
pseudo-disciplines <code>:raw</code> and <code>:crlf</code> are currently supported on
DOS-derivative platforms (i.e. where binmode is not a no-op).
See also <a href="#binmode___can_be_used_to_set__crlf_and__raw_modes">binmode() can be used to set :crlf and :raw modes</a>.</p>
<p>
</p>
<hr />
<h1><a name="utility_changes">Utility Changes</a></h1>
<p>
</p>
<h2><a name="dprofpp">dprofpp</a></h2>
<p><code>dprofpp</code> is used to display profile data generated using <a href="#item_devel_3a_3adprof"><code>Devel::DProf</code></a>.
See <a href="#dprofpp">the dprofpp manpage</a>.</p>
<p>
</p>
<h2><a name="find2perl">find2perl</a></h2>
<p>The <code>find2perl</code> utility now uses the enhanced features of the File::Find
module.  The -depth and -follow options are supported.  Pod documentation
is also included in the script.</p>
<p>
</p>
<h2><a name="h2xs">h2xs</a></h2>
<p>The <code>h2xs</code> tool can now work in conjunction with <code>C::Scan</code> (available
from CPAN) to automatically parse real-life header files.  The <code>-M</code>,
<code>-a</code>, <code>-k</code>, and <code>-o</code> options are new.</p>
<p>
</p>
<h2><a name="perlcc">perlcc</a></h2>
<p><code>perlcc</code> now supports the C and Bytecode backends.  By default,
it generates output from the simple C backend rather than the
optimized C backend.</p>
<p>Support for non-Unix platforms has been improved.</p>
<p>
</p>
<h2><a name="perldoc">perldoc</a></h2>
<p><code>perldoc</code> has been reworked to avoid possible security holes.
It will not by default let itself be run as the superuser, but you
may still use the <strong>-U</strong> switch to try to make it drop privileges
first.</p>
<p>
</p>
<h2><a name="the_perl_debugger">The Perl Debugger</a></h2>
<p>Many bug fixes and enhancements were added to <em>perl5db.pl</em>, the
Perl debugger.  The help documentation was rearranged.  New commands
include <code>&lt; ?</code>, <code>&gt; ?</code>, and <code>{ ?</code> to list out current
actions, <code>man docpage</code> to run your doc viewer on some perl
docset, and support for quoted options.  The help information was
rearranged, and should be viewable once again if you're using <strong>less</strong>
as your pager.  A serious security hole was plugged--you should
immediately remove all older versions of the Perl debugger as
installed in previous releases, all the way back to perl3, from
your system to avoid being bitten by this.</p>
<p>
</p>
<hr />
<h1><a name="improved_documentation">Improved Documentation</a></h1>
<p>Many of the platform-specific README files are now part of the perl
installation.  See <a href="perl.html">the perl manpage</a> for the complete list.</p>
<dl>
<dt><strong><a name="item_perlapi_2epod">perlapi.pod</a></strong>

<dd>
<p>The official list of public Perl API functions.</p>
</dd>
</li>
<dt><strong><a name="item_perlboot_2epod">perlboot.pod</a></strong>

<dd>
<p>A tutorial for beginners on object-oriented Perl.</p>
</dd>
</li>
<dt><strong><a name="item_perlcompile_2epod">perlcompile.pod</a></strong>

<dd>
<p>An introduction to using the Perl Compiler suite.</p>
</dd>
</li>
<dt><strong><a name="item_perldbmfilter_2epod">perldbmfilter.pod</a></strong>

<dd>
<p>A howto document on using the DBM filter facility.</p>
</dd>
</li>
<dt><strong><a name="item_perldebug_2epod">perldebug.pod</a></strong>

<dd>
<p>All material unrelated to running the Perl debugger, plus all
low-level guts-like details that risked crushing the casual user
of the debugger, have been relocated from the old manpage to the
next entry below.</p>
</dd>
</li>
<dt><strong><a name="item_perldebguts_2epod">perldebguts.pod</a></strong>

<dd>
<p>This new manpage contains excessively low-level material not related
to the Perl debugger, but slightly related to debugging Perl itself.
It also contains some arcane internal details of how the debugging
process works that may only be of interest to developers of Perl
debuggers.</p>
</dd>
</li>
<dt><strong><a name="item_perlfork_2epod">perlfork.pod</a></strong>

<dd>
<p>Notes on the <code>fork()</code> emulation currently available for the Windows platform.</p>
</dd>
</li>
<dt><strong><a name="item_perlfilter_2epod">perlfilter.pod</a></strong>

<dd>
<p>An introduction to writing Perl source filters.</p>
</dd>
</li>
<dt><strong><a name="item_perlhack_2epod">perlhack.pod</a></strong>

<dd>
<p>Some guidelines for hacking the Perl source code.</p>
</dd>
</li>
<dt><strong><a name="item_perlintern_2epod">perlintern.pod</a></strong>

<dd>
<p>A list of internal functions in the Perl source code.
(List is currently empty.)</p>
</dd>
</li>
<dt><strong><a name="item_perllexwarn_2epod">perllexwarn.pod</a></strong>

<dd>
<p>Introduction and reference information about lexically scoped
warning categories.</p>
</dd>
</li>
<dt><strong><a name="item_perlnumber_2epod">perlnumber.pod</a></strong>

<dd>
<p>Detailed information about numbers as they are represented in Perl.</p>
</dd>
</li>
<dt><strong><a name="item_perlopentut_2epod">perlopentut.pod</a></strong>

<dd>
<p>A tutorial on using <a href="#item_open"><code>open()</code></a> effectively.</p>
</dd>
</li>
<dt><strong><a name="item_perlreftut_2epod">perlreftut.pod</a></strong>

<dd>
<p>A tutorial that introduces the essentials of references.</p>
</dd>
</li>
<dt><strong><a name="item_perltootc_2epod">perltootc.pod</a></strong>

<dd>
<p>A tutorial on managing class data for object modules.</p>
</dd>
</li>
<dt><strong><a name="item_perltodo_2epod">perltodo.pod</a></strong>

<dd>
<p>Discussion of the most often wanted features that may someday be
supported in Perl.</p>
</dd>
</li>
<dt><strong><a name="item_perlunicode_2epod">perlunicode.pod</a></strong>

<dd>
<p>An introduction to Unicode support features in Perl.</p>
</dd>
</li>
</dl>
<p>
</p>
<hr />
<h1><a name="performance_enhancements">Performance enhancements</a></h1>
<p>
</p>
<h2><a name="simple_sort___using____a______b___and_the_like_are_optimized">Simple <code>sort()</code> using { $a &lt;=&gt; $b } and the like are optimized</a></h2>
<p>Many common <code>sort()</code> operations using a simple inlined block are now
optimized for faster performance.</p>
<p>
</p>
<h2><a name="optimized_assignments_to_lexical_variables">Optimized assignments to lexical variables</a></h2>
<p>Certain operations in the RHS of assignment statements have been
optimized to directly set the lexical variable on the LHS,
eliminating redundant copying overheads.</p>
<p>
</p>
<h2><a name="faster_subroutine_calls">Faster subroutine calls</a></h2>
<p>Minor changes in how subroutine calls are handled internally
provide marginal improvements in performance.</p>
<p>
</p>
<h2><a name="delete____each____values___and_hash_iteration_are_faster">delete(), each(), <code>values()</code> and hash iteration are faster</a></h2>
<p>The hash values returned by delete(), each(), <code>values()</code> and hashes in a
list context are the actual values in the hash, instead of copies.
This results in significantly better performance, because it eliminates
needless copying in most situations.</p>
<p>
</p>
<hr />
<h1><a name="installation_and_configuration_improvements">Installation and Configuration Improvements</a></h1>
<p>
</p>
<h2><a name="dusethreads_means_something_different">-Dusethreads means something different</a></h2>
<p>The -Dusethreads flag now enables the experimental interpreter-based thread
support by default.  To get the flavor of experimental threads that was in
5.005 instead, you need to run Configure with ``-Dusethreads -Duse5005threads''.</p>
<p>As of v5.6.0, interpreter-threads support is still lacking a way to
create new threads from Perl (i.e., <code>use Thread;</code> will not work with
interpreter threads).  <code>use Thread;</code> continues to be available when you
specify the -Duse5005threads option to Configure, bugs and all.</p>
<pre>
    NOTE: Support for threads continues to be an experimental feature.
    Interfaces and implementation are subject to sudden and drastic changes.</pre>
<p>
</p>
<h2><a name="new_configure_flags">New Configure flags</a></h2>
<p>The following new flags may be enabled on the Configure command line
by running Configure with <code>-Dflag</code>.</p>
<pre>
    usemultiplicity
    usethreads useithreads      (new interpreter threads: no Perl API yet)
    usethreads use5005threads   (threads as they were in 5.005)</pre>
<pre>
    use64bitint                 (equal to now deprecated 'use64bits')
    use64bitall</pre>
<pre>
    uselongdouble
    usemorebits
    uselargefiles
    usesocks                    (only SOCKS v5 supported)</pre>
<p>
</p>
<h2><a name="threadedness_and_64bitness_now_more_daring">Threadedness and 64-bitness now more daring</a></h2>
<p>The Configure options enabling the use of threads and the use of
64-bitness are now more daring in the sense that they no more have an
explicit list of operating systems of known threads/64-bit
capabilities.  In other words: if your operating system has the
necessary APIs and datatypes, you should be able just to go ahead and
use them, for threads by Configure -Dusethreads, and for 64 bits
either explicitly by Configure -Duse64bitint or implicitly if your
system has 64-bit wide datatypes.  See also <a href="#64bit_support">64-bit support</a>.</p>
<p>
</p>
<h2><a name="long_doubles">Long Doubles</a></h2>
<p>Some platforms have ``long doubles'', floating point numbers of even
larger range than ordinary ``doubles''.  To enable using long doubles for
Perl's scalars, use -Duselongdouble.</p>
<p>
</p>
<h2><a name="dusemorebits">-Dusemorebits</a></h2>
<p>You can enable both -Duse64bitint and -Duselongdouble with -Dusemorebits.
See also <a href="#64bit_support">64-bit support</a>.</p>
<p>
</p>
<h2><a name="duselargefiles">-Duselargefiles</a></h2>
<p>Some platforms support system APIs that are capable of handling large files
(typically, files larger than two gigabytes).  Perl will try to use these
APIs if you ask for -Duselargefiles.</p>
<p>See <a href="#large_file_support">Large file support</a> for more information.</p>
<p>
</p>
<h2><a name="installusrbinperl">installusrbinperl</a></h2>
<p>You can use ``Configure -Uinstallusrbinperl'' which causes installperl
to skip installing perl also as /usr/bin/perl.  This is useful if you
prefer not to modify /usr/bin for some reason or another but harmful
because many scripts assume to find Perl in /usr/bin/perl.</p>
<p>
</p>
<h2><a name="socks_support">SOCKS support</a></h2>
<p>You can use ``Configure -Dusesocks'' which causes Perl to probe
for the SOCKS proxy protocol library (v5, not v4).  For more information
on SOCKS, see:</p>
<pre>
    <a href="http://www.socks.nec.com/">http://www.socks.nec.com/</a></pre>
<p>
</p>
<h2><a name="a_flag"><code>-A</code> flag</a></h2>
<p>You can ``post-edit'' the Configure variables using the Configure <code>-A</code>
switch.  The editing happens immediately after the platform specific
hints files have been processed but before the actual configuration
process starts.  Run <code>Configure -h</code> to find out the full <code>-A</code> syntax.</p>
<p>
</p>
<h2><a name="enhanced_installation_directories">Enhanced Installation Directories</a></h2>
<p>The installation structure has been enriched to improve the support
for maintaining multiple versions of perl, to provide locations for
vendor-supplied modules, scripts, and manpages, and to ease maintenance
of locally-added modules, scripts, and manpages.  See the section on
Installation Directories in the INSTALL file for complete details.
For most users building and installing from source, the defaults should
be fine.</p>
<p>If you previously used <code>Configure -Dsitelib</code> or <code>-Dsitearch</code> to set
special values for library directories, you might wish to consider using
the new <code>-Dsiteprefix</code> setting instead.  Also, if you wish to re-use a
config.sh file from an earlier version of perl, you should be sure to
check that Configure makes sensible choices for the new directories.
See INSTALL for complete details.</p>
<p>
</p>
<hr />
<h1><a name="platform_specific_changes">Platform specific changes</a></h1>
<p>
</p>
<h2><a name="supported_platforms">Supported platforms</a></h2>
<ul>
<li>
<p>The Mach CThreads (NEXTSTEP, OPENSTEP) are now supported by the Thread
extension.</p>
</li>
<li>
<p>GNU/Hurd is now supported.</p>
</li>
<li>
<p>Rhapsody/Darwin is now supported.</p>
</li>
<li>
<p>EPOC is now supported (on Psion 5).</p>
</li>
<li>
<p>The cygwin port (formerly cygwin32) has been greatly improved.</p>
</li>
</ul>
<p>
</p>
<h2><a name="dos">DOS</a></h2>
<ul>
<li>
<p>Perl now works with djgpp 2.02 (and 2.03 alpha).</p>
</li>
<li>
<p>Environment variable names are not converted to uppercase any more.</p>
</li>
<li>
<p>Incorrect exit codes from backticks have been fixed.</p>
</li>
<li>
<p>This port continues to use its own builtin globbing (not File::Glob).</p>
</li>
</ul>
<p>
</p>
<h2><a name="os390__openedition_mvs_">OS390 (OpenEdition MVS)</a></h2>
<p>Support for this EBCDIC platform has not been renewed in this release.
There are difficulties in reconciling Perl's standardization on UTF-8
as its internal representation for characters with the EBCDIC character
set, because the two are incompatible.</p>
<p>It is unclear whether future versions will renew support for this
platform, but the possibility exists.</p>
<p>
</p>
<h2><a name="vms">VMS</a></h2>
<p>Numerous revisions and extensions to configuration, build, testing, and
installation process to accommodate core changes and VMS-specific options.</p>
<p>Expand %ENV-handling code to allow runtime mapping to logical names,
CLI symbols, and CRTL environ array.</p>
<p>Extension of subprocess invocation code to accept filespecs as command
``verbs''.</p>
<p>Add to Perl command line processing the ability to use default file types and
to recognize Unix-style <code>2&gt;&amp;1</code>.</p>
<p>Expansion of File::Spec::VMS routines, and integration into ExtUtils::MM_VMS.</p>
<p>Extension of ExtUtils::MM_VMS to handle complex extensions more flexibly.</p>
<p>Barewords at start of Unix-syntax paths may be treated as text rather than
only as logical names.</p>
<p>Optional secure translation of several logical names used internally by Perl.</p>
<p>Miscellaneous bugfixing and porting of new core code to VMS.</p>
<p>Thanks are gladly extended to the many people who have contributed VMS
patches, testing, and ideas.</p>
<p>
</p>
<h2><a name="win32">Win32</a></h2>
<p>Perl can now emulate <code>fork()</code> internally, using multiple interpreters running
in different concurrent threads.  This support must be enabled at build
time.  See <a href="perlfork.html">the perlfork manpage</a> for detailed information.</p>
<p>When given a pathname that consists only of a drivename, such as <code>A:</code>,
<code>opendir()</code> and <code>stat()</code> now use the current working directory for the drive
rather than the drive root.</p>
<p>The builtin XSUB functions in the Win32:: namespace are documented.  See
<a href="../../File/Spec/Win32.html">the Win32 manpage</a>.</p>
<p>$^X now contains the full path name of the running executable.</p>
<p>A Win32::GetLongPathName() function is provided to complement
Win32::GetFullPathName() and Win32::GetShortPathName().  See <a href="../../File/Spec/Win32.html">the Win32 manpage</a>.</p>
<p>POSIX::uname() is supported.</p>
<p><code>system(1,...)</code> now returns true process IDs rather than process
handles.  <code>kill()</code> accepts any real process id, rather than strictly
return values from system(1,...).</p>
<p>For better compatibility with Unix, <code>kill(0, $pid)</code> can now be used to
test whether a process exists.</p>
<p>The <code>Shell</code> module is supported.</p>
<p>Better support for building Perl under command.com in Windows 95
has been added.</p>
<p>Scripts are read in binary mode by default to allow ByteLoader (and
the filter mechanism in general) to work properly.  For compatibility,
the DATA filehandle will be set to text mode if a carriage return is
detected at the end of the line containing the __END__ or __DATA__
token; if not, the DATA filehandle will be left open in binary mode.
Earlier versions always opened the DATA filehandle in text mode.</p>
<p>The <code>glob()</code> operator is implemented via the <a href="#item_file_3a_3aglob"><code>File::Glob</code></a> extension,
which supports glob syntax of the C shell.  This increases the flexibility
of the <code>glob()</code> operator, but there may be compatibility issues for
programs that relied on the older globbing syntax.  If you want to
preserve compatibility with the older syntax, you might want to run
perl with <code>-MFile::DosGlob</code>.  For details and compatibility information,
see <a href="../../File/Glob.html">the File::Glob manpage</a>.</p>
<p>
</p>
<hr />
<h1><a name="significant_bug_fixes">Significant bug fixes</a></h1>
<p>
</p>
<h2><a name="_handle__on_empty_files">&lt;HANDLE&gt; on empty files</a></h2>
<p>With <code>$/</code> set to <code>undef</code>, ``slurping'' an empty file returns a string of
zero length (instead of <code>undef</code>, as it used to) the first time the
HANDLE is read after <code>$/</code> is set to <code>undef</code>.  Further reads yield
<code>undef</code>.</p>
<p>This means that the following will append ``foo'' to an empty file (it used
to do nothing):</p>
<pre>
    perl -0777 -pi -e 's/^/foo/' empty_file</pre>
<p>The behaviour of:</p>
<pre>
    perl -pi -e 's/^/foo/' empty_file</pre>
<p>is unchanged (it continues to leave the file empty).</p>
<p>
</p>
<h2><a name="eval_______improvements"><code>eval '...'</code> improvements</a></h2>
<p>Line numbers (as reflected by <code>caller()</code> and most diagnostics) within
<code>eval '...'</code> were often incorrect where here documents were involved.
This has been corrected.</p>
<p>Lexical lookups for variables appearing in <code>eval '...'</code> within
functions that were themselves called within an <code>eval '...'</code> were
searching the wrong place for lexicals.  The lexical search now
correctly ends at the subroutine's block boundary.</p>
<p>The use of <code>return</code> within <code>eval {...}</code> caused $@ not to be reset
correctly when no exception occurred within the eval.  This has
been fixed.</p>
<p>Parsing of here documents used to be flawed when they appeared as
the replacement expression in <code>eval 's/.../.../e'</code>.  This has
been fixed.</p>
<p>
</p>
<h2><a name="all_compilation_errors_are_true_errors">All compilation errors are true errors</a></h2>
<p>Some ``errors'' encountered at compile time were by necessity 
generated as warnings followed by eventual termination of the
program.  This enabled more such errors to be reported in a
single run, rather than causing a hard stop at the first error
that was encountered.</p>
<p>The mechanism for reporting such errors has been reimplemented
to queue compile-time errors and report them at the end of the
compilation as true errors rather than as warnings.  This fixes
cases where error messages leaked through in the form of warnings
when code was compiled at run time using <code>eval STRING</code>, and
also allows such errors to be reliably trapped using <code>eval &quot;...&quot;</code>.</p>
<p>
</p>
<h2><a name="implicitly_closed_filehandles_are_safer">Implicitly closed filehandles are safer</a></h2>
<p>Sometimes implicitly closed filehandles (as when they are localized,
and Perl automatically closes them on exiting the scope) could
inadvertently set $? or $!.  This has been corrected.</p>
<p>
</p>
<h2><a name="behavior_of_list_slices_is_more_consistent">Behavior of list slices is more consistent</a></h2>
<p>When taking a slice of a literal list (as opposed to a slice of
an array or hash), Perl used to return an empty list if the
result happened to be composed of all undef values.</p>
<p>The new behavior is to produce an empty list if (and only if)
the original list was empty.  Consider the following example:</p>
<pre>
    @a = (1,undef,undef,2)[2,1,2];</pre>
<p>The old behavior would have resulted in @a having no elements.
The new behavior ensures it has three undefined elements.</p>
<p>Note in particular that the behavior of slices of the following
cases remains unchanged:</p>
<pre>
    @a = ()[1,2];
    @a = (getpwent)[7,0];
    @a = (anything_returning_empty_list())[2,1,2];
    @a = @b[2,1,2];
    @a = @c{'a','b','c'};</pre>
<p>See <a href="perldata.html">the perldata manpage</a>.</p>
<p>
</p>
<h2><a name="_____prototype_and__foo_a_"><code>(\$)</code> prototype and <code>$foo{a}</code></a></h2>
<p>A scalar reference prototype now correctly allows a hash or
array element in that slot.</p>
<p>
</p>
<h2><a name="goto__sub_and_autoload"><code>goto &amp;sub</code> and AUTOLOAD</a></h2>
<p>The <code>goto &amp;sub</code> construct works correctly when <code>&amp;sub</code> happens
to be autoloaded.</p>
<p>
</p>
<h2><a name="bareword_allowed_under_use_integer"><code>-bareword</code> allowed under <code>use integer</code></a></h2>
<p>The autoquoting of barewords preceded by <code>-</code> did not work
in prior versions when the <code>integer</code> pragma was enabled.
This has been fixed.</p>
<p>
</p>
<h2><a name="failures_in_destroy__">Failures in <code>DESTROY()</code></a></h2>
<p>When code in a destructor threw an exception, it went unnoticed
in earlier versions of Perl, unless someone happened to be
looking in $@ just after the point the destructor happened to
run.  Such failures are now visible as warnings when warnings are
enabled.</p>
<p>
</p>
<h2><a name="locale_bugs_fixed">Locale bugs fixed</a></h2>
<p><code>printf()</code> and <code>sprintf()</code> previously reset the numeric locale
back to the default ``C'' locale.  This has been fixed.</p>
<p>Numbers formatted according to the local numeric locale
(such as using a decimal comma instead of a decimal dot) caused
``isn't numeric'' warnings, even while the operations accessing
those numbers produced correct results.  These warnings have been
discontinued.</p>
<p>
</p>
<h2><a name="memory_leaks">Memory leaks</a></h2>
<p>The <code>eval 'return sub {...}'</code> construct could sometimes leak
memory.  This has been fixed.</p>
<p>Operations that aren't filehandle constructors used to leak memory
when used on invalid filehandles.  This has been fixed.</p>
<p>Constructs that modified <code>@_</code> could fail to deallocate values
in <code>@_</code> and thus leak memory.  This has been corrected.</p>
<p>
</p>
<h2><a name="spurious_subroutine_stubs_after_failed_subroutine_calls">Spurious subroutine stubs after failed subroutine calls</a></h2>
<p>Perl could sometimes create empty subroutine stubs when a
subroutine was not found in the package.  Such cases stopped
later method lookups from progressing into base packages.
This has been corrected.</p>
<p>
</p>
<h2><a name="taint_failures_under_u">Taint failures under <code>-U</code></a></h2>
<p>When running in unsafe mode, taint violations could sometimes
cause silent failures.  This has been fixed.</p>
<p>
</p>
<h2><a name="end_blocks_and_the_c_switch">END blocks and the <code>-c</code> switch</a></h2>
<p>Prior versions used to run BEGIN <strong>and</strong> END blocks when Perl was
run in compile-only mode.  Since this is typically not the expected
behavior, END blocks are not executed anymore when the <code>-c</code> switch
is used, or if compilation fails.</p>
<p>See <a href="#support_for_check_blocks">Support for CHECK blocks</a> for how to run things when the compile 
phase ends.</p>
<p>
</p>
<h2><a name="potential_to_leak_data_filehandles">Potential to leak DATA filehandles</a></h2>
<p>Using the <code>__DATA__</code> token creates an implicit filehandle to
the file that contains the token.  It is the program's
responsibility to close it when it is done reading from it.</p>
<p>This caveat is now better explained in the documentation.
See <a href="perldata.html">the perldata manpage</a>.</p>
<p>
</p>
<hr />
<h1><a name="new_or_changed_diagnostics">New or Changed Diagnostics</a></h1>
<dl>
<dt><strong><a name="item__22_25s_22_variable__25s_masks_earlier_declaration">``%s'' variable %s masks earlier declaration in same %s</a></strong>

<dd>
<p>(W misc) A ``my'' or ``our'' variable has been redeclared in the current scope or statement,
effectively eliminating all access to the previous instance.  This is almost
always a typographical error.  Note that the earlier variable will still exist
until the end of the scope or until all closure referents to it are
destroyed.</p>
</dd>
</li>
<dt><strong><a name="item__22my_sub_22_not_yet_implemented">``my sub'' not yet implemented</a></strong>

<dd>
<p>(F) Lexically scoped subroutines are not yet implemented.  Don't try that
yet.</p>
</dd>
</li>
<dt><strong><a name="item__22our_22_variable__25s_redeclared">``our'' variable %s redeclared</a></strong>

<dd>
<p>(W misc) You seem to have already declared the same global once before in the
current lexical scope.</p>
</dd>
</li>
<dt><strong><a name="item__27_21_27_allowed_only_after_types__25s">'!' allowed only after types %s</a></strong>

<dd>
<p>(F) The '!' is allowed in <code>pack()</code> and <code>unpack()</code> only after certain types.
See <a href="perlfunc.html#pack">pack in the perlfunc manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item__2f_cannot_take_a_count">/ cannot take a count</a></strong>

<dd>
<p>(F) You had an unpack template indicating a counted-length string,
but you have also specified an explicit size for the string.
See <a href="perlfunc.html#pack">pack in the perlfunc manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item__2f_must_be_followed_by_a_2c_a_or_z">/ must be followed by a, A or Z</a></strong>

<dd>
<p>(F) You had an unpack template indicating a counted-length string,
which must be followed by one of the letters a, A or Z
to indicate what sort of string is to be unpacked.
See <a href="perlfunc.html#pack">pack in the perlfunc manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item__2f_must_be_followed_by_a_2a_2c_a_2a_or_z_2a">/ must be followed by a*, A* or Z*</a></strong>

<dd>
<p>(F) You had a pack template indicating a counted-length string,
Currently the only things that can have their length counted are a*, A* or Z*.
See <a href="perlfunc.html#pack">pack in the perlfunc manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item__2f_must_follow_a_numeric_type">/ must follow a numeric type</a></strong>

<dd>
<p>(F) You had an unpack template that contained a '#',
but this did not follow some numeric unpack specification.
See <a href="perlfunc.html#pack">pack in the perlfunc manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item__2f_25s_2f_3a_unrecognized_escape__5c_5c_25c_passe">/%s/: Unrecognized escape \\%c passed through</a></strong>

<dd>
<p>(W regexp) You used a backslash-character combination which is not recognized
by Perl.  This combination appears in an interpolated variable or a
<code>'</code>-delimited regular expression.  The character was understood literally.</p>
</dd>
</li>
<dt><strong><a name="item__2f_25s_2f_3a_unrecognized_escape__5c_5c_25c_in_ch">/%s/: Unrecognized escape \\%c in character class passed through</a></strong>

<dd>
<p>(W regexp) You used a backslash-character combination which is not recognized
by Perl inside character classes.  The character was understood literally.</p>
</dd>
</li>
<dt><strong><a name="item__2f_25s_2f_should_probably_be_written_as__22_25s_2">/%s/ should probably be written as ``%s''</a></strong>

<dd>
<p>(W syntax) You have used a pattern where Perl expected to find a string,
as in the first argument to <code>join</code>.  Perl will treat the true
or false result of matching the pattern against $_ as the string,
which is probably not what you had in mind.</p>
</dd>
</li>
<dt><strong><a name="item_s">%s() called too early to check prototype</a></strong>

<dd>
<p>(W prototype) You've called a function that has a prototype before the parser saw a
definition or declaration for it, and Perl could not check that the call
conforms to the prototype.  You need to either add an early prototype
declaration for the subroutine in question, or move the subroutine
definition ahead of the call to get proper prototype checking.  Alternatively,
if you are certain that you're calling the function correctly, you may put
an ampersand before the name to avoid the warning.  See <a href="perlsub.html">the perlsub manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item__s">%s argument is not a HASH or ARRAY element</a></strong>

<dd>
<p>(F) The argument to <code>exists()</code> must be a hash or array element, such as:</p>
</dd>
<dd>
<pre>
    $foo{$bar}
    $ref-&gt;{&quot;susie&quot;}[12]</pre>
</dd>
</li>
<dt><strong>%s argument is not a HASH or ARRAY element or slice</strong>

<dd>
<p>(F) The argument to <a href="#item_delete"><code>delete()</code></a> must be either a hash or array element, such as:</p>
</dd>
<dd>
<pre>
    $foo{$bar}
    $ref-&gt;{&quot;susie&quot;}[12]</pre>
</dd>
<dd>
<p>or a hash or array slice, such as:</p>
</dd>
<dd>
<pre>
    @foo[$bar, $baz, $xyzzy]
    @{$ref-&gt;[12]}{&quot;susie&quot;, &quot;queue&quot;}</pre>
</dd>
</li>
<dt><strong>%s argument is not a subroutine name</strong>

<dd>
<p>(F) The argument to <code>exists()</code> for <code>exists &amp;sub</code> must be a subroutine
name, and not a subroutine call.  <code>exists &amp;sub()</code> will generate this error.</p>
</dd>
</li>
<dt><strong>%s package attribute may clash with future reserved word: %s</strong>

<dd>
<p>(W reserved) A lowercase attribute name was used that had a package-specific handler.
That name might have a meaning to Perl itself some day, even though it
doesn't yet.  Perhaps you should use a mixed-case attribute name, instead.
See <a href="../../attributes.html">the attributes manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item__28in_cleanup_29__25s">(in cleanup) %s</a></strong>

<dd>
<p>(W misc) This prefix usually indicates that a <code>DESTROY()</code> method raised
the indicated exception.  Since destructors are usually called by
the system at arbitrary points during execution, and often a vast
number of times, the warning is issued only once for any number
of failures that would otherwise result in the same message being
repeated.</p>
</dd>
<dd>
<p>Failure of user callbacks dispatched using the <code>G_KEEPERR</code> flag
could also result in this warning.  See <a href="perlcall.html#g_keeperr">G_KEEPERR in the perlcall manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item__3c_3e_should_be_quotes">&lt;&gt; should be quotes</a></strong>

<dd>
<p>(F) You wrote <code>require &lt;file&gt;</code> when you should have written
<code>require 'file'</code>.</p>
</dd>
</li>
<dt><strong><a name="item_attempt_to_join_self">Attempt to join self</a></strong>

<dd>
<p>(F) You tried to join a thread from within itself, which is an
impossible task.  You may be joining the wrong thread, or you may
need to move the <code>join()</code> to some other thread.</p>
</dd>
</li>
<dt><strong><a name="item_bad_evalled_substitution_pattern">Bad evalled substitution pattern</a></strong>

<dd>
<p>(F) You've used the /e switch to evaluate the replacement for a
substitution, but perl found a syntax error in the code to evaluate,
most likely an unexpected right brace '}'.</p>
</dd>
</li>
<dt><strong><a name="item_realloc">Bad <code>realloc()</code> ignored</a></strong>

<dd>
<p>(S) An internal routine called <a href="#item_realloc"><code>realloc()</code></a> on something that had never been
malloc()ed in the first place. Mandatory, but can be disabled by
setting environment variable <code>PERL_BADFREE</code> to 1.</p>
</dd>
</li>
<dt><strong><a name="item_bareword_found_in_conditional">Bareword found in conditional</a></strong>

<dd>
<p>(W bareword) The compiler found a bareword where it expected a conditional,
which often indicates that an || or &amp;&amp; was parsed as part of the
last argument of the previous construct, for example:</p>
</dd>
<dd>
<pre>
    open FOO || die;</pre>
</dd>
<dd>
<p>It may also indicate a misspelled constant that has been interpreted
as a bareword:</p>
</dd>
<dd>
<pre>
    use constant TYPO =&gt; 1;
    if (TYOP) { print &quot;foo&quot; }</pre>
</dd>
<dd>
<p>The <code>strict</code> pragma is useful in avoiding such errors.</p>
</dd>
</li>
<dt><strong><a name="item_binary_number__3e_0b111111111111111111111111111111">Binary number &gt; 0b11111111111111111111111111111111 non-portable</a></strong>

<dd>
<p>(W portable) The binary number you specified is larger than 2**32-1
(4294967295) and therefore non-portable between systems.  See
<a href="perlport.html">the perlport manpage</a> for more on portability concerns.</p>
</dd>
</li>
<dt><strong><a name="item_bit_vector_size__3e_32_non_2dportable">Bit vector size &gt; 32 non-portable</a></strong>

<dd>
<p>(W portable) Using bit vector sizes larger than 32 is non-portable.</p>
</dd>
</li>
<dt><strong><a name="item_buffer_overflow_in_prime_env_iter_3a__25s">Buffer overflow in prime_env_iter: %s</a></strong>

<dd>
<p>(W internal) A warning peculiar to VMS.  While Perl was preparing to iterate over
%ENV, it encountered a logical name or symbol definition which was too long,
so it was truncated to the string shown.</p>
</dd>
</li>
<dt><strong><a name="item_can_27t_check_filesystem_of_script__22_25s_22">Can't check filesystem of script ``%s''</a></strong>

<dd>
<p>(P) For some reason you can't check the filesystem of the script for nosuid.</p>
</dd>
</li>
<dt><strong><a name="item_can_27t_declare_class_for_non_2dscalar__25s_in__22">Can't declare class for non-scalar %s in ``%s''</a></strong>

<dd>
<p>(S) Currently, only scalar variables can declared with a specific class
qualifier in a ``my'' or ``our'' declaration.  The semantics may be extended
for other types of variables in future.</p>
</dd>
</li>
<dt><strong><a name="item_can_27t_declare__25s_in__22_25s_22">Can't declare %s in ``%s''</a></strong>

<dd>
<p>(F) Only scalar, array, and hash variables may be declared as ``my'' or
``our'' variables.  They must have ordinary identifiers as names.</p>
</dd>
</li>
<dt><strong><a name="item_can_27t_ignore_signal_chld_2c_forcing_to_default">Can't ignore signal CHLD, forcing to default</a></strong>

<dd>
<p>(W signal) Perl has detected that it is being run with the SIGCHLD signal
(sometimes known as SIGCLD) disabled.  Since disabling this signal
will interfere with proper determination of exit status of child
processes, Perl has reset the signal to its default value.
This situation typically indicates that the parent program under
which Perl may be running (e.g., cron) is being very careless.</p>
</dd>
</li>
<dt><strong><a name="item_can_27t_modify_non_2dlvalue_subroutine_call">Can't modify non-lvalue subroutine call</a></strong>

<dd>
<p>(F) Subroutines meant to be used in lvalue context should be declared as
such, see <a href="perlsub.html#lvalue_subroutines">Lvalue subroutines in the perlsub manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_can_27t_read_crtl_environ">Can't read CRTL environ</a></strong>

<dd>
<p>(S) A warning peculiar to VMS.  Perl tried to read an element of %ENV
from the CRTL's internal environment array and discovered the array was
missing.  You need to figure out where your CRTL misplaced its environ
or define <em>PERL_ENV_TABLES</em> (see <a href="perlvms.html">the perlvms manpage</a>) so that environ is not searched.</p>
</dd>
</li>
<dt><strong><a name="item_can_27t_remove__25s_3a__25s_2c_skipping_file">Can't remove %s: %s, skipping file</a></strong>

<dd>
<p>(S) You requested an inplace edit without creating a backup file.  Perl
was unable to remove the original file to replace it with the modified
file.  The file was left unmodified.</p>
</dd>
</li>
<dt><strong><a name="item_can_27t_return__25s_from_lvalue_subroutine">Can't return %s from lvalue subroutine</a></strong>

<dd>
<p>(F) Perl detected an attempt to return illegal lvalues (such
as temporary or readonly values) from a subroutine used as an lvalue.
This is not allowed.</p>
</dd>
</li>
<dt><strong><a name="item_can_27t_weaken_a_nonreference">Can't weaken a nonreference</a></strong>

<dd>
<p>(F) You attempted to weaken something that was not a reference.  Only
references can be weakened.</p>
</dd>
</li>
<dt><strong><a name="item_character_class__5b_3a_25s_3a_5d_unknown">Character class [:%s:] unknown</a></strong>

<dd>
<p>(F) The class in the character class [: :] syntax is unknown.
See <a href="perlre.html">the perlre manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_character_class_syntax__5b_25s_5d_belongs_inside_c">Character class syntax [%s] belongs inside character classes</a></strong>

<dd>
<p>(W unsafe) The character class constructs [: :], [= =], and [. .]  go
<em>inside</em> character classes, the [] are part of the construct,
for example: /[012[:alpha:]345]/.  Note that [= =] and [. .]
are not currently implemented; they are simply placeholders for
future extensions.</p>
</dd>
</li>
<dt><strong><a name="item_constant_is_not__25s_reference">Constant is not %s reference</a></strong>

<dd>
<p>(F) A constant value (perhaps declared using the <code>use constant</code> pragma)
is being dereferenced, but it amounts to the wrong type of reference.  The
message indicates the type of reference that was expected. This usually
indicates a syntax error in dereferencing the constant value.
See <a href="perlsub.html#constant_functions">Constant Functions in the perlsub manpage</a> and <a href="../../constant.html">the constant manpage</a>.</p>
</dd>
</li>
<dt><strong>constant(%s): %s</strong>

<dd>
<p>(F) The parser found inconsistencies either while attempting to define an
overloaded constant, or when trying to find the character name specified
in the <code>\N{...}</code> escape.  Perhaps you forgot to load the corresponding
<code>overload</code> or <a href="#item_charnames"><code>charnames</code></a> pragma?  See <a href="../../charnames.html">the charnames manpage</a> and <a href="../../overload.html">the overload manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_core_3a_3a_25s_is_not_a_keyword">CORE::%s is not a keyword</a></strong>

<dd>
<p>(F) The CORE:: namespace is reserved for Perl keywords.</p>
</dd>
</li>
<dt><strong><a name="item_defined"><code>defined(@array)</code> is deprecated</a></strong>

<dd>
<p>(D) <a href="#item_defined"><code>defined()</code></a> is not usually useful on arrays because it checks for an
undefined <em>scalar</em> value.  If you want to see if the array is empty,
just use <code>if (@array) { # not empty }</code> for example.</p>
</dd>
</li>
<dt><strong><code>defined(%hash)</code> is deprecated</strong>

<dd>
<p>(D) <a href="#item_defined"><code>defined()</code></a> is not usually useful on hashes because it checks for an
undefined <em>scalar</em> value.  If you want to see if the hash is empty,
just use <code>if (%hash) { # not empty }</code> for example.</p>
</dd>
</li>
<dt><strong><a name="item_did_not_produce_a_valid_header">Did not produce a valid header</a></strong>

<dd>
<p>See Server error.</p>
</dd>
</li>
<dt><strong><a name="item__28did_you_mean__22local_22_instead_of__22our_22_3">(Did you mean ``local'' instead of ``our''?)</a></strong>

<dd>
<p>(W misc) Remember that ``our'' does not localize the declared global variable.
You have declared it again in the same lexical scope, which seems superfluous.</p>
</dd>
</li>
<dt><strong><a name="item_document_contains_no_data">Document contains no data</a></strong>

<dd>
<p>See Server error.</p>
</dd>
</li>
<dt><strong><a name="item_entering_effective__25s_failed">entering effective %s failed</a></strong>

<dd>
<p>(F) While under the <code>use filetest</code> pragma, switching the real and
effective uids or gids failed.</p>
</dd>
</li>
<dt><strong><a name="item_false__5b_5d_range__22_25s_22_in_regexp">false [] range ``%s'' in regexp</a></strong>

<dd>
<p>(W regexp) A character class range must start and end at a literal character, not
another character class like <code>\d</code> or <code>[:alpha:]</code>.  The ``-'' in your false
range is interpreted as a literal ``-''.  Consider quoting the ``-'',  ``\-''.
See <a href="perlre.html">the perlre manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_filehandle__25s_opened_only_for_output">Filehandle %s opened only for output</a></strong>

<dd>
<p>(W io) You tried to read from a filehandle opened only for writing.  If you
intended it to be a read/write filehandle, you needed to open it with
``+&lt;'' or ``+&gt;'' or ``+&gt;&gt;'' instead of with ``&lt;'' or nothing.  If
you intended only to read from the file, use ``&lt;''.  See
<a href="perlfunc.html#open">open in the perlfunc manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_flock"><code>flock()</code> on closed filehandle %s</a></strong>

<dd>
<p>(W closed) The filehandle you're attempting to <a href="#item_flock"><code>flock()</code></a> got itself closed some
time before now.  Check your logic flow.  <a href="#item_flock"><code>flock()</code></a> operates on filehandles.
Are you attempting to call <a href="#item_flock"><code>flock()</code></a> on a dirhandle by the same name?</p>
</dd>
</li>
<dt><strong><a name="item_global_symbol__22_25s_22_requires_explicit_package">Global symbol ``%s'' requires explicit package name</a></strong>

<dd>
<p>(F) You've said ``use strict vars'', which indicates that all variables
must either be lexically scoped (using ``my''), declared beforehand using
``our'', or explicitly qualified to say which package the global variable
is in (using ``::'').</p>
</dd>
</li>
<dt><strong><a name="item_hexadecimal_number__3e_0xffffffff_non_2dportable">Hexadecimal number &gt; 0xffffffff non-portable</a></strong>

<dd>
<p>(W portable) The hexadecimal number you specified is larger than 2**32-1
(4294967295) and therefore non-portable between systems.  See
<a href="perlport.html">the perlport manpage</a> for more on portability concerns.</p>
</dd>
</li>
<dt><strong><a name="item_ill_2dformed_crtl_environ_value__22_25s_22">Ill-formed CRTL environ value ``%s''</a></strong>

<dd>
<p>(W internal) A warning peculiar to VMS.  Perl tried to read the CRTL's internal
environ array, and encountered an element without the <code>=</code> delimiter
used to separate keys from values.  The element is ignored.</p>
</dd>
</li>
<dt><strong><a name="item_ill_2dformed_message_in_prime_env_iter_3a__7c_25s_">Ill-formed message in prime_env_iter: |%s|</a></strong>

<dd>
<p>(W internal) A warning peculiar to VMS.  Perl tried to read a logical name
or CLI symbol definition when preparing to iterate over %ENV, and
didn't see the expected delimiter between key and value, so the
line was ignored.</p>
</dd>
</li>
<dt><strong><a name="item_illegal_binary_digit__25s">Illegal binary digit %s</a></strong>

<dd>
<p>(F) You used a digit other than 0 or 1 in a binary number.</p>
</dd>
</li>
<dt><strong><a name="item_illegal_binary_digit__25s_ignored">Illegal binary digit %s ignored</a></strong>

<dd>
<p>(W digit) You may have tried to use a digit other than 0 or 1 in a binary number.
Interpretation of the binary number stopped before the offending digit.</p>
</dd>
</li>
<dt><strong><a name="item_illegal_number_of_bits_in_vec">Illegal number of bits in vec</a></strong>

<dd>
<p>(F) The number of bits in <a href="#item_vec"><code>vec()</code></a> (the third argument) must be a power of
two from 1 to 32 (or 64, if your platform supports that).</p>
</dd>
</li>
<dt><strong><a name="item_integer_overflow_in__25s_number">Integer overflow in %s number</a></strong>

<dd>
<p>(W overflow) The hexadecimal, octal or binary number you have specified either
as a literal or as an argument to <code>hex()</code> or <code>oct()</code> is too big for your
architecture, and has been converted to a floating point number.  On a
32-bit architecture the largest hexadecimal, octal or binary number
representable without overflow is 0xFFFFFFFF, 037777777777, or
0b11111111111111111111111111111111 respectively.  Note that Perl
transparently promotes all numbers to a floating point representation
internally--subject to loss of precision errors in subsequent
operations.</p>
</dd>
</li>
<dt><strong><a name="item_invalid__25s_attribute_3a__25s">Invalid %s attribute: %s</a></strong>

<dd>
<p>The indicated attribute for a subroutine or variable was not recognized
by Perl or by a user-supplied handler.  See <a href="../../attributes.html">the attributes manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_invalid__25s_attributes_3a__25s">Invalid %s attributes: %s</a></strong>

<dd>
<p>The indicated attributes for a subroutine or variable were not recognized
by Perl or by a user-supplied handler.  See <a href="../../attributes.html">the attributes manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_invalid__5b_5d_range__22_25s_22_in_regexp">invalid [] range ``%s'' in regexp</a></strong>

<dd>
<p>The offending range is now explicitly displayed.</p>
</dd>
</li>
<dt><strong><a name="item_invalid_separator_character__25s_in_attribute_list">Invalid separator character %s in attribute list</a></strong>

<dd>
<p>(F) Something other than a colon or whitespace was seen between the
elements of an attribute list.  If the previous attribute
had a parenthesised parameter list, perhaps that list was terminated
too soon.  See <a href="../../attributes.html">the attributes manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_invalid_separator_character__25s_in_subroutine_att">Invalid separator character %s in subroutine attribute list</a></strong>

<dd>
<p>(F) Something other than a colon or whitespace was seen between the
elements of a subroutine attribute list.  If the previous attribute
had a parenthesised parameter list, perhaps that list was terminated
too soon.</p>
</dd>
</li>
<dt><strong><a name="item_leaving_effective__25s_failed">leaving effective %s failed</a></strong>

<dd>
<p>(F) While under the <code>use filetest</code> pragma, switching the real and
effective uids or gids failed.</p>
</dd>
</li>
<dt><strong><a name="item_lvalue_subs_returning__25s_not_implemented_yet">Lvalue subs returning %s not implemented yet</a></strong>

<dd>
<p>(F) Due to limitations in the current implementation, array and hash
values cannot be returned in subroutines used in lvalue context.
See <a href="perlsub.html#lvalue_subroutines">Lvalue subroutines in the perlsub manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_method__25s_not_permitted">Method %s not permitted</a></strong>

<dd>
<p>See Server error.</p>
</dd>
</li>
<dt><strong><a name="item_missing__25sbrace_25s_on__5cn_7b_7d">Missing %sbrace%s on \N{}</a></strong>

<dd>
<p>(F) Wrong syntax of character name literal <code>\N{charname}</code> within
double-quotish context.</p>
</dd>
</li>
<dt><strong><a name="item_missing_command_in_piped_open">Missing command in piped open</a></strong>

<dd>
<p>(W pipe) You used the <a href="#item_open"><code>open(FH, &quot;| command&quot;)</code></a> or <a href="#item_open"><code>open(FH, &quot;command |&quot;)</code></a>
construction, but the command was missing or blank.</p>
</dd>
</li>
<dt><strong><a name="item_missing_name_in__22my_sub_22">Missing name in ``my sub''</a></strong>

<dd>
<p>(F) The reserved syntax for lexically scoped subroutines requires that they
have a name with which they can be found.</p>
</dd>
</li>
<dt><strong><a name="item_no__25s_specified_for__2d_25c">No %s specified for -%c</a></strong>

<dd>
<p>(F) The indicated command line switch needs a mandatory argument, but
you haven't specified one.</p>
</dd>
</li>
<dt><strong><a name="item_no_package_name_allowed_for_variable__25s_in__22ou">No package name allowed for variable %s in ``our''</a></strong>

<dd>
<p>(F) Fully qualified variable names are not allowed in ``our'' declarations,
because that doesn't make much sense under existing semantics.  Such
syntax is reserved for future extensions.</p>
</dd>
</li>
<dt><strong><a name="item_no_space_allowed_after__2d_25c">No space allowed after -%c</a></strong>

<dd>
<p>(F) The argument to the indicated command line switch must follow immediately
after the switch, without intervening spaces.</p>
</dd>
</li>
<dt><strong><a name="item_no_utc_offset_information_3b_assuming_local_time_i">no UTC offset information; assuming local time is UTC</a></strong>

<dd>
<p>(S) A warning peculiar to VMS.  Perl was unable to find the local
timezone offset, so it's assuming that local system time is equivalent
to UTC.  If it's not, define the logical name <em>SYS$TIMEZONE_DIFFERENTIAL</em>
to translate to the number of seconds which need to be added to UTC to
get local time.</p>
</dd>
</li>
<dt><strong><a name="item_octal_number__3e_037777777777_non_2dportable">Octal number &gt; 037777777777 non-portable</a></strong>

<dd>
<p>(W portable) The octal number you specified is larger than 2**32-1 (4294967295)
and therefore non-portable between systems.  See <a href="perlport.html">the perlport manpage</a> for more
on portability concerns.</p>
</dd>
<dd>
<p>See also <a href="perlport.html">the perlport manpage</a> for writing portable code.</p>
</dd>
</li>
<dt><strong><a name="item_panic_3a_del_backref">panic: del_backref</a></strong>

<dd>
<p>(P) Failed an internal consistency check while trying to reset a weak
reference.</p>
</dd>
</li>
<dt><strong><a name="item_panic_3a_kid_popen_errno_read">panic: kid popen errno read</a></strong>

<dd>
<p>(F) forked child returned an incomprehensible message about its errno.</p>
</dd>
</li>
<dt><strong><a name="item_panic_3a_magic_killbackrefs">panic: magic_killbackrefs</a></strong>

<dd>
<p>(P) Failed an internal consistency check while trying to reset all weak
references to an object.</p>
</dd>
</li>
<dt><strong><a name="item_parentheses_missing_around__22_25s_22_list">Parentheses missing around ``%s'' list</a></strong>

<dd>
<p>(W parenthesis) You said something like</p>
</dd>
<dd>
<pre>
    my $foo, $bar = @_;</pre>
</dd>
<dd>
<p>when you meant</p>
</dd>
<dd>
<pre>
    my ($foo, $bar) = @_;</pre>
</dd>
<dd>
<p>Remember that ``my'', ``our'', and ``local'' bind tighter than comma.</p>
</dd>
</li>
<dt><strong><a name="item_possible_unintended_interpolation_of__25s_in_strin">Possible unintended interpolation of %s in string</a></strong>

<dd>
<p>(W ambiguous) It used to be that Perl would try to guess whether you
wanted an array interpolated or a literal @.  It no longer does this;
arrays are now <em>always</em> interpolated into strings.  This means that 
if you try something like:</p>
</dd>
<dd>
<pre>
        print &quot;fred@example.com&quot;;</pre>
</dd>
<dd>
<p>and the array <code>@example</code> doesn't exist, Perl is going to print
<code>fred.com</code>, which is probably not what you wanted.  To get a literal
<code>@</code> sign in a string, put a backslash before it, just as you would
to get a literal <code>$</code> sign.</p>
</dd>
</li>
<dt><strong><a name="item_possible_y2k_bug_3a__25s">Possible Y2K bug: %s</a></strong>

<dd>
<p>(W y2k) You are concatenating the number 19 with another number, which
could be a potential Year 2000 problem.</p>
</dd>
</li>
<dt><strong><a name="item_pragma__22attrs_22_is_deprecated_2c_use__22sub_nam">pragma ``attrs'' is deprecated, use ``sub NAME : ATTRS'' instead</a></strong>

<dd>
<p>(W deprecated) You have written something like this:</p>
</dd>
<dd>
<pre>
    sub doit
    {
        use attrs qw(locked);
    }</pre>
</dd>
<dd>
<p>You should use the new declaration syntax instead.</p>
</dd>
<dd>
<pre>
    sub doit : locked
    {
        ...</pre>
</dd>
<dd>
<p>The <code>use attrs</code> pragma is now obsolete, and is only provided for
backward-compatibility. See <a href="perlsub.html#subroutine_attributes">Subroutine Attributes in the perlsub manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_premature_end_of_script_headers">Premature end of script headers</a></strong>

<dd>
<p>See Server error.</p>
</dd>
</li>
<dt><strong><a name="item_repeat_count_in_pack_overflows">Repeat count in pack overflows</a></strong>

<dd>
<p>(F) You can't specify a repeat count so large that it overflows
your signed integers.  See <a href="perlfunc.html#pack">pack in the perlfunc manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_repeat_count_in_unpack_overflows">Repeat count in unpack overflows</a></strong>

<dd>
<p>(F) You can't specify a repeat count so large that it overflows
your signed integers.  See <a href="perlfunc.html#unpack">unpack in the perlfunc manpage</a>.</p>
</dd>
</li>
<dt><strong><code>realloc()</code> of freed memory ignored</strong>

<dd>
<p>(S) An internal routine called <a href="#item_realloc"><code>realloc()</code></a> on something that had already
been freed.</p>
</dd>
</li>
<dt><strong><a name="item_reference_is_already_weak">Reference is already weak</a></strong>

<dd>
<p>(W misc) You have attempted to weaken a reference that is already weak.
Doing so has no effect.</p>
</dd>
</li>
<dt><strong><a name="item_setpgrp_can_27t_take_arguments">setpgrp can't take arguments</a></strong>

<dd>
<p>(F) Your system has the <code>setpgrp()</code> from BSD 4.2, which takes no arguments,
unlike POSIX setpgid(), which takes a process ID and process group ID.</p>
</dd>
</li>
<dt><strong><a name="item_strange__2a_2b_3f_7b_7d_on_zero_2dlength_expressio">Strange *+?{} on zero-length expression</a></strong>

<dd>
<p>(W regexp) You applied a regular expression quantifier in a place where it
makes no sense, such as on a zero-width assertion.
Try putting the quantifier inside the assertion instead.  For example,
the way to match ``abc'' provided that it is followed by three
repetitions of ``xyz'' is <code>/abc(?=(?:xyz){3})/</code>, not <code>/abc(?=xyz){3}/</code>.</p>
</dd>
</li>
<dt><strong><a name="item_switching_effective__25s_is_not_implemented">switching effective %s is not implemented</a></strong>

<dd>
<p>(F) While under the <code>use filetest</code> pragma, we cannot switch the
real and effective uids or gids.</p>
</dd>
</li>
<dt><strong><a name="item_elements">This Perl can't reset CRTL environ elements (%s)</a></strong>

<dt><strong>This Perl can't set CRTL environ elements (%s=%s)</strong>

<dd>
<p>(W internal) Warnings peculiar to VMS.  You tried to change or delete an element
of the CRTL's internal environ array, but your copy of Perl wasn't
built with a CRTL that contained the <code>setenv()</code> function.  You'll need to
rebuild Perl with a CRTL that does, or redefine <em>PERL_ENV_TABLES</em> (see
<a href="perlvms.html">the perlvms manpage</a>) so that the environ array isn't the target of the change to
%ENV which produced the warning.</p>
</dd>
</li>
<dt><strong><a name="item_too_late_to_run__25s_block">Too late to run %s block</a></strong>

<dd>
<p>(W void) A CHECK or INIT block is being defined during run time proper,
when the opportunity to run them has already passed.  Perhaps you are
loading a file with <code>require</code> or <code>do</code> when you should be using
<code>use</code> instead.  Or perhaps you should put the <code>require</code> or <code>do</code>
inside a BEGIN block.</p>
</dd>
</li>
<dt><strong><a name="item_open">Unknown <code>open()</code> mode '%s'</a></strong>

<dd>
<p>(F) The second argument of 3-argument <a href="#item_open"><code>open()</code></a> is not among the list
of valid modes: <code>&lt;</code>, <code>&gt;</code>, <code>&gt;&gt;</code>, <code>+&lt;</code>,
<code>+&gt;</code>, <code>+&gt;&gt;</code>, <code>-|</code>, <code>|-</code>.</p>
</dd>
</li>
<dt><strong><a name="item_unknown_process__25x_sent_message_to_prime_env_ite">Unknown process %x sent message to prime_env_iter: %s</a></strong>

<dd>
<p>(P) An error peculiar to VMS.  Perl was reading values for %ENV before
iterating over it, and someone else stuck a message in the stream of
data Perl expected.  Someone's very confused, or perhaps trying to
subvert Perl's population of %ENV for nefarious purposes.</p>
</dd>
</li>
<dt><strong><a name="item_unrecognized_escape__5c_5c_25c_passed_through">Unrecognized escape \\%c passed through</a></strong>

<dd>
<p>(W misc) You used a backslash-character combination which is not recognized
by Perl.  The character was understood literally.</p>
</dd>
</li>
<dt><strong><a name="item_unterminated_attribute_parameter_in_attribute_list">Unterminated attribute parameter in attribute list</a></strong>

<dd>
<p>(F) The lexer saw an opening (left) parenthesis character while parsing an
attribute list, but the matching closing (right) parenthesis
character was not found.  You may need to add (or remove) a backslash
character to get your parentheses to balance.  See <a href="../../attributes.html">the attributes manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_unterminated_attribute_list">Unterminated attribute list</a></strong>

<dd>
<p>(F) The lexer found something other than a simple identifier at the start
of an attribute, and it wasn't a semicolon or the start of a
block.  Perhaps you terminated the parameter list of the previous attribute
too soon.  See <a href="../../attributes.html">the attributes manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_unterminated_attribute_parameter_in_subroutine_att">Unterminated attribute parameter in subroutine attribute list</a></strong>

<dd>
<p>(F) The lexer saw an opening (left) parenthesis character while parsing a
subroutine attribute list, but the matching closing (right) parenthesis
character was not found.  You may need to add (or remove) a backslash
character to get your parentheses to balance.</p>
</dd>
</li>
<dt><strong><a name="item_unterminated_subroutine_attribute_list">Unterminated subroutine attribute list</a></strong>

<dd>
<p>(F) The lexer found something other than a simple identifier at the start
of a subroutine attribute, and it wasn't a semicolon or the start of a
block.  Perhaps you terminated the parameter list of the previous attribute
too soon.</p>
</dd>
</li>
<dt><strong><a name="item_value_of_cli_symbol__22_25s_22_too_long">Value of CLI symbol ``%s'' too long</a></strong>

<dd>
<p>(W misc) A warning peculiar to VMS.  Perl tried to read the value of an %ENV
element from a CLI symbol table, and found a resultant string longer
than 1024 characters.  The return value has been truncated to 1024
characters.</p>
</dd>
</li>
<dt><strong><a name="item_version_number_must_be_a_constant_number">Version number must be a constant number</a></strong>

<dd>
<p>(P) The attempt to translate a <code>use Module n.n LIST</code> statement into
its equivalent <code>BEGIN</code> block found an internal inconsistency with
the version number.</p>
</dd>
</li>
</dl>
<p>
</p>
<hr />
<h1><a name="new_tests">New tests</a></h1>
<dl>
<dt><strong><a name="item_lib_2fattrs">lib/attrs</a></strong>

<dd>
<p>Compatibility tests for <code>sub : attrs</code> vs the older <code>use attrs</code>.</p>
</dd>
</li>
<dt><strong><a name="item_lib_2fenv">lib/env</a></strong>

<dd>
<p>Tests for new environment scalar capability (e.g., <code>use Env qw($BAR);</code>).</p>
</dd>
</li>
<dt><strong><a name="item_lib_2fenv_2darray">lib/env-array</a></strong>

<dd>
<p>Tests for new environment array capability (e.g., <code>use Env qw(@PATH);</code>).</p>
</dd>
</li>
<dt><strong><a name="item_lib_2fio_const">lib/io_const</a></strong>

<dd>
<p>IO constants (SEEK_*, _IO*).</p>
</dd>
</li>
<dt><strong><a name="item_lib_2fio_dir">lib/io_dir</a></strong>

<dd>
<p>Directory-related IO methods (new, read, close, rewind, tied delete).</p>
</dd>
</li>
<dt><strong><a name="item_lib_2fio_multihomed">lib/io_multihomed</a></strong>

<dd>
<p>INET sockets with multi-homed hosts.</p>
</dd>
</li>
<dt><strong><a name="item_lib_2fio_poll">lib/io_poll</a></strong>

<dd>
<p>IO poll().</p>
</dd>
</li>
<dt><strong><a name="item_lib_2fio_unix">lib/io_unix</a></strong>

<dd>
<p>UNIX sockets.</p>
</dd>
</li>
<dt><strong><a name="item_op_2fattrs">op/attrs</a></strong>

<dd>
<p>Regression tests for <code>my ($x,@y,%z) : attrs</code> and &lt;sub : attrs&gt;.</p>
</dd>
</li>
<dt><strong><a name="item_op_2ffiletest">op/filetest</a></strong>

<dd>
<p>File test operators.</p>
</dd>
</li>
<dt><strong><a name="item_op_2flex_assign">op/lex_assign</a></strong>

<dd>
<p>Verify operations that access pad objects (lexicals and temporaries).</p>
</dd>
</li>
<dt><strong><a name="item_op_2fexists_sub">op/exists_sub</a></strong>

<dd>
<p>Verify <code>exists &amp;sub</code> operations.</p>
</dd>
</li>
</dl>
<p>
</p>
<hr />
<h1><a name="incompatible_changes">Incompatible Changes</a></h1>
<p>
</p>
<h2><a name="perl_source_incompatibilities">Perl Source Incompatibilities</a></h2>
<p>Beware that any new warnings that have been added or old ones
that have been enhanced are <strong>not</strong> considered incompatible changes.</p>
<p>Since all new warnings must be explicitly requested via the <code>-w</code>
switch or the <code>warnings</code> pragma, it is ultimately the programmer's
responsibility to ensure that warnings are enabled judiciously.</p>
<dl>
<dt><strong><a name="item_check_is_a_new_keyword">CHECK is a new keyword</a></strong>

<dd>
<p>All subroutine definitions named CHECK are now special.  See
<code>/&quot;Support for CHECK blocks&quot;</code> for more information.</p>
</dd>
</li>
<dt><strong><a name="item_treatment_of_list_slices_of_undef_has_changed">Treatment of list slices of undef has changed</a></strong>

<dd>
<p>There is a potential incompatibility in the behavior of list slices
that are comprised entirely of undefined values.
See <a href="#behavior_of_list_slices_is_more_consistent">Behavior of list slices is more consistent</a>.</p>
</dd>
</li>
<dt><strong><a name="item_format_of__24english_3a_3aperl_version_is_differen">Format of $English::PERL_VERSION is different</a></strong>

<dd>
<p>The English module now sets $PERL_VERSION to $^V (a string value) rather
than <code>$]</code> (a numeric value).  This is a potential incompatibility.
Send us a report via perlbug if you are affected by this.</p>
</dd>
<dd>
<p>See <a href="#improved_perl_version_numbering_system">Improved Perl version numbering system</a> for the reasons for
this change.</p>
</dd>
</li>
<dt><strong><a name="item_literals_of_the_form_1_2e2_2e3_parse_differently">Literals of the form <code>1.2.3</code> parse differently</a></strong>

<dd>
<p>Previously, numeric literals with more than one dot in them were
interpreted as a floating point number concatenated with one or more
numbers.  Such ``numbers'' are now parsed as strings composed of the
specified ordinals.</p>
</dd>
<dd>
<p>For example, <code>print 97.98.99</code> used to output <code>97.9899</code> in earlier
versions, but now prints <code>abc</code>.</p>
</dd>
<dd>
<p>See <a href="#support_for_strings_represented_as_a_vector_of_ordinals">Support for strings represented as a vector of ordinals</a>.</p>
</dd>
</li>
<dt><strong><a name="item_possibly_changed_pseudo_2drandom_number_generator">Possibly changed pseudo-random number generator</a></strong>

<dd>
<p>Perl programs that depend on reproducing a specific set of pseudo-random
numbers may now produce different output due to improvements made to the
<code>rand()</code> builtin.  You can use <code>sh Configure -Drandfunc=rand</code> to obtain
the old behavior.</p>
</dd>
<dd>
<p>See <a href="#better_pseudorandom_number_generator">Better pseudo-random number generator</a>.</p>
</dd>
</li>
<dt><strong><a name="item_hashing_function_for_hash_keys_has_changed">Hashing function for hash keys has changed</a></strong>

<dd>
<p>Even though Perl hashes are not order preserving, the apparently
random order encountered when iterating on the contents of a hash
is actually determined by the hashing algorithm used.  Improvements
in the algorithm may yield a random order that is <strong>different</strong> from
that of previous versions, especially when iterating on hashes.</p>
</dd>
<dd>
<p>See <a href="#better_worstcase_behavior_of_hashes">Better worst-case behavior of hashes</a> for additional
information.</p>
</dd>
</li>
<dt><strong><a name="item_undef_fails_on_read_only_values"><code>undef</code> fails on read only values</a></strong>

<dd>
<p>Using the <code>undef</code> operator on a readonly value (such as $1) has
the same effect as assigning <code>undef</code> to the readonly value--it
throws an exception.</p>
</dd>
</li>
<dt><strong><a name="item_close_2don_2dexec_bit_may_be_set_on_pipe_and_socke">Close-on-exec bit may be set on pipe and socket handles</a></strong>

<dd>
<p>Pipe and socket handles are also now subject to the close-on-exec
behavior determined by the special variable $^F.</p>
</dd>
<dd>
<p>See <a href="#more_consistent_closeonexec_behavior">More consistent close-on-exec behavior</a>.</p>
</dd>
</li>
<dt><strong><a name="item_writing__22_24_241_22_to_mean__22_24_7b_24_7d1_22_">Writing <code>&quot;$$1&quot;</code> to mean <code>&quot;${$}1&quot;</code> is unsupported</a></strong>

<dd>
<p>Perl 5.004 deprecated the interpretation of <code>$$1</code> and
similar within interpolated strings to mean <code>$$ . &quot;1&quot;</code>,
but still allowed it.</p>
</dd>
<dd>
<p>In Perl 5.6.0 and later, <code>&quot;$$1&quot;</code> always means <code>&quot;${$1}&quot;</code>.</p>
</dd>
</li>
<dt><strong><a name="item_delete">delete(), each(), <code>values()</code> and <code>\(%h)</code></a></strong>

<dd>
<p>operate on aliases to values, not copies</p>
</dd>
<dd>
<p>delete(), each(), <code>values()</code> and hashes (e.g. <code>\(%h)</code>)
in a list context return the actual
values in the hash, instead of copies (as they used to in earlier
versions).  Typical idioms for using these constructs copy the
returned values, but this can make a significant difference when
creating references to the returned values.  Keys in the hash are still
returned as copies when iterating on a hash.</p>
</dd>
<dd>
<p>See also <a href="#item_delete">delete(), each(), values() and hash iteration are faster</a>.</p>
</dd>
</li>
<dt><strong><a name="item_vec"><code>vec(EXPR,OFFSET,BITS)</code> enforces powers-of-two BITS</a></strong>

<dd>
<p><a href="#item_vec"><code>vec()</code></a> generates a run-time error if the BITS argument is not
a valid power-of-two integer.</p>
</dd>
</li>
<dt><strong><a name="item_text_of_some_diagnostic_output_has_changed">Text of some diagnostic output has changed</a></strong>

<dd>
<p>Most references to internal Perl operations in diagnostics
have been changed to be more descriptive.  This may be an
issue for programs that may incorrectly rely on the exact
text of diagnostics for proper functioning.</p>
</dd>
</li>
<dt><strong><a name="item___"><code>%@</code> has been removed</a></strong>

<dd>
<p>The undocumented special variable <a href="#item___"><code>%@</code></a> that used to accumulate
``background'' errors (such as those that happen in <code>DESTROY())</code>
has been removed, because it could potentially result in memory
leaks.</p>
</dd>
</li>
<dt><strong><a name="item_not">Parenthesized <code>not()</code> behaves like a list operator</a></strong>

<dd>
<p>The <a href="#item_not"><code>not</code></a> operator now falls under the ``if it looks like a function,
it behaves like a function'' rule.</p>
</dd>
<dd>
<p>As a result, the parenthesized form can be used with <code>grep</code> and <code>map</code>.
The following construct used to be a syntax error before, but it works
as expected now:</p>
</dd>
<dd>
<pre>
    grep not($_), @things;</pre>
</dd>
<dd>
<p>On the other hand, using <a href="#item_not"><code>not</code></a> with a literal list slice may not
work.  The following previously allowed construct:</p>
</dd>
<dd>
<pre>
    print not (1,2,3)[0];</pre>
</dd>
<dd>
<p>needs to be written with additional parentheses now:</p>
</dd>
<dd>
<pre>
    print not((1,2,3)[0]);</pre>
</dd>
<dd>
<p>The behavior remains unaffected when <a href="#item_not"><code>not</code></a> is not followed by parentheses.</p>
</dd>
</li>
<dt><strong><a name="item_prototype">Semantics of bareword prototype <code>(*)</code> have changed</a></strong>

<dd>
<p>The semantics of the bareword prototype <code>*</code> have changed.  Perl 5.005
always coerced simple scalar arguments to a typeglob, which wasn't useful
in situations where the subroutine must distinguish between a simple
scalar and a typeglob.  The new behavior is to not coerce bareword
arguments to a typeglob.  The value will always be visible as either
a simple scalar or as a reference to a typeglob.</p>
</dd>
<dd>
<p>See <a href="#item_prototype">More functional bareword prototype (*)</a>.</p>
</dd>
</li>
<dt><strong><a name="item_semantics_of_bit_operators_may_have_changed_on_64_">Semantics of bit operators may have changed on 64-bit platforms</a></strong>

<dd>
<p>If your platform is either natively 64-bit or if Perl has been
configured to used 64-bit integers, i.e., $Config{ivsize} is 8, 
there may be a potential incompatibility in the behavior of bitwise
numeric operators (&amp; | ^ ~ &lt;&lt; &gt;&gt;).  These operators used to strictly
operate on the lower 32 bits of integers in previous versions, but now
operate over the entire native integral width.  In particular, note
that unary <code>~</code> will produce different results on platforms that have
different $Config{ivsize}.  For portability, be sure to mask off
the excess bits in the result of unary <code>~</code>, e.g., <code>~$x &amp; 0xffffffff</code>.</p>
</dd>
<dd>
<p>See <a href="#bit_operators_support_full_native_integer_width">Bit operators support full native integer width</a>.</p>
</dd>
</li>
<dt><strong><a name="item_more_builtins_taint_their_results">More builtins taint their results</a></strong>

<dd>
<p>As described in <a href="#improved_security_features">Improved security features</a>, there may be more
sources of taint in a Perl program.</p>
</dd>
<dd>
<p>To avoid these new tainting behaviors, you can build Perl with the
Configure option <code>-Accflags=-DINCOMPLETE_TAINTS</code>.  Beware that the
ensuing perl binary may be insecure.</p>
</dd>
</li>
</dl>
<p>
</p>
<h2><a name="c_source_incompatibilities">C Source Incompatibilities</a></h2>
<dl>
<dt><strong><a name="item_perl_pollute"><code>PERL_POLLUTE</code></a></strong>

<dd>
<p>Release 5.005 grandfathered old global symbol names by providing preprocessor
macros for extension source compatibility.  As of release 5.6.0, these
preprocessor definitions are not available by default.  You need to explicitly
compile perl with <code>-DPERL_POLLUTE</code> to get these definitions.  For
extensions still using the old symbols, this option can be
specified via MakeMaker:</p>
</dd>
<dd>
<pre>
    perl Makefile.PL POLLUTE=1</pre>
</dd>
</li>
<dt><strong><a name="item_perl_implicit_context"><code>PERL_IMPLICIT_CONTEXT</code></a></strong>

<dd>
<p>This new build option provides a set of macros for all API functions
such that an implicit interpreter/thread context argument is passed to
every API function.  As a result of this, something like <code>sv_setsv(foo,bar)</code>
amounts to a macro invocation that actually translates to something like
<code>Perl_sv_setsv(my_perl,foo,bar)</code>.  While this is generally expected
to not have any significant source compatibility issues, the difference
between a macro and a real function call will need to be considered.</p>
</dd>
<dd>
<p>This means that there <strong>is</strong> a source compatibility issue as a result of
this if your extensions attempt to use pointers to any of the Perl API
functions.</p>
</dd>
<dd>
<p>Note that the above issue is not relevant to the default build of
Perl, whose interfaces continue to match those of prior versions
(but subject to the other options described here).</p>
</dd>
<dd>
<p>See <a href="perlguts.html#the_perl_api">The Perl API in the perlguts manpage</a> for detailed information on the
ramifications of building Perl with this option.</p>
</dd>
<dd>
<pre>
    NOTE: PERL_IMPLICIT_CONTEXT is automatically enabled whenever Perl is built
    with one of -Dusethreads, -Dusemultiplicity, or both.  It is not
    intended to be enabled by users at this time.</pre>
</dd>
</li>
<dt><strong><a name="item_perl_pollute_malloc"><code>PERL_POLLUTE_MALLOC</code></a></strong>

<dd>
<p>Enabling Perl's malloc in release 5.005 and earlier caused the namespace of
the system's malloc family of functions to be usurped by the Perl versions,
since by default they used the same names.  Besides causing problems on
platforms that do not allow these functions to be cleanly replaced, this
also meant that the system versions could not be called in programs that
used Perl's malloc.  Previous versions of Perl have allowed this behaviour
to be suppressed with the HIDEMYMALLOC and EMBEDMYMALLOC preprocessor
definitions.</p>
</dd>
<dd>
<p>As of release 5.6.0, Perl's malloc family of functions have default names
distinct from the system versions.  You need to explicitly compile perl with
<code>-DPERL_POLLUTE_MALLOC</code> to get the older behaviour.  HIDEMYMALLOC
and EMBEDMYMALLOC have no effect, since the behaviour they enabled is now
the default.</p>
</dd>
<dd>
<p>Note that these functions do <strong>not</strong> constitute Perl's memory allocation API.
See <a href="perlguts.html#memory_allocation">Memory Allocation in the perlguts manpage</a> for further information about that.</p>
</dd>
</li>
</dl>
<p>
</p>
<h2><a name="compatible_c_source_api_changes">Compatible C Source API Changes</a></h2>
<dl>
<dt><strong><a name="item_patchlevel_is_now_perl_version"><code>PATCHLEVEL</code> is now <code>PERL_VERSION</code></a></strong>

<dd>
<p>The cpp macros <code>PERL_REVISION</code>, <code>PERL_VERSION</code>, and <code>PERL_SUBVERSION</code>
are now available by default from perl.h, and reflect the base revision,
patchlevel, and subversion respectively.  <code>PERL_REVISION</code> had no
prior equivalent, while <code>PERL_VERSION</code> and <code>PERL_SUBVERSION</code> were
previously available as <code>PATCHLEVEL</code> and <code>SUBVERSION</code>.</p>
</dd>
<dd>
<p>The new names cause less pollution of the <strong>cpp</strong> namespace and reflect what
the numbers have come to stand for in common practice.  For compatibility,
the old names are still supported when <em>patchlevel.h</em> is explicitly
included (as required before), so there is no source incompatibility
from the change.</p>
</dd>
</li>
</dl>
<p>
</p>
<h2><a name="binary_incompatibilities">Binary Incompatibilities</a></h2>
<p>In general, the default build of this release is expected to be binary
compatible for extensions built with the 5.005 release or its maintenance
versions.  However, specific platforms may have broken binary compatibility
due to changes in the defaults used in hints files.  Therefore, please be
sure to always check the platform-specific README files for any notes to
the contrary.</p>
<p>The usethreads or usemultiplicity builds are <strong>not</strong> binary compatible
with the corresponding builds in 5.005.</p>
<p>On platforms that require an explicit list of exports (AIX, OS/2 and Windows,
among others), purely internal symbols such as parser functions and the
run time opcodes are not exported by default.  Perl 5.005 used to export
all functions irrespective of whether they were considered part of the
public API or not.</p>
<p>For the full list of public API functions, see <a href="perlapi.html">the perlapi manpage</a>.</p>
<p>
</p>
<hr />
<h1><a name="known_problems">Known Problems</a></h1>
<p>
</p>
<h2><a name="thread_test_failures">Thread test failures</a></h2>
<p>The subtests 19 and 20 of lib/thr5005.t test are known to fail due to
fundamental problems in the 5.005 threading implementation.  These are
not new failures--Perl 5.005_0x has the same bugs, but didn't have these
tests.</p>
<p>
</p>
<h2><a name="ebcdic_platforms_not_supported">EBCDIC platforms not supported</a></h2>
<p>In earlier releases of Perl, EBCDIC environments like OS390 (also
known as Open Edition MVS) and VM-ESA were supported.  Due to changes
required by the UTF-8 (Unicode) support, the EBCDIC platforms are not
supported in Perl 5.6.0.</p>
<p>
</p>
<h2><a name="in_64bit_hpux_the_lib_io_multihomed_test_may_hang">In 64-bit HP-UX the lib/io_multihomed test may hang</a></h2>
<p>The lib/io_multihomed test may hang in HP-UX if Perl has been
configured to be 64-bit.  Because other 64-bit platforms do not
hang in this test, HP-UX is suspect.  All other tests pass
in 64-bit HP-UX.  The test attempts to create and connect to
``multihomed'' sockets (sockets which have multiple IP addresses).</p>
<p>
</p>
<h2><a name="nextstep_3_3_posix_test_failure">NEXTSTEP 3.3 POSIX test failure</a></h2>
<p>In NEXTSTEP 3.3p2 the implementation of the <code>strftime(3)</code> in the
operating system libraries is buggy: the %j format numbers the days of
a month starting from zero, which, while being logical to programmers,
will cause the subtests 19 to 27 of the lib/posix test may fail.</p>
<p>
</p>
<h2><a name="tru64__aka_digital_unix__aka_dec_osf_1__lib_sdbm_test_failure_with_gcc">Tru64 (aka Digital UNIX, aka DEC OSF/1) lib/sdbm test failure with gcc</a></h2>
<p>If compiled with gcc 2.95 the lib/sdbm test will fail (dump core).
The cure is to use the vendor cc, it comes with the operating system
and produces good code.</p>
<p>
</p>
<h2><a name="unicos_mk_cc_failures_during_configure_run">UNICOS/mk CC failures during Configure run</a></h2>
<p>In UNICOS/mk the following errors may appear during the Configure run:</p>
<pre>
        Guessing which symbols your C compiler and preprocessor define...
        CC-20 cc: ERROR File = try.c, Line = 3
        ...
          bad switch yylook 79bad switch yylook 79bad switch yylook 79bad switch yylook 79#ifdef A29K
        ...
        4 errors detected in the compilation of &quot;try.c&quot;.</pre>
<p>The culprit is the broken awk of UNICOS/mk.  The effect is fortunately
rather mild: Perl itself is not adversely affected by the error, only
the h2ph utility coming with Perl, and that is rather rarely needed
these days.</p>
<p>
</p>
<h2><a name="arrow_operator_and_arrays">Arrow operator and arrays</a></h2>
<p>When the left argument to the arrow operator <code>-&gt;</code> is an array, or
the <code>scalar</code> operator operating on an array, the result of the
operation must be considered erroneous. For example:</p>
<pre>
    @x-&gt;[2]
    scalar(@x)-&gt;[2]</pre>
<p>These expressions will get run-time errors in some future release of
Perl.</p>
<p>
</p>
<h2><a name="experimental_features">Experimental features</a></h2>
<p>As discussed above, many features are still experimental.  Interfaces and
implementation of these features are subject to change, and in extreme cases,
even subject to removal in some future release of Perl.  These features
include the following:</p>
<dl>
<dt><strong><a name="item_threads">Threads</a></strong>

<dt><strong><a name="item_unicode">Unicode</a></strong>

<li><strong><a name="item__2dbit_support">-bit support</a></strong>

<dt><strong><a name="item_lvalue_subroutines">Lvalue subroutines</a></strong>

<dt><strong><a name="item_weak_references">Weak references</a></strong>

<dt><strong><a name="item_the_pseudo_2dhash_data_type">The pseudo-hash data type</a></strong>

<dt><strong><a name="item_the_compiler_suite">The Compiler suite</a></strong>

<dt><strong><a name="item_internal_implementation_of_file_globbing">Internal implementation of file globbing</a></strong>

<dt><strong><a name="item_the_db_module">The DB module</a></strong>

<dt><strong><a name="item_the_regular_expression_code_constructs_3a">The regular expression code constructs:</a></strong>

<dd>
<p><code>(?{ code })</code> and <code>(??{ code })</code></p>
</dd>
</li>
</dl>
<p>
</p>
<hr />
<h1><a name="obsolete_diagnostics">Obsolete Diagnostics</a></h1>
<dl>
<dt><strong><a name="item_character_class_syntax__5b_3a__3a_5d_is_reserved_f">Character class syntax [: :] is reserved for future extensions</a></strong>

<dd>
<p>(W) Within regular expression character classes ([]) the syntax beginning
with ``[:'' and ending with ``:]'' is reserved for future extensions.
If you need to represent those character sequences inside a regular
expression character class, just quote the square brackets with the
backslash: ``\[:'' and ``:\]''.</p>
</dd>
</li>
<dt><strong><a name="item_ill_2dformed_logical_name__7c_25s_7c_in_prime_env_">Ill-formed logical name |%s| in prime_env_iter</a></strong>

<dd>
<p>(W) A warning peculiar to VMS.  A logical name was encountered when preparing
to iterate over %ENV which violates the syntactic rules governing logical
names.  Because it cannot be translated normally, it is skipped, and will not
appear in %ENV.  This may be a benign occurrence, as some software packages
might directly modify logical name tables and introduce nonstandard names,
or it may indicate that a logical name table has been corrupted.</p>
</dd>
</li>
<dt><strong><a name="item_in_string_2c__40_25s_now_must_be_written_as__5c_40">In string, @%s now must be written as \@%s</a></strong>

<dd>
<p>The description of this error used to say:</p>
</dd>
<dd>
<pre>
        (Someday it will simply assume that an unbackslashed @
         interpolates an array.)</pre>
</dd>
<dd>
<p>That day has come, and this fatal error has been removed.  It has been
replaced by a non-fatal warning instead.
See <a href="#arrays_now_always_interpolate_into_doublequoted_strings">Arrays now always interpolate into double-quoted strings</a> for
details.</p>
</dd>
</li>
<dt><strong><a name="item_probable_precedence_problem_on__25s">Probable precedence problem on %s</a></strong>

<dd>
<p>(W) The compiler found a bareword where it expected a conditional,
which often indicates that an || or &amp;&amp; was parsed as part of the
last argument of the previous construct, for example:</p>
</dd>
<dd>
<pre>
    open FOO || die;</pre>
</dd>
</li>
<dt><strong><a name="item_regexp_too_big">regexp too big</a></strong>

<dd>
<p>(F) The current implementation of regular expressions uses shorts as
address offsets within a string.  Unfortunately this means that if
the regular expression compiles to longer than 32767, it'll blow up.
Usually when you want a regular expression this big, there is a better
way to do it with multiple statements.  See <a href="perlre.html">the perlre manpage</a>.</p>
</dd>
</li>
<dt><strong><a name="item_use_of__22_24_24_3cdigit_3e_22_to_mean__22_24_7b_2">Use of ``$$&lt;digit&gt;'' to mean ``${$}&lt;digit&gt;'' is deprecated</a></strong>

<dd>
<p>(D) Perl versions before 5.004 misinterpreted any type marker followed
by ``$'' and a digit.  For example, ``$$0'' was incorrectly taken to mean
``${$}0'' instead of ``${$0}''.  This bug is (mostly) fixed in Perl 5.004.</p>
</dd>
<dd>
<p>However, the developers of Perl 5.004 could not fix this bug completely,
because at least two widely-used modules depend on the old meaning of
``$$0'' in a string.  So Perl 5.004 still interprets ``$$&lt;digit&gt;'' in the
old (broken) way inside strings; but it generates this message as a
warning.  And in Perl 5.005, this special treatment will cease.</p>
</dd>
</li>
</dl>
<p>
</p>
<hr />
<h1><a name="reporting_bugs">Reporting Bugs</a></h1>
<p>If you find what you think is a bug, you might check the
articles recently posted to the comp.lang.perl.misc newsgroup.
There may also be information at <a href="http://www.perl.com/perl/">http://www.perl.com/perl/</a> , the Perl
Home Page.</p>
<p>If you believe you have an unreported bug, please run the <strong>perlbug</strong>
program included with your release.  Be sure to trim your bug down
to a tiny but sufficient test case.  Your bug report, along with the
output of <code>perl -V</code>, will be sent off to <a href="mailto:perlbug@perl.org">perlbug@perl.org</a> to be
analysed by the Perl porting team.</p>
<p>
</p>
<hr />
<h1><a name="see_also">SEE ALSO</a></h1>
<p>The <em>Changes</em> file for exhaustive details on what changed.</p>
<p>The <em>INSTALL</em> file for how to build Perl.</p>
<p>The <em>README</em> file for general stuff.</p>
<p>The <em>Artistic</em> and <em>Copying</em> files for copyright information.</p>
<p>
</p>
<hr />
<h1><a name="history">HISTORY</a></h1>
<p>Written by Gurusamy Sarathy &lt;<em><a href="mailto:gsar@activestate.com">gsar@activestate.com</a></em>&gt;, with many
contributions from The Perl Porters.</p>
<p>Send omissions or corrections to &lt;<em><a href="mailto:perlbug@perl.org">perlbug@perl.org</a></em>&gt;.</p>
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;perl56delta - what's new for perl v5.6.0</span></strong></big>
</td></tr>
</table>

</body>

</html>
