<?xml version="1.0" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>README.freebsd - Perl version 5 on FreeBSD systems</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rev="made" href="mailto:root@localhost" />
</head>

<body style="background-color: white">
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;README.freebsd - Perl version 5 on FreeBSD systems</span></strong></big>
</td></tr>
</table>

<p><a name="__index__"></a></p>
<!-- INDEX BEGIN -->

<ul>

	<li><a href="#name">NAME</a></li>
	<li><a href="#description">DESCRIPTION</a></li>
	<ul>

		<li><a href="#freebsd_core_dumps_from_readdir_r_with_ithreads">FreeBSD core dumps from readdir_r with ithreads</a></li>
		<li><a href="#__x_doesn_t_always_contain_a_full_path_in_freebsd">$^X doesn't always contain a full path in FreeBSD</a></li>
		<li><a href="#perl_will_no_longer_be_part_of_base_freebsd">Perl will no longer be part of ``base FreeBSD''</a></li>
	</ul>

	<li><a href="#author">AUTHOR</a></li>
</ul>
<!-- INDEX END -->

<hr />
<p>
</p>
<h1><a name="name">NAME</a></h1>
<p>README.freebsd - Perl version 5 on FreeBSD systems</p>
<p>
</p>
<hr />
<h1><a name="description">DESCRIPTION</a></h1>
<p>This document describes various features of FreeBSD that will affect how Perl
version 5 (hereafter just Perl) is compiled and/or runs.</p>
<p>
</p>
<h2><a name="freebsd_core_dumps_from_readdir_r_with_ithreads">FreeBSD core dumps from readdir_r with ithreads</a></h2>
<p>When perl is configured to use ithreads, it will use re-entrant library calls
in preference to non-re-entrant versions.  There is a bug in FreeBSD's
<code>readdir_r</code> function in versions 4.5 and earlier that can cause a SEGV when
reading large directories. A patch for FreeBSD libc is available
(see <a href="http://www.freebsd.org/cgi/query-pr.cgi?pr=misc/30631">http://www.freebsd.org/cgi/query-pr.cgi?pr=misc/30631</a> )
which has been integrated into FreeBSD 4.6.</p>
<p>
</p>
<h2><a name="__x_doesn_t_always_contain_a_full_path_in_freebsd">$^X doesn't always contain a full path in FreeBSD</a></h2>
<p>perl 5.8.0 sets <code>$^X</code> where possible to a full path by asking the operating
system. On FreeBSD the full path of the perl interpreter is found by reading
the symlink <em>/proc/curproc/file</em>. There is a bug on FreeBSD, where the
result of reading this symlink is can be wrong in certain circumstances
(see <a href="http://www.freebsd.org/cgi/query-pr.cgi?pr=35703">http://www.freebsd.org/cgi/query-pr.cgi?pr=35703</a> ).
In these cases perl will fall back to the old behaviour of using C's
argv[0] value for <code>$^X</code>.</p>
<p>
</p>
<h2><a name="perl_will_no_longer_be_part_of_base_freebsd">Perl will no longer be part of ``base FreeBSD''</a></h2>
<p>Not as bad as it sounds--what this means is that Perl will no longer be
part of the <strong>kernel build system</strong> of FreeBSD.  Perl will still very
probably be part of the ``default install'', and in any case the latest
version will be in the ports system.  The first FreeBSD version this
change will affect is 5.0, all 4.n versions will keep the status quo.</p>
<p>
</p>
<hr />
<h1><a name="author">AUTHOR</a></h1>
<p>Nicholas Clark &lt;<a href="mailto:nick@ccl4.org">nick@ccl4.org</a>&gt;, collating wisdom supplied by Slaven Rezic
and Tim Bunce.</p>
<p>Please report any errors, updates, or suggestions to <em><a href="mailto:perlbug@perl.org">perlbug@perl.org</a></em>.</p>
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;README.freebsd - Perl version 5 on FreeBSD systems</span></strong></big>
</td></tr>
</table>

</body>

</html>
