<?xml version="1.0" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>README.machten - Perl version 5 on Power MachTen systems</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rev="made" href="mailto:root@localhost" />
</head>

<body style="background-color: white">
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;README.machten - Perl version 5 on Power MachTen systems</span></strong></big>
</td></tr>
</table>

<p><a name="__index__"></a></p>
<!-- INDEX BEGIN -->

<ul>

	<li><a href="#name">NAME</a></li>
	<li><a href="#description">DESCRIPTION</a></li>
	<ul>

		<li><a href="#perl_version_5_8_x_and_greater_not_supported">Perl version 5.8.x and greater not supported</a></li>
		<li><a href="#compiling_perl_5_6_x_on_machten">Compiling Perl 5.6.x on MachTen</a></li>
		<li><a href="#failures_during_make_test_on_machten">Failures during <code>make test</code> on MachTen</a></li>
		<li><a href="#building_external_modules_on_machten">Building external modules on MachTen</a></li>
	</ul>

	<li><a href="#author">AUTHOR</a></li>
	<li><a href="#date">DATE</a></li>
</ul>
<!-- INDEX END -->

<hr />
<p>
</p>
<h1><a name="name">NAME</a></h1>
<p>README.machten - Perl version 5 on Power MachTen systems</p>
<p>
</p>
<hr />
<h1><a name="description">DESCRIPTION</a></h1>
<p>This document describes how to build Perl 5 on Power MachTen systems,
and discusses a few wrinkles in the implementation.</p>
<p>
</p>
<h2><a name="perl_version_5_8_x_and_greater_not_supported">Perl version 5.8.x and greater not supported</a></h2>
<p><strong>Power MachTen is not supported by versions of Perl later than
5.6.x.</strong>
If you wish to build a version from the 5.6 track, please
obtain a source distribution from the archive at
<a href="http://cpan.org/src/5.0/">http://cpan.org/src/5.0/</a> and follow the instructions in its
README.machten file.</p>
<p>MachTen is no longer supported by its developers, Tenon Intersystems.
A UNIX environment hosted on Mac OS Classic, MachTen has been
superseded by Mac OS X and by BSD and Linux implementations for Macintosh
hardware.
The final version of Power MachTen, 4.1.4, lacks many features found in
modern implementations of UNIX, and has a number of bugs.
These shortcomings prevent recent versions of Perl from being able to use
extensions on MachTen, and cause numerous test suite failures in the
perl core.</p>
<p>In September 2003, a discussion on the MachTen mailing list determined
that there was no interest in making a later version of Perl build
successfully on MachTen.
Consequently, support for building Perl under MachTen has been suppressed
in Perl distributions published after February 2004.
The hints file, <em>hints/machten.sh</em>, remains a part of the
distributions for reference purposes.</p>
<p>
</p>
<h2><a name="compiling_perl_5_6_x_on_machten">Compiling Perl 5.6.x on MachTen</a></h2>
<p>To compile perl 5.6.x under MachTen 4.1.4 (and probably earlier versions):</p>
<pre>
  ./Configure -de
  make
  make test
  make install</pre>
<p>This builds and installs a statically-linked perl; MachTen's dynamic
linking facilities are not adequate to support Perl's use of
dynamically linked libraries.  (See <em>hints/machten.sh</em> for more
information.)</p>
<p>You should have at least 32 megabytes of free memory on your
system before running the <code>make</code> command.</p>
<p>For much more information on building perl -- for example, on how to
change the default installation directory -- see <em>INSTALL</em>.</p>
<p>
</p>
<h2><a name="failures_during_make_test_on_machten">Failures during <code>make test</code> on MachTen</a></h2>
<dl>
<dt><strong><a name="item_op_2flexassign_2et">op/lexassign.t</a></strong>

<dd>
<p>This test may fail when first run after building perl.  It does not
fail subsequently.  The cause is unknown.</p>
</dd>
</li>
<dt><strong><a name="item_pragma_2fwarnings_2et">pragma/warnings.t</a></strong>

<dd>
<p>Test 257 fails due to a failure to warn about attempts to read from a
filehandle which is a duplicate of stdout when stdout is attached to a
pipe.  The output of the test contains a block comment which discusses
a different failure, not applicable to MachTen.</p>
</dd>
<dd>
<p>The root of the problem is that Machten does not assign a file type to
either end of a pipe (see <a href="../../File/stat.html">the stat manpage</a>), resulting, among other things
in Perl's <code>-p</code> test failing on file descriptors belonging to pipes.
As a result, perl becomes confused, and the test for reading from a
write-only file fails.  I am reluctant to patch perl to get around
this, as it's clearly an OS bug (about which Tenon has been informed),
and limited in its effect on practical Perl programs.</p>
</dd>
</li>
</dl>
<p>
</p>
<h2><a name="building_external_modules_on_machten">Building external modules on MachTen</a></h2>
<p>To add an external module to perl, build in the normal way, which
is documented in <a href="../../ExtUtils/MakeMaker.html">the ExtUtils::MakeMaker manpage</a>, or which can be driven
automatically by the CPAN module (see <a href="../../CPAN.html">the CPAN manpage</a>), which is part of the
standard distribution.  If you want to install a module which
contains XS code (C or C++ source which compiles to object code
for linking with perl), you will have to replace your perl binary with
a new version containing the new statically-linked object module.  The
build process tells you how to do this.</p>
<p>There is a gotcha, however, which users usually encounter immediately
they respond to CPAN's invitation to <code>install Bundle::CPAN</code>. When
installing a <em>bundle</em> -- a group of modules which together achieve
some particular purpose, the installation process for later modules in
the bundle tends to assume that earlier modules have been fully
installed and are available for use.  This is not true on a
statically-linked system for earlier modules which contain XS code.
As a result the installation of the bundle fails.  The work-around is
not to install the bundle as a one-shot operation, but instead to see
what modules it contains, and install these one-at-a-time by hand in
the order given.</p>
<p>
</p>
<hr />
<h1><a name="author">AUTHOR</a></h1>
<p>Dominic Dunlop &lt;<a href="mailto:domo@computer.org">domo@computer.org</a>&gt;</p>
<p>
</p>
<hr />
<h1><a name="date">DATE</a></h1>
<p>Version 1.1.0 2004-02-13</p>
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;README.machten - Perl version 5 on Power MachTen systems</span></strong></big>
</td></tr>
</table>

</body>

</html>
