<?xml version="1.0" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>perlnetware - Perl for NetWare</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rev="made" href="mailto:root@localhost" />
</head>

<body style="background-color: white">
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;perlnetware - Perl for NetWare</span></strong></big>
</td></tr>
</table>

<p><a name="__index__"></a></p>
<!-- INDEX BEGIN -->

<ul>

	<li><a href="#name">NAME</a></li>
	<li><a href="#description">DESCRIPTION</a></li>
	<li><a href="#build">BUILD</a></li>
	<ul>

		<li><a href="#tools___sdk">Tools &amp; SDK</a></li>
		<li><a href="#setup">Setup</a></li>
		<li><a href="#make">Make</a></li>
		<li><a href="#interpreter">Interpreter</a></li>
		<li><a href="#extensions">Extensions</a></li>
	</ul>

	<li><a href="#install">INSTALL</a></li>
	<li><a href="#build_new_extensions">BUILD NEW EXTENSIONS</a></li>
	<li><a href="#acknowledgements">ACKNOWLEDGEMENTS</a></li>
	<li><a href="#authors">AUTHORS</a></li>
	<li><a href="#date">DATE</a></li>
</ul>
<!-- INDEX END -->

<hr />
<p>
</p>
<h1><a name="name">NAME</a></h1>
<p>perlnetware - Perl for NetWare</p>
<p>
</p>
<hr />
<h1><a name="description">DESCRIPTION</a></h1>
<p>This file gives instructions for building Perl 5.7 and above, and also 
Perl modules for NetWare. Before you start, you may want to read the
README file found in the top level directory into which the Perl source
code distribution was extracted. Make sure you read and understand
the terms under which the software is being distributed.</p>
<p>
</p>
<hr />
<h1><a name="build">BUILD</a></h1>
<p>This section describes the steps to be performed to build a Perl NLM
and other associated NLMs.</p>
<p>
</p>
<h2><a name="tools___sdk">Tools &amp; SDK</a></h2>
<p>The build requires CodeWarrior compiler and linker.  In addition,
the ``NetWare SDK'', ``NLM &amp; NetWare Libraries for C'' and
``NetWare Server Protocol Libraries for C'', all available at
<a href="http://developer.novell.com/ndk/">http://developer.novell.com/ndk/</a>, are also required.
Microsoft Visual C++ version 4.2 or later is also required.</p>
<p>
</p>
<h2><a name="setup">Setup</a></h2>
<p>The build process is dependent on the location of the NetWare SDK.
Once the Tools &amp; SDK are installed, the build environment has to
be setup.  The following batch files setup the environment.</p>
<dl>
<dt><strong><a name="item_setnwbld_2ebat">SetNWBld.bat</a></strong>

<dd>
<p>The Execution of this file takes 2 parameters as input. The first
being the NetWare SDK path, second being the path for CodeWarrior
Compiler &amp; tools. Execution of this file sets these paths and also
sets the build type to Release by default.</p>
</dd>
</li>
<dt><strong><a name="item_buildtype_2ebat">Buildtype.bat</a></strong>

<dd>
<p>This is used to set the build type to debug or release. Change the
build type only after executing SetNWBld.bat</p>
</dd>
</li>
<li>
<p>Example:
  1. Typing ``buildtype d on'' at the command prompt causes the buildtype
     to be set to Debug type with D2 flag set. 
  2. Typing ``buildtype d off'' or ``buildtype d'' at the command prompt causes
     the buildtype to be set to Debug type with D1 flag set. 
  2. Typing ``buildtype r'' at the command prompt sets it to Release Build type.</p>
</li>
</dl>
<p>
</p>
<h2><a name="make">Make</a></h2>
<p>The make process runs only under WinNT shell.  The NetWare makefile is
located under the NetWare folder.  This makes use of miniperl.exe to
run some of the Perl scripts. To create miniperl.exe, first set the
required paths for Visual c++ compilier (specify vcvars32 location) at
the command prompt.  Then run nmake from win32 folder through WinNT
command prompt.  The build process can be stopped after miniperl.exe
is created. Then run nmake from NetWare folder through WinNT command
prompt.</p>
<p>Currently the following two build types are tested on NetWare:</p>
<ul>
<li>
<p>USE_MULTI, USE_ITHREADS &amp; USE_IMP_SYS defined</p>
</li>
<li>
<p>USE_MULTI &amp; USE_IMP_SYS defined and USE_ITHREADS not defined</p>
</li>
</ul>
<p>
</p>
<h2><a name="interpreter">Interpreter</a></h2>
<p>Once miniperl.exe creation is over, run nmake from the NetWare folder.
This will build the Perl interpreter for NetWare as <em>perl.nlm</em>.
This is copied under the <em>Release</em> folder if you are doing
a release build, else will be copied under <em>Debug</em> folder for debug builds.</p>
<p>
</p>
<h2><a name="extensions">Extensions</a></h2>
<p>The make process also creates the Perl extensions as <em>&lt;Extension</em>.nlm&gt;</p>
<p>
</p>
<hr />
<h1><a name="install">INSTALL</a></h1>
<p>To install NetWare Perl onto a NetWare server, first map the Sys
volume of a NetWare server to <em>i:</em>. This is because the makefile by
default sets the drive letter to <em>i:</em>.  Type <em>nmake nwinstall</em> from
NetWare folder on a WinNT command prompt.  This will copy the binaries
and module files onto the NetWare server under <em>sys:\Perl</em>
folder. The Perl interpreter, <em>perl.nlm</em>, is copied under
<em>sys:\perl\system</em> folder.  Copy this to <em>sys:\system</em> folder.</p>
<p>Example: At the command prompt Type ``nmake nwinstall''.
          This will install NetWare Perl on the NetWare Server.
          Similiarly if you type ``nmake install'',
          This will cause the binaries to be installed on the local machine.
          (Typically under the c:\perl folder)</p>
<p>
</p>
<hr />
<h1><a name="build_new_extensions">BUILD NEW EXTENSIONS</a></h1>
<p>To build extensions other than standard extensions, NetWare Perl has
to be installed on Windows along with Windows Perl. The Perl for
Windows can be either downloaded from the CPAN site and built using
the sources, or the binaries can be directly downloaded from the
ActiveState site.  Installation can be done by invoking <em>nmake
install</em> from the NetWare folder on a WinNT command prompt after
building NetWare Perl by following steps given above.  This will copy
all the *.pm files and other required files.  Documentation files are
not copied.  Thus one must first install Windows Perl, Then install
NetWare Perl.</p>
<p>Once this is done, do the following to build any extension:</p>
<ul>
<li>
<p>Change to the extension directory where its source files are present.</p>
</li>
<li>
<p>Run the following command at the command prompt:</p>
<pre>
    perl -II&lt;path to NetWare lib dir&gt; -II&lt;path to lib&gt; Makefile.pl</pre>
<p>Example:</p>
<pre>
    perl -Ic:/perl/5.6.1/lib/NetWare-x86-multi-thread -Ic:\perl\5.6.1\lib MakeFile.pl</pre>
<p>or</p>
<pre>
    perl -Ic:/perl/5.8.0/lib/NetWare-x86-multi-thread -Ic:\perl\5.8.0\lib MakeFile.pl</pre>
</li>
<li>
<p>nmake</p>
</li>
<li>
<p>nmake install</p>
<p>Install will copy the files into the Windows machine where NetWare
Perl is installed and these files may have to be copied to the NetWare
server manually. Alternatively, pass <em>INSTALLSITELIB=i:\perl\lib</em> as
an input to makefile.pl above. Here <em>i:</em> is the mapped drive to the
sys: volume of the server where Perl on NetWare is installed. Now
typing <em>nmake install</em>, will copy the files onto the NetWare server.</p>
<p>Example: You can execute the following on the command prompt.</p>
<pre>
          perl -Ic:/perl/5.6.1/lib/NetWare-x86-multi-thread -Ic:\perl\5.6.1\lib MakeFile.pl
          INSTALLSITELIB=i:\perl\lib</pre>
<p>or</p>
<pre>
          perl -Ic:/perl/5.8.0/lib/NetWare-x86-multi-thread -Ic:\perl\5.8.0\lib MakeFile.pl
          INSTALLSITELIB=i:\perl\lib</pre>
</li>
<li>
<p>Note: Some modules downloaded from CPAN may require NetWare related
API in order to build on NetWare.  Other modules may however build
smoothly with or without minor changes depending on the type of
module.</p>
</li>
</ul>
<p>
</p>
<hr />
<h1><a name="acknowledgements">ACKNOWLEDGEMENTS</a></h1>
<p>The makefile for Win32 is used as a reference to create the makefile
for NetWare.  Also, the make process for NetWare port uses
miniperl.exe to run scripts during the make and installation process.</p>
<p>
</p>
<hr />
<h1><a name="authors">AUTHORS</a></h1>
<p>Anantha Kesari H Y (<a href="mailto:hyanantha@novell.com">hyanantha@novell.com</a>)
Aditya C (<a href="mailto:caditya@novell.com">caditya@novell.com</a>)</p>
<p>
</p>
<hr />
<h1><a name="date">DATE</a></h1>
<ul>
<li>
<p>Created - 18 Jan 2001</p>
</li>
<li>
<p>Modified - 25 June 2001</p>
</li>
<li>
<p>Modified - 13 July 2001</p>
</li>
<li>
<p>Modified - 28 May 2002</p>
</li>
</ul>
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;perlnetware - Perl for NetWare</span></strong></big>
</td></tr>
</table>

</body>

</html>
