<?xml version="1.0" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>perlothrtut - old tutorial on threads in Perl</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rev="made" href="mailto:root@localhost" />
</head>

<body style="background-color: white">
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;perlothrtut - old tutorial on threads in Perl</span></strong></big>
</td></tr>
</table>

<p><a name="__index__"></a></p>
<!-- INDEX BEGIN -->

<ul>

	<li><a href="#name">NAME</a></li>
	<li><a href="#description">DESCRIPTION</a></li>
	<li><a href="#what_is_a_thread_anyway">What Is A Thread Anyway?</a></li>
	<li><a href="#threaded_program_models">Threaded Program Models</a></li>
	<ul>

		<li><a href="#boss_worker">Boss/Worker</a></li>
		<li><a href="#work_crew">Work Crew</a></li>
		<li><a href="#pipeline">Pipeline</a></li>
	</ul>

	<li><a href="#native_threads">Native threads</a></li>
	<li><a href="#what_kind_of_threads_are_perl_threads">What kind of threads are perl threads?</a></li>
	<li><a href="#threadsafe_modules">Threadsafe Modules</a></li>
	<li><a href="#thread_basics">Thread Basics</a></li>
	<ul>

		<li><a href="#basic_thread_support">Basic Thread Support</a></li>
		<li><a href="#creating_threads">Creating Threads</a></li>
		<li><a href="#giving_up_control">Giving up control</a></li>
		<li><a href="#waiting_for_a_thread_to_exit">Waiting For A Thread To Exit</a></li>
		<li><a href="#errors_in_threads">Errors In Threads</a></li>
		<li><a href="#ignoring_a_thread">Ignoring A Thread</a></li>
	</ul>

	<li><a href="#threads_and_data">Threads And Data</a></li>
	<ul>

		<li><a href="#shared_and_unshared_data">Shared And Unshared Data</a></li>
		<li><a href="#thread_pitfall__races">Thread Pitfall: Races</a></li>
		<li><a href="#controlling_access__lock__">Controlling access: <code>lock()</code></a></li>
		<li><a href="#thread_pitfall__deadlocks">Thread Pitfall: Deadlocks</a></li>
		<li><a href="#queues__passing_data_around">Queues: Passing Data Around</a></li>
	</ul>

	<li><a href="#threads_and_code">Threads And Code</a></li>
	<ul>

		<li><a href="#semaphores__synchronizing_data_access">Semaphores: Synchronizing Data Access</a></li>
		<li><a href="#attributes__restricting_access_to_subroutines">Attributes: Restricting Access To Subroutines</a></li>
		<li><a href="#subroutine_locks">Subroutine Locks</a></li>
		<li><a href="#methods">Methods</a></li>
		<li><a href="#locking_a_subroutine">Locking A Subroutine</a></li>
	</ul>

	<li><a href="#general_thread_utility_routines">General Thread Utility Routines</a></li>
	<ul>

		<li><a href="#what_thread_am_i_in">What Thread Am I In?</a></li>
		<li><a href="#thread_ids">Thread IDs</a></li>
		<li><a href="#are_these_threads_the_same">Are These Threads The Same?</a></li>
		<li><a href="#what_threads_are_running">What Threads Are Running?</a></li>
	</ul>

	<li><a href="#a_complete_example">A Complete Example</a></li>
	<li><a href="#conclusion">Conclusion</a></li>
	<li><a href="#bibliography">Bibliography</a></li>
	<ul>

		<li><a href="#introductory_texts">Introductory Texts</a></li>
		<li><a href="#osrelated_references">OS-Related References</a></li>
		<li><a href="#other_references">Other References</a></li>
	</ul>

	<li><a href="#acknowledgements">Acknowledgements</a></li>
	<li><a href="#author">AUTHOR</a></li>
	<li><a href="#copyrights">Copyrights</a></li>
</ul>
<!-- INDEX END -->

<hr />
<p>
</p>
<h1><a name="name">NAME</a></h1>
<p>perlothrtut - old tutorial on threads in Perl</p>
<p>
</p>
<hr />
<h1><a name="description">DESCRIPTION</a></h1>
<p><strong>WARNING</strong>:
This tutorial describes the old-style thread model that was introduced in
release 5.005. This model is now deprecated, and will be removed, probably
in version 5.10. The interfaces described here were considered
experimental, and are likely to be buggy.</p>
<p>For information about the new interpreter threads (``ithreads'') model, see
the <em>perlthrtut</em> tutorial, and the <a href="../../threads.html">the threads manpage</a> and <a href="../../threads/shared.html">the threads::shared manpage</a>
modules.</p>
<p>You are strongly encouraged to migrate any existing threads code to the
new model as soon as possible.</p>
<p>
</p>
<hr />
<h1><a name="what_is_a_thread_anyway">What Is A Thread Anyway?</a></h1>
<p>A thread is a flow of control through a program with a single
execution point.</p>
<p>Sounds an awful lot like a process, doesn't it? Well, it should.
Threads are one of the pieces of a process.  Every process has at least
one thread and, up until now, every process running Perl had only one
thread.  With 5.005, though, you can create extra threads.  We're going
to show you how, when, and why.</p>
<p>
</p>
<hr />
<h1><a name="threaded_program_models">Threaded Program Models</a></h1>
<p>There are three basic ways that you can structure a threaded
program.  Which model you choose depends on what you need your program
to do.  For many non-trivial threaded programs you'll need to choose
different models for different pieces of your program.</p>
<p>
</p>
<h2><a name="boss_worker">Boss/Worker</a></h2>
<p>The boss/worker model usually has one `boss' thread and one or more
`worker' threads.  The boss thread gathers or generates tasks that need
to be done, then parcels those tasks out to the appropriate worker
thread.</p>
<p>This model is common in GUI and server programs, where a main thread
waits for some event and then passes that event to the appropriate
worker threads for processing.  Once the event has been passed on, the
boss thread goes back to waiting for another event.</p>
<p>The boss thread does relatively little work.  While tasks aren't
necessarily performed faster than with any other method, it tends to
have the best user-response times.</p>
<p>
</p>
<h2><a name="work_crew">Work Crew</a></h2>
<p>In the work crew model, several threads are created that do
essentially the same thing to different pieces of data.  It closely
mirrors classical parallel processing and vector processors, where a
large array of processors do the exact same thing to many pieces of
data.</p>
<p>This model is particularly useful if the system running the program
will distribute multiple threads across different processors.  It can
also be useful in ray tracing or rendering engines, where the
individual threads can pass on interim results to give the user visual
feedback.</p>
<p>
</p>
<h2><a name="pipeline">Pipeline</a></h2>
<p>The pipeline model divides up a task into a series of steps, and
passes the results of one step on to the thread processing the
next.  Each thread does one thing to each piece of data and passes the
results to the next thread in line.</p>
<p>This model makes the most sense if you have multiple processors so two
or more threads will be executing in parallel, though it can often
make sense in other contexts as well.  It tends to keep the individual
tasks small and simple, as well as allowing some parts of the pipeline
to block (on I/O or system calls, for example) while other parts keep
going.  If you're running different parts of the pipeline on different
processors you may also take advantage of the caches on each
processor.</p>
<p>This model is also handy for a form of recursive programming where,
rather than having a subroutine call itself, it instead creates
another thread.  Prime and Fibonacci generators both map well to this
form of the pipeline model. (A version of a prime number generator is
presented later on.)</p>
<p>
</p>
<hr />
<h1><a name="native_threads">Native threads</a></h1>
<p>There are several different ways to implement threads on a system.  How
threads are implemented depends both on the vendor and, in some cases,
the version of the operating system.  Often the first implementation
will be relatively simple, but later versions of the OS will be more
sophisticated.</p>
<p>While the information in this section is useful, it's not necessary,
so you can skip it if you don't feel up to it.</p>
<p>There are three basic categories of threads-user-mode threads, kernel
threads, and multiprocessor kernel threads.</p>
<p>User-mode threads are threads that live entirely within a program and
its libraries.  In this model, the OS knows nothing about threads.  As
far as it's concerned, your process is just a process.</p>
<p>This is the easiest way to implement threads, and the way most OSes
start.  The big disadvantage is that, since the OS knows nothing about
threads, if one thread blocks they all do.  Typical blocking activities
include most system calls, most I/O, and things like sleep().</p>
<p>Kernel threads are the next step in thread evolution.  The OS knows
about kernel threads, and makes allowances for them.  The main
difference between a kernel thread and a user-mode thread is
blocking.  With kernel threads, things that block a single thread don't
block other threads.  This is not the case with user-mode threads,
where the kernel blocks at the process level and not the thread level.</p>
<p>This is a big step forward, and can give a threaded program quite a
performance boost over non-threaded programs.  Threads that block
performing I/O, for example, won't block threads that are doing other
things.  Each process still has only one thread running at once,
though, regardless of how many CPUs a system might have.</p>
<p>Since kernel threading can interrupt a thread at any time, they will
uncover some of the implicit locking assumptions you may make in your
program.  For example, something as simple as <code>$a = $a + 2</code> can behave
unpredictably with kernel threads if $a is visible to other
threads, as another thread may have changed $a between the time it
was fetched on the right hand side and the time the new value is
stored.</p>
<p>Multiprocessor Kernel Threads are the final step in thread
support.  With multiprocessor kernel threads on a machine with multiple
CPUs, the OS may schedule two or more threads to run simultaneously on
different CPUs.</p>
<p>This can give a serious performance boost to your threaded program,
since more than one thread will be executing at the same time.  As a
tradeoff, though, any of those nagging synchronization issues that
might not have shown with basic kernel threads will appear with a
vengeance.</p>
<p>In addition to the different levels of OS involvement in threads,
different OSes (and different thread implementations for a particular
OS) allocate CPU cycles to threads in different ways.</p>
<p>Cooperative multitasking systems have running threads give up control
if one of two things happen.  If a thread calls a yield function, it
gives up control.  It also gives up control if the thread does
something that would cause it to block, such as perform I/O.  In a
cooperative multitasking implementation, one thread can starve all the
others for CPU time if it so chooses.</p>
<p>Preemptive multitasking systems interrupt threads at regular intervals
while the system decides which thread should run next.  In a preemptive
multitasking system, one thread usually won't monopolize the CPU.</p>
<p>On some systems, there can be cooperative and preemptive threads
running simultaneously. (Threads running with realtime priorities
often behave cooperatively, for example, while threads running at
normal priorities behave preemptively.)</p>
<p>
</p>
<hr />
<h1><a name="what_kind_of_threads_are_perl_threads">What kind of threads are perl threads?</a></h1>
<p>If you have experience with other thread implementations, you might
find that things aren't quite what you expect.  It's very important to
remember when dealing with Perl threads that Perl Threads Are Not X
Threads, for all values of X.  They aren't POSIX threads, or
DecThreads, or Java's Green threads, or Win32 threads.  There are
similarities, and the broad concepts are the same, but if you start
looking for implementation details you're going to be either
disappointed or confused.  Possibly both.</p>
<p>This is not to say that Perl threads are completely different from
everything that's ever come before--they're not.  Perl's threading
model owes a lot to other thread models, especially POSIX.  Just as
Perl is not C, though, Perl threads are not POSIX threads.  So if you
find yourself looking for mutexes, or thread priorities, it's time to
step back a bit and think about what you want to do and how Perl can
do it.</p>
<p>
</p>
<hr />
<h1><a name="threadsafe_modules">Threadsafe Modules</a></h1>
<p>The addition of threads has changed Perl's internals
substantially.  There are implications for people who write
modules--especially modules with XS code or external libraries.  While
most modules won't encounter any problems, modules that aren't
explicitly tagged as thread-safe should be tested before being used in
production code.</p>
<p>Not all modules that you might use are thread-safe, and you should
always assume a module is unsafe unless the documentation says
otherwise.  This includes modules that are distributed as part of the
core.  Threads are a beta feature, and even some of the standard
modules aren't thread-safe.</p>
<p>If you're using a module that's not thread-safe for some reason, you
can protect yourself by using semaphores and lots of programming
discipline to control access to the module.  Semaphores are covered
later in the article.  Perl Threads Are Different</p>
<p>
</p>
<hr />
<h1><a name="thread_basics">Thread Basics</a></h1>
<p>The core Thread module provides the basic functions you need to write
threaded programs.  In the following sections we'll cover the basics,
showing you what you need to do to create a threaded program.   After
that, we'll go over some of the features of the Thread module that
make threaded programming easier.</p>
<p>
</p>
<h2><a name="basic_thread_support">Basic Thread Support</a></h2>
<p>Thread support is a Perl compile-time option-it's something that's
turned on or off when Perl is built at your site, rather than when
your programs are compiled. If your Perl wasn't compiled with thread
support enabled, then any attempt to use threads will fail.</p>
<p>Remember that the threading support in 5.005 is in beta release, and
should be treated as such.   You should expect that it may not function
entirely properly, and the thread interface may well change some
before it is a fully supported, production release.  The beta version
shouldn't be used for mission-critical projects.  Having said that,
threaded Perl is pretty nifty, and worth a look.</p>
<p>Your programs can use the Config module to check whether threads are
enabled. If your program can't run without them, you can say something
like:</p>
<pre>
  $Config{usethreads} or die &quot;Recompile Perl with threads to run this program.&quot;;</pre>
<p>A possibly-threaded program using a possibly-threaded module might
have code like this:</p>
<pre>
    use Config; 
    use MyMod;</pre>
<pre>
    if ($Config{usethreads}) { 
        # We have threads 
        require MyMod_threaded; 
        import MyMod_threaded; 
    } else { 
        require MyMod_unthreaded; 
        import MyMod_unthreaded; 
    }</pre>
<p>Since code that runs both with and without threads is usually pretty
messy, it's best to isolate the thread-specific code in its own
module.  In our example above, that's what MyMod_threaded is, and it's
only imported if we're running on a threaded Perl.</p>
<p>
</p>
<h2><a name="creating_threads">Creating Threads</a></h2>
<p>The Thread package provides the tools you need to create new
threads.  Like any other module, you need to tell Perl you want to use
it; use Thread imports all the pieces you need to create basic
threads.</p>
<p>The simplest, straightforward way to create a thread is with new():</p>
<pre>
    use Thread;</pre>
<pre>
    $thr = new Thread \&amp;sub1;</pre>
<pre>
    sub sub1 { 
        print &quot;In the thread\n&quot;; 
    }</pre>
<p>The <code>new()</code> method takes a reference to a subroutine and creates a new
thread, which starts executing in the referenced subroutine.  Control
then passes both to the subroutine and the caller.</p>
<p>If you need to, your program can pass parameters to the subroutine as
part of the thread startup.  Just include the list of parameters as
part of the <code>Thread::new</code> call, like this:</p>
<pre>
    use Thread; 
    $Param3 = &quot;foo&quot;; 
    $thr = new Thread \&amp;sub1, &quot;Param 1&quot;, &quot;Param 2&quot;, $Param3; 
    $thr = new Thread \&amp;sub1, @ParamList; 
    $thr = new Thread \&amp;sub1, qw(Param1 Param2 $Param3);</pre>
<pre>
    sub sub1 { 
        my @InboundParameters = @_; 
        print &quot;In the thread\n&quot;; 
        print &quot;got parameters &gt;&quot;, join(&quot;&lt;&gt;&quot;, @InboundParameters), &quot;&lt;\n&quot;; 
    }</pre>
<p>The subroutine runs like a normal Perl subroutine, and the call to new
Thread returns whatever the subroutine returns.</p>
<p>The last example illustrates another feature of threads.  You can spawn
off several threads using the same subroutine.  Each thread executes
the same subroutine, but in a separate thread with a separate
environment and potentially separate arguments.</p>
<p>The other way to spawn a new thread is with async(), which is a way to
spin off a chunk of code like eval(), but into its own thread:</p>
<pre>
    use Thread qw(async);</pre>
<pre>
    $LineCount = 0;</pre>
<pre>
    $thr = async { 
        while(&lt;&gt;) {$LineCount++}         
        print &quot;Got $LineCount lines\n&quot;;
    };</pre>
<pre>
    print &quot;Waiting for the linecount to end\n&quot;; 
    $thr-&gt;join; 
    print &quot;All done\n&quot;;</pre>
<p>You'll notice we did a use Thread <code>qw(async)</code> in that example.  async is
not exported by default, so if you want it, you'll either need to
import it before you use it or fully qualify it as
Thread::async.  You'll also note that there's a semicolon after the
closing brace.  That's because <code>async()</code> treats the following block as an
anonymous subroutine, so the semicolon is necessary.</p>
<p>Like eval(), the code executes in the same context as it would if it
weren't spun off.  Since both the code inside and after the async start
executing, you need to be careful with any shared resources.  Locking
and other synchronization techniques are covered later.</p>
<p>
</p>
<h2><a name="giving_up_control">Giving up control</a></h2>
<p>There are times when you may find it useful to have a thread
explicitly give up the CPU to another thread.  Your threading package
might not support preemptive multitasking for threads, for example, or
you may be doing something compute-intensive and want to make sure
that the user-interface thread gets called frequently.  Regardless,
there are times that you might want a thread to give up the processor.</p>
<p>Perl's threading package provides the <code>yield()</code> function that does
this. <code>yield()</code> is pretty straightforward, and works like this:</p>
<pre>
    use Thread qw(yield async); 
    async { 
        my $foo = 50; 
        while ($foo--) { print &quot;first async\n&quot; }
        yield; 
        $foo = 50; 
        while ($foo--) { print &quot;first async\n&quot; } 
    }; 
    async { 
        my $foo = 50; 
        while ($foo--) { print &quot;second async\n&quot; }
        yield; 
        $foo = 50; 
        while ($foo--) { print &quot;second async\n&quot; } 
    };</pre>
<p>
</p>
<h2><a name="waiting_for_a_thread_to_exit">Waiting For A Thread To Exit</a></h2>
<p>Since threads are also subroutines, they can return values.  To wait
for a thread to exit and extract any scalars it might return, you can
use the <code>join()</code> method.</p>
<pre>
    use Thread; 
    $thr = new Thread \&amp;sub1;</pre>
<pre>
    @ReturnData = $thr-&gt;join; 
    print &quot;Thread returned @ReturnData&quot;;</pre>
<pre>
    sub sub1 { return &quot;Fifty-six&quot;, &quot;foo&quot;, 2; }</pre>
<p>In the example above, the <code>join()</code> method returns as soon as the thread
ends.  In addition to waiting for a thread to finish and gathering up
any values that the thread might have returned, <code>join()</code> also performs
any OS cleanup necessary for the thread.  That cleanup might be
important, especially for long-running programs that spawn lots of
threads.  If you don't want the return values and don't want to wait
for the thread to finish, you should call the <code>detach()</code> method
instead. <code>detach()</code> is covered later in the article.</p>
<p>
</p>
<h2><a name="errors_in_threads">Errors In Threads</a></h2>
<p>So what happens when an error occurs in a thread? Any errors that
could be caught with <code>eval()</code> are postponed until the thread is
joined.  If your program never joins, the errors appear when your
program exits.</p>
<p>Errors deferred until a <code>join()</code> can be caught with eval():</p>
<pre>
    use Thread qw(async); 
    $thr = async {$b = 3/0};   # Divide by zero error
    $foo = eval {$thr-&gt;join}; 
    if ($@) { 
        print &quot;died with error $@\n&quot;; 
    } else { 
        print &quot;Hey, why aren't you dead?\n&quot;; 
    }</pre>
<p><code>eval()</code> passes any results from the joined thread back unmodified, so
if you want the return value of the thread, this is your only chance
to get them.</p>
<p>
</p>
<h2><a name="ignoring_a_thread">Ignoring A Thread</a></h2>
<p><code>join()</code> does three things: it waits for a thread to exit, cleans up
after it, and returns any data the thread may have produced.  But what
if you're not interested in the thread's return values, and you don't
really care when the thread finishes? All you want is for the thread
to get cleaned up after when it's done.</p>
<p>In this case, you use the <code>detach()</code> method.  Once a thread is detached,
it'll run until it's finished, then Perl will clean up after it
automatically.</p>
<pre>
    use Thread; 
    $thr = new Thread \&amp;sub1; # Spawn the thread</pre>
<pre>
    $thr-&gt;detach; # Now we officially don't care any more</pre>
<pre>
    sub sub1 { 
        $a = 0; 
        while (1) { 
            $a++; 
            print &quot;\$a is $a\n&quot;; 
            sleep 1; 
        } 
    }</pre>
<p>Once a thread is detached, it may not be joined, and any output that
it might have produced (if it was done and waiting for a join) is
lost.</p>
<p>
</p>
<hr />
<h1><a name="threads_and_data">Threads And Data</a></h1>
<p>Now that we've covered the basics of threads, it's time for our next
topic: data.  Threading introduces a couple of complications to data
access that non-threaded programs never need to worry about.</p>
<p>
</p>
<h2><a name="shared_and_unshared_data">Shared And Unshared Data</a></h2>
<p>The single most important thing to remember when using threads is that
all threads potentially have access to all the data anywhere in your
program.  While this is true with a nonthreaded Perl program as well,
it's especially important to remember with a threaded program, since
more than one thread can be accessing this data at once.</p>
<p>Perl's scoping rules don't change because you're using threads.  If a
subroutine (or block, in the case of <code>async())</code> could see a variable if
you weren't running with threads, it can see it if you are.  This is
especially important for the subroutines that create, and makes <code>my</code>
variables even more important.  Remember--if your variables aren't
lexically scoped (declared with <code>my</code>) you're probably sharing them
between threads.</p>
<p>
</p>
<h2><a name="thread_pitfall__races">Thread Pitfall: Races</a></h2>
<p>While threads bring a new set of useful tools, they also bring a
number of pitfalls.  One pitfall is the race condition:</p>
<pre>
    use Thread; 
    $a = 1; 
    $thr1 = Thread-&gt;new(\&amp;sub1); 
    $thr2 = Thread-&gt;new(\&amp;sub2);</pre>
<pre>
    sleep 10; 
    print &quot;$a\n&quot;;</pre>
<pre>
    sub sub1 { $foo = $a; $a = $foo + 1; }
    sub sub2 { $bar = $a; $a = $bar + 1; }</pre>
<p>What do you think $a will be? The answer, unfortunately, is ``it
depends.'' Both <code>sub1()</code> and <code>sub2()</code> access the global variable $a, once
to read and once to write.  Depending on factors ranging from your
thread implementation's scheduling algorithm to the phase of the moon,
$a can be 2 or 3.</p>
<p>Race conditions are caused by unsynchronized access to shared
data.  Without explicit synchronization, there's no way to be sure that
nothing has happened to the shared data between the time you access it
and the time you update it.  Even this simple code fragment has the
possibility of error:</p>
<pre>
    use Thread qw(async); 
    $a = 2; 
    async{ $b = $a; $a = $b + 1; }; 
    async{ $c = $a; $a = $c + 1; };</pre>
<p>Two threads both access $a.  Each thread can potentially be interrupted
at any point, or be executed in any order.  At the end, $a could be 3
or 4, and both $b and $c could be 2 or 3.</p>
<p>Whenever your program accesses data or resources that can be accessed
by other threads, you must take steps to coordinate access or risk
data corruption and race conditions.</p>
<p>
</p>
<h2><a name="controlling_access__lock__">Controlling access: <code>lock()</code></a></h2>
<p>The <code>lock()</code> function takes a variable (or subroutine, but we'll get to
that later) and puts a lock on it.  No other thread may lock the
variable until the locking thread exits the innermost block containing
the lock.  Using <code>lock()</code> is straightforward:</p>
<pre>
    use Thread qw(async); 
    $a = 4; 
    $thr1 = async { 
        $foo = 12; 
        { 
            lock ($a); # Block until we get access to $a 
            $b = $a; 
            $a = $b * $foo; 
        } 
        print &quot;\$foo was $foo\n&quot;;
    }; 
    $thr2 = async { 
        $bar = 7; 
        { 
            lock ($a); # Block until we can get access to $a
            $c = $a; 
            $a = $c * $bar; 
        } 
        print &quot;\$bar was $bar\n&quot;;
    }; 
    $thr1-&gt;join; 
    $thr2-&gt;join; 
    print &quot;\$a is $a\n&quot;;</pre>
<p><code>lock()</code> blocks the thread until the variable being locked is
available.  When <code>lock()</code> returns, your thread can be sure that no other
thread can lock that variable until the innermost block containing the
lock exits.</p>
<p>It's important to note that locks don't prevent access to the variable
in question, only lock attempts.  This is in keeping with Perl's
longstanding tradition of courteous programming, and the advisory file
locking that <code>flock()</code> gives you.  Locked subroutines behave differently,
however.  We'll cover that later in the article.</p>
<p>You may lock arrays and hashes as well as scalars.  Locking an array,
though, will not block subsequent locks on array elements, just lock
attempts on the array itself.</p>
<p>Finally, locks are recursive, which means it's okay for a thread to
lock a variable more than once.  The lock will last until the outermost
<code>lock()</code> on the variable goes out of scope.</p>
<p>
</p>
<h2><a name="thread_pitfall__deadlocks">Thread Pitfall: Deadlocks</a></h2>
<p>Locks are a handy tool to synchronize access to data.  Using them
properly is the key to safe shared data.  Unfortunately, locks aren't
without their dangers.  Consider the following code:</p>
<pre>
    use Thread qw(async yield); 
    $a = 4; 
    $b = &quot;foo&quot;; 
    async { 
        lock($a); 
        yield; 
        sleep 20; 
        lock ($b); 
    }; 
    async { 
        lock($b); 
        yield; 
        sleep 20; 
        lock ($a); 
    };</pre>
<p>This program will probably hang until you kill it.  The only way it
won't hang is if one of the two <code>async()</code> routines acquires both locks
first.  A guaranteed-to-hang version is more complicated, but the
principle is the same.</p>
<p>The first thread spawned by <code>async()</code> will grab a lock on $a then, a
second or two later, try to grab a lock on $b.  Meanwhile, the second
thread grabs a lock on $b, then later tries to grab a lock on $a.  The
second lock attempt for both threads will block, each waiting for the
other to release its lock.</p>
<p>This condition is called a deadlock, and it occurs whenever two or
more threads are trying to get locks on resources that the others
own.  Each thread will block, waiting for the other to release a lock
on a resource.  That never happens, though, since the thread with the
resource is itself waiting for a lock to be released.</p>
<p>There are a number of ways to handle this sort of problem.  The best
way is to always have all threads acquire locks in the exact same
order.  If, for example, you lock variables $a, $b, and $c, always lock
$a before $b, and $b before $c.  It's also best to hold on to locks for
as short a period of time to minimize the risks of deadlock.</p>
<p>
</p>
<h2><a name="queues__passing_data_around">Queues: Passing Data Around</a></h2>
<p>A queue is a special thread-safe object that lets you put data in one
end and take it out the other without having to worry about
synchronization issues.  They're pretty straightforward, and look like
this:</p>
<pre>
    use Thread qw(async); 
    use Thread::Queue;</pre>
<pre>
    my $DataQueue = new Thread::Queue; 
    $thr = async { 
        while ($DataElement = $DataQueue-&gt;dequeue) { 
            print &quot;Popped $DataElement off the queue\n&quot;;
        } 
    };</pre>
<pre>
    $DataQueue-&gt;enqueue(12); 
    $DataQueue-&gt;enqueue(&quot;A&quot;, &quot;B&quot;, &quot;C&quot;); 
    $DataQueue-&gt;enqueue(\$thr); 
    sleep 10; 
    $DataQueue-&gt;enqueue(undef);</pre>
<p>You create the queue with new Thread::Queue.  Then you can add lists of
scalars onto the end with enqueue(), and pop scalars off the front of
it with dequeue().  A queue has no fixed size, and can grow as needed
to hold everything pushed on to it.</p>
<p>If a queue is empty, <code>dequeue()</code> blocks until another thread enqueues
something.  This makes queues ideal for event loops and other
communications between threads.</p>
<p>
</p>
<hr />
<h1><a name="threads_and_code">Threads And Code</a></h1>
<p>In addition to providing thread-safe access to data via locks and
queues, threaded Perl also provides general-purpose semaphores for
coarser synchronization than locks provide and thread-safe access to
entire subroutines.</p>
<p>
</p>
<h2><a name="semaphores__synchronizing_data_access">Semaphores: Synchronizing Data Access</a></h2>
<p>Semaphores are a kind of generic locking mechanism.  Unlike lock, which
gets a lock on a particular scalar, Perl doesn't associate any
particular thing with a semaphore so you can use them to control
access to anything you like.  In addition, semaphores can allow more
than one thread to access a resource at once, though by default
semaphores only allow one thread access at a time.</p>
<dl>
<dt><strong><a name="item_basic_semaphores">Basic semaphores</a></strong>

<dd>
<p>Semaphores have two methods, down and up. down decrements the resource
count, while up increments it.  down calls will block if the
semaphore's current count would decrement below zero.  This program
gives a quick demonstration:</p>
</dd>
<dd>
<pre>
    use Thread qw(yield); 
    use Thread::Semaphore; 
    my $semaphore = new Thread::Semaphore; 
    $GlobalVariable = 0;</pre>
</dd>
<dd>
<pre>
    $thr1 = new Thread \&amp;sample_sub, 1; 
    $thr2 = new Thread \&amp;sample_sub, 2; 
    $thr3 = new Thread \&amp;sample_sub, 3;</pre>
</dd>
<dd>
<pre>
    sub sample_sub { 
        my $SubNumber = shift @_; 
        my $TryCount = 10; 
        my $LocalCopy; 
        sleep 1; 
        while ($TryCount--) { 
            $semaphore-&gt;down; 
            $LocalCopy = $GlobalVariable; 
            print &quot;$TryCount tries left for sub $SubNumber (\$GlobalVariable is $GlobalVariable)\n&quot;; 
            yield; 
            sleep 2; 
            $LocalCopy++; 
            $GlobalVariable = $LocalCopy; 
            $semaphore-&gt;up; 
        } 
    }</pre>
</dd>
<dd>
<p>The three invocations of the subroutine all operate in sync.  The
semaphore, though, makes sure that only one thread is accessing the
global variable at once.</p>
</dd>
</li>
<dt><strong><a name="item_advanced_semaphores">Advanced Semaphores</a></strong>

<dd>
<p>By default, semaphores behave like locks, letting only one thread
<code>down()</code> them at a time.  However, there are other uses for semaphores.</p>
</dd>
<dd>
<p>Each semaphore has a counter attached to it. <code>down()</code> decrements the
counter and <code>up()</code> increments the counter.  By default, semaphores are
created with the counter set to one, <code>down()</code> decrements by one, and
<code>up()</code> increments by one.  If <code>down()</code> attempts to decrement the counter
below zero, it blocks until the counter is large enough.  Note that
while a semaphore can be created with a starting count of zero, any
<code>up()</code> or <code>down()</code> always changes the counter by at least
one. $semaphore-&gt;<code>down(0)</code> is the same as $semaphore-&gt;down(1).</p>
</dd>
<dd>
<p>The question, of course, is why would you do something like this? Why
create a semaphore with a starting count that's not one, or why
decrement/increment it by more than one? The answer is resource
availability.  Many resources that you want to manage access for can be
safely used by more than one thread at once.</p>
</dd>
<dd>
<p>For example, let's take a GUI driven program.  It has a semaphore that
it uses to synchronize access to the display, so only one thread is
ever drawing at once.  Handy, but of course you don't want any thread
to start drawing until things are properly set up.  In this case, you
can create a semaphore with a counter set to zero, and up it when
things are ready for drawing.</p>
</dd>
<dd>
<p>Semaphores with counters greater than one are also useful for
establishing quotas.  Say, for example, that you have a number of
threads that can do I/O at once.  You don't want all the threads
reading or writing at once though, since that can potentially swamp
your I/O channels, or deplete your process' quota of filehandles.  You
can use a semaphore initialized to the number of concurrent I/O
requests (or open files) that you want at any one time, and have your
threads quietly block and unblock themselves.</p>
</dd>
<dd>
<p>Larger increments or decrements are handy in those cases where a
thread needs to check out or return a number of resources at once.</p>
</dd>
</li>
</dl>
<p>
</p>
<h2><a name="attributes__restricting_access_to_subroutines">Attributes: Restricting Access To Subroutines</a></h2>
<p>In addition to synchronizing access to data or resources, you might
find it useful to synchronize access to subroutines.  You may be
accessing a singular machine resource (perhaps a vector processor), or
find it easier to serialize calls to a particular subroutine than to
have a set of locks and semaphores.</p>
<p>One of the additions to Perl 5.005 is subroutine attributes.  The
Thread package uses these to provide several flavors of
serialization.  It's important to remember that these attributes are
used in the compilation phase of your program so you can't change a
subroutine's behavior while your program is actually running.</p>
<p>
</p>
<h2><a name="subroutine_locks">Subroutine Locks</a></h2>
<p>The basic subroutine lock looks like this:</p>
<pre>
    sub test_sub :locked { 
    }</pre>
<p>This ensures that only one thread will be executing this subroutine at
any one time.  Once a thread calls this subroutine, any other thread
that calls it will block until the thread in the subroutine exits
it.  A more elaborate example looks like this:</p>
<pre>
    use Thread qw(yield);</pre>
<pre>
    new Thread \&amp;thread_sub, 1; 
    new Thread \&amp;thread_sub, 2; 
    new Thread \&amp;thread_sub, 3; 
    new Thread \&amp;thread_sub, 4;</pre>
<pre>
    sub sync_sub :locked { 
        my $CallingThread = shift @_; 
        print &quot;In sync_sub for thread $CallingThread\n&quot;;
        yield; 
        sleep 3; 
        print &quot;Leaving sync_sub for thread $CallingThread\n&quot;; 
    }</pre>
<pre>
    sub thread_sub { 
        my $ThreadID = shift @_; 
        print &quot;Thread $ThreadID calling sync_sub\n&quot;;
        sync_sub($ThreadID); 
        print &quot;$ThreadID is done with sync_sub\n&quot;; 
    }</pre>
<p>The <code>locked</code> attribute tells perl to lock sync_sub(), and if you run
this, you can see that only one thread is in it at any one time.</p>
<p>
</p>
<h2><a name="methods">Methods</a></h2>
<p>Locking an entire subroutine can sometimes be overkill, especially
when dealing with Perl objects.  When calling a method for an object,
for example, you want to serialize calls to a method, so that only one
thread will be in the subroutine for a particular object, but threads
calling that subroutine for a different object aren't blocked.  The
method attribute indicates whether the subroutine is really a method.</p>
<pre>
    use Thread;</pre>
<pre>
    sub tester { 
        my $thrnum = shift @_; 
        my $bar = new Foo; 
        foreach (1..10) {       
            print &quot;$thrnum calling per_object\n&quot;; 
            $bar-&gt;per_object($thrnum);  
            print &quot;$thrnum out of per_object\n&quot;; 
            yield; 
            print &quot;$thrnum calling one_at_a_time\n&quot;;
            $bar-&gt;one_at_a_time($thrnum);       
            print &quot;$thrnum out of one_at_a_time\n&quot;; 
            yield; 
        } 
    }</pre>
<pre>
    foreach my $thrnum (1..10) { 
        new Thread \&amp;tester, $thrnum; 
    }</pre>
<pre>
    package Foo; 
    sub new { 
        my $class = shift @_; 
        return bless [@_], $class; 
    }</pre>
<pre>
    sub per_object :locked :method { 
        my ($class, $thrnum) = @_; 
        print &quot;In per_object for thread $thrnum\n&quot;; 
        yield; 
        sleep 2; 
        print &quot;Exiting per_object for thread $thrnum\n&quot;; 
    }</pre>
<pre>
    sub one_at_a_time :locked { 
        my ($class, $thrnum) = @_; 
        print &quot;In one_at_a_time for thread $thrnum\n&quot;;     
        yield; 
        sleep 2; 
        print &quot;Exiting one_at_a_time for thread $thrnum\n&quot;; 
    }</pre>
<p>As you can see from the output (omitted for brevity; it's 800 lines)
all the threads can be in <code>per_object()</code> simultaneously, but only one
thread is ever in <code>one_at_a_time()</code> at once.</p>
<p>
</p>
<h2><a name="locking_a_subroutine">Locking A Subroutine</a></h2>
<p>You can lock a subroutine as you would lock a variable.  Subroutine locks
work the same as specifying a <code>locked</code> attribute for the subroutine,
and block all access to the subroutine for other threads until the
lock goes out of scope.  When the subroutine isn't locked, any number
of threads can be in it at once, and getting a lock on a subroutine
doesn't affect threads already in the subroutine.  Getting a lock on a
subroutine looks like this:</p>
<pre>
    lock(\&amp;sub_to_lock);</pre>
<p>Simple enough.  Unlike the <code>locked</code> attribute, which is a compile time
option, locking and unlocking a subroutine can be done at runtime at your
discretion.  There is some runtime penalty to using <code>lock(\&amp;sub)</code> instead
of the <code>locked</code> attribute, so make sure you're choosing the proper
method to do the locking.</p>
<p>You'd choose <code>lock(\&amp;sub)</code> when writing modules and code to run on both
threaded and unthreaded Perl, especially for code that will run on
5.004 or earlier Perls.  In that case, it's useful to have subroutines
that should be serialized lock themselves if they're running threaded,
like so:</p>
<pre>
    package Foo; 
    use Config; 
    $Running_Threaded = 0;</pre>
<pre>
    BEGIN { $Running_Threaded = $Config{'usethreads'} }</pre>
<pre>
    sub sub1 { lock(\&amp;sub1) if $Running_Threaded }</pre>
<p>This way you can ensure single-threadedness regardless of which
version of Perl you're running.</p>
<p>
</p>
<hr />
<h1><a name="general_thread_utility_routines">General Thread Utility Routines</a></h1>
<p>We've covered the workhorse parts of Perl's threading package, and
with these tools you should be well on your way to writing threaded
code and packages.  There are a few useful little pieces that didn't
really fit in anyplace else.</p>
<p>
</p>
<h2><a name="what_thread_am_i_in">What Thread Am I In?</a></h2>
<p>The Thread-&gt;self method provides your program with a way to get an
object representing the thread it's currently in.  You can use this
object in the same way as the ones returned from the thread creation.</p>
<p>
</p>
<h2><a name="thread_ids">Thread IDs</a></h2>
<p><code>tid()</code> is a thread object method that returns the thread ID of the
thread the object represents.  Thread IDs are integers, with the main
thread in a program being 0.  Currently Perl assigns a unique tid to
every thread ever created in your program, assigning the first thread
to be created a tid of 1, and increasing the tid by 1 for each new
thread that's created.</p>
<p>
</p>
<h2><a name="are_these_threads_the_same">Are These Threads The Same?</a></h2>
<p>The <code>equal()</code> method takes two thread objects and returns true 
if the objects represent the same thread, and false if they don't.</p>
<p>
</p>
<h2><a name="what_threads_are_running">What Threads Are Running?</a></h2>
<p>Thread-&gt;list returns a list of thread objects, one for each thread
that's currently running.  Handy for a number of things, including
cleaning up at the end of your program:</p>
<pre>
    # Loop through all the threads 
    foreach $thr (Thread-&gt;list) { 
        # Don't join the main thread or ourselves 
        if ($thr-&gt;tid &amp;&amp; !Thread::equal($thr, Thread-&gt;self)) { 
            $thr-&gt;join; 
        } 
    }</pre>
<p>The example above is just for illustration.  It isn't strictly
necessary to join all the threads you create, since Perl detaches all
the threads before it exits.</p>
<p>
</p>
<hr />
<h1><a name="a_complete_example">A Complete Example</a></h1>
<p>Confused yet? It's time for an example program to show some of the
things we've covered.  This program finds prime numbers using threads.</p>
<pre>
    1  #!/usr/bin/perl -w
    2  # prime-pthread, courtesy of Tom Christiansen
    3
    4  use strict;
    5
    6  use Thread;
    7  use Thread::Queue;
    8
    9  my $stream = new Thread::Queue;
    10 my $kid    = new Thread(\&amp;check_num, $stream, 2);
    11
    12 for my $i ( 3 .. 1000 ) {
    13     $stream-&gt;enqueue($i);
    14 } 
    15
    16 $stream-&gt;enqueue(undef);
    17 $kid-&gt;join();
    18
    19 sub check_num {
    20     my ($upstream, $cur_prime) = @_;
    21     my $kid;
    22     my $downstream = new Thread::Queue;
    23     while (my $num = $upstream-&gt;dequeue) {
    24         next unless $num % $cur_prime;
    25         if ($kid) {
    26            $downstream-&gt;enqueue($num);
    27                  } else {
    28            print &quot;Found prime $num\n&quot;;
    29                $kid = new Thread(\&amp;check_num, $downstream, $num);
    30         }
    31     } 
    32     $downstream-&gt;enqueue(undef) if $kid;
    33     $kid-&gt;join()         if $kid;
    34 }</pre>
<p>This program uses the pipeline model to generate prime numbers.  Each
thread in the pipeline has an input queue that feeds numbers to be
checked, a prime number that it's responsible for, and an output queue
that it funnels numbers that have failed the check into.  If the thread
has a number that's failed its check and there's no child thread, then
the thread must have found a new prime number.  In that case, a new
child thread is created for that prime and stuck on the end of the
pipeline.</p>
<p>This probably sounds a bit more confusing than it really is, so lets
go through this program piece by piece and see what it does.  (For
those of you who might be trying to remember exactly what a prime
number is, it's a number that's only evenly divisible by itself and 1)</p>
<p>The bulk of the work is done by the <code>check_num()</code> subroutine, which
takes a reference to its input queue and a prime number that it's
responsible for.  After pulling in the input queue and the prime that
the subroutine's checking (line 20), we create a new queue (line 22)
and reserve a scalar for the thread that we're likely to create later
(line 21).</p>
<p>The while loop from lines 23 to line 31 grabs a scalar off the input
queue and checks against the prime this thread is responsible
for.  Line 24 checks to see if there's a remainder when we modulo the
number to be checked against our prime.  If there is one, the number
must not be evenly divisible by our prime, so we need to either pass
it on to the next thread if we've created one (line 26) or create a
new thread if we haven't.</p>
<p>The new thread creation is line 29.  We pass on to it a reference to
the queue we've created, and the prime number we've found.</p>
<p>Finally, once the loop terminates (because we got a 0 or undef in the
queue, which serves as a note to die), we pass on the notice to our
child and wait for it to exit if we've created a child (Lines 32 and
37).</p>
<p>Meanwhile, back in the main thread, we create a queue (line 9) and the
initial child thread (line 10), and pre-seed it with the first prime:
2.  Then we queue all the numbers from 3 to 1000 for checking (lines
12-14), then queue a die notice (line 16) and wait for the first child
thread to terminate (line 17).  Because a child won't die until its
child has died, we know that we're done once we return from the join.</p>
<p>That's how it works.  It's pretty simple; as with many Perl programs,
the explanation is much longer than the program.</p>
<p>
</p>
<hr />
<h1><a name="conclusion">Conclusion</a></h1>
<p>A complete thread tutorial could fill a book (and has, many times),
but this should get you well on your way.  The final authority on how
Perl's threads behave is the documentation bundled with the Perl
distribution, but with what we've covered in this article, you should
be well on your way to becoming a threaded Perl expert.</p>
<p>
</p>
<hr />
<h1><a name="bibliography">Bibliography</a></h1>
<p>Here's a short bibliography courtesy of Jrgen Christoffel:</p>
<p>
</p>
<h2><a name="introductory_texts">Introductory Texts</a></h2>
<p>Birrell, Andrew D. An Introduction to Programming with
Threads. Digital Equipment Corporation, 1989, DEC-SRC Research Report
#35 online as
<a href="http://www.research.digital.com/SRC/staff/birrell/bib.html">http://www.research.digital.com/SRC/staff/birrell/bib.html</a> (highly
recommended)</p>
<p>Robbins, Kay. A., and Steven Robbins. Practical Unix Programming: A
Guide to Concurrency, Communication, and
Multithreading. Prentice-Hall, 1996.</p>
<p>Lewis, Bill, and Daniel J. Berg. Multithreaded Programming with
Pthreads. Prentice Hall, 1997, ISBN 0-13-443698-9 (a well-written
introduction to threads).</p>
<p>Nelson, Greg (editor). Systems Programming with Modula-3.  Prentice
Hall, 1991, ISBN 0-13-590464-1.</p>
<p>Nichols, Bradford, Dick Buttlar, and Jacqueline Proulx Farrell.
Pthreads Programming. O'Reilly &amp; Associates, 1996, ISBN 156592-115-1
(covers POSIX threads).</p>
<p>
</p>
<h2><a name="osrelated_references">OS-Related References</a></h2>
<p>Boykin, Joseph, David Kirschen, Alan Langerman, and Susan
LoVerso. Programming under Mach. Addison-Wesley, 1994, ISBN
0-201-52739-1.</p>
<p>Tanenbaum, Andrew S. Distributed Operating Systems. Prentice Hall,
1995, ISBN 0-13-219908-4 (great textbook).</p>
<p>Silberschatz, Abraham, and Peter B. Galvin. Operating System Concepts,
4th ed. Addison-Wesley, 1995, ISBN 0-201-59292-4</p>
<p>
</p>
<h2><a name="other_references">Other References</a></h2>
<p>Arnold, Ken and James Gosling. The Java Programming Language, 2nd
ed. Addison-Wesley, 1998, ISBN 0-201-31006-6.</p>
<p>Le Sergent, T. and B. Berthomieu. ``Incremental MultiThreaded Garbage
Collection on Virtually Shared Memory Architectures'' in Memory
Management: Proc. of the International Workshop IWMM 92, St. Malo,
France, September 1992, Yves Bekkers and Jacques Cohen, eds. Springer,
1992, ISBN 3540-55940-X (real-life thread applications).</p>
<p>
</p>
<hr />
<h1><a name="acknowledgements">Acknowledgements</a></h1>
<p>Thanks (in no particular order) to Chaim Frenkel, Steve Fink, Gurusamy
Sarathy, Ilya Zakharevich, Benjamin Sugars, Jrgen Christoffel, Joshua
Pritikin, and Alan Burlison, for their help in reality-checking and
polishing this article.  Big thanks to Tom Christiansen for his rewrite
of the prime number generator.</p>
<p>
</p>
<hr />
<h1><a name="author">AUTHOR</a></h1>
<p>Dan Sugalski &lt;<a href="mailto:sugalskd@ous.edu">sugalskd@ous.edu</a>&gt;</p>
<p>
</p>
<hr />
<h1><a name="copyrights">Copyrights</a></h1>
<p>This article originally appeared in The Perl Journal #10, and is
copyright 1998 The Perl Journal. It appears courtesy of Jon Orwant and
The Perl Journal.  This document may be distributed under the same terms
as Perl itself.</p>
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;perlothrtut - old tutorial on threads in Perl</span></strong></big>
</td></tr>
</table>

</body>

</html>
