<?xml version="1.0" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>README.solaris - Perl version 5 on Solaris systems</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rev="made" href="mailto:root@localhost" />
</head>

<body style="background-color: white">
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;README.solaris - Perl version 5 on Solaris systems</span></strong></big>
</td></tr>
</table>

<p><a name="__index__"></a></p>
<!-- INDEX BEGIN -->

<ul>

	<li><a href="#name">NAME</a></li>
	<li><a href="#description">DESCRIPTION</a></li>
	<ul>

		<li><a href="#solaris_version_numbers_">Solaris Version Numbers.</a></li>
	</ul>

	<li><a href="#resources">RESOURCES</a></li>
	<li><a href="#setting_up">SETTING UP</a></li>
	<ul>

		<li><a href="#file_extraction_problems_on_solaris_">File Extraction Problems on Solaris.</a></li>
		<li><a href="#compiler_and_related_tools_on_solaris_">Compiler and Related Tools on Solaris.</a></li>
		<ul>

			<li><a href="#include__usr_ccs_bin__in_your_path_">Include /usr/ccs/bin/ in your PATH.</a></li>
			<li><a href="#avoid__usr_ucb_cc_">Avoid /usr/ucb/cc.</a></li>
			<li><a href="#sun_s_c_compiler">Sun's C Compiler</a></li>
			<li><a href="#gcc">GCC</a></li>
			<li><a href="#gnu_as_and_gnu_ld">GNU as and GNU ld</a></li>
			<li><a href="#sun_and_gnu_make">Sun and GNU make</a></li>
			<li><a href="#avoid_libucb_">Avoid libucb.</a></li>
		</ul>

		<li><a href="#environment_for_compiling_perl_on_solaris">Environment for Compiling perl on Solaris</a></li>
		<ul>

			<li><a href="#path">PATH</a></li>
			<li><a href="#ld_library_path">LD_LIBRARY_PATH</a></li>
		</ul>

	</ul>

	<li><a href="#run_configure_">RUN CONFIGURE.</a></li>
	<ul>

		<li><a href="#64bit_perl_on_solaris_">64-bit perl on Solaris.</a></li>
		<ul>

			<li><a href="#general_32bit_vs__64bit_issues_">General 32-bit vs. 64-bit issues.</a></li>
			<li><a href="#large_file_support">Large File Support</a></li>
			<li><a href="#building_an_lp64_perl">Building an LP64 perl</a></li>
			<li><a href="#long_doubles_">Long Doubles.</a></li>
		</ul>

		<li><a href="#threads_in_perl_on_solaris_">Threads in perl on Solaris.</a></li>
		<li><a href="#malloc_issues_with_perl_on_solaris_">Malloc Issues with perl on Solaris.</a></li>
	</ul>

	<li><a href="#make_problems_">MAKE PROBLEMS.</a></li>
	<li><a href="#make_test">MAKE TEST</a></li>
	<ul>

		<li><a href="#op_stat_t_test_4_in_solaris">op/stat.t test 4 in Solaris</a></li>
		<li><a href="#nss_delete_core_dump_from_op_pwent_or_op_grent">nss_delete core dump from op/pwent or op/grent</a></li>
	</ul>

	<li><a href="#prebuilt_binaries_of_perl_for_solaris_">PREBUILT BINARIES OF PERL FOR SOLARIS.</a></li>
	<li><a href="#runtime_issues_for_perl_on_solaris_">RUNTIME ISSUES FOR PERL ON SOLARIS.</a></li>
	<ul>

		<li><a href="#limits_on_numbers_of_open_files_on_solaris_">Limits on Numbers of Open Files on Solaris.</a></li>
	</ul>

	<li><a href="#solarisspecific_modules_">SOLARIS-SPECIFIC MODULES.</a></li>
	<li><a href="#solarisspecific_problems_with_modules_">SOLARIS-SPECIFIC PROBLEMS WITH MODULES.</a></li>
	<ul>

		<li><a href="#proc__processtable_on_solaris">Proc::ProcessTable on Solaris</a></li>
		<li><a href="#bsd__resource_on_solaris">BSD::Resource on Solaris</a></li>
		<li><a href="#net__ssleay_on_solaris">Net::SSLeay on Solaris</a></li>
	</ul>

	<li><a href="#sunos_4_x">SunOS 4.x</a></li>
	<li><a href="#author">AUTHOR</a></li>
</ul>
<!-- INDEX END -->

<hr />
<p>
</p>
<h1><a name="name">NAME</a></h1>
<p>README.solaris - Perl version 5 on Solaris systems</p>
<p>
</p>
<hr />
<h1><a name="description">DESCRIPTION</a></h1>
<p>This document describes various features of Sun's Solaris operating system
that will affect how Perl version 5 (hereafter just perl) is
compiled and/or runs.  Some issues relating to the older SunOS 4.x are
also discussed, though they may be out of date.</p>
<p>For the most part, everything should just work.</p>
<p>Starting with Solaris 8, perl5.00503 (or higher) is supplied with the
operating system, so you might not even need to build a newer version
of perl at all.  The Sun-supplied version is installed in /usr/perl5
with /usr/bin/perl pointing to /usr/perl5/bin/perl.  Do not disturb
that installation unless you really know what you are doing.  If you
remove the perl supplied with the OS, you will render some bits of
your system inoperable.  If you wish to install a newer version of perl,
install it under a different prefix from /usr/perl5.  Common prefixes
to use are /usr/local and /opt/perl.</p>
<p>You may wish to put your version of perl in the PATH of all users by
changing the link /usr/bin/perl.  This is probably OK, as most perl
scripts shipped with Solaris use an explicit path.  (There are a few
exceptions, such as /usr/bin/rpm2cpio and /etc/rcm/scripts/README, but
these are also sufficiently generic that the actual version of perl
probably doesn't matter too much.)</p>
<p>Solaris ships with a range of Solaris-specific modules.  If you choose
to install your own version of perl you will find the source of many of
these modules is available on CPAN under the Sun::Solaris:: namespace.</p>
<p>Solaris may include two versions of perl, e.g. Solaris 9 includes
both 5.005_03 and 5.6.1.  This is to provide stability across Solaris
releases, in cases where a later perl version has incompatibilities
with the version included in the preceeding Solaris release.  The
default perl version will always be the most recent, and in general
the old version will only be retained for one Solaris release.  Note
also that the default perl will NOT be configured to search for modules
in the older version, again due to compatibility/stability concerns.
As a consequence if you upgrade Solaris, you will have to
rebuild/reinstall any additional CPAN modules that you installed for
the previous Solaris version.  See the CPAN manpage under 'autobundle'
for a quick way of doing this.</p>
<p>As an interim measure, you may either change the #! line of your
scripts to specifically refer to the old perl version, e.g. on
Solaris 9 use #!/usr/perl5/5.00503/bin/perl to use the perl version
that was the default for Solaris 8, or if you have a large number of
scripts it may be more convenient to make the old version of perl the
default on your system.  You can do this by changing the appropriate
symlinks under /usr/perl5 as follows (example for Solaris 9):</p>
<pre>
 # cd /usr/perl5
 # rm bin man pod
 # ln -s ./5.00503/bin
 # ln -s ./5.00503/man
 # ln -s ./5.00503/lib/pod
 # rm /usr/bin/perl
 # ln -s ../perl5/5.00503/bin/perl /usr/bin/perl</pre>
<p>In both cases this should only be considered to be a temporary
measure - you should upgrade to the later version of perl as soon as
is practicable.</p>
<p>Note also that the perl command-line utilities (e.g. perldoc) and any
that are added by modules that you install will be under
/usr/perl5/bin, so that directory should be added to your PATH.</p>
<p>
</p>
<h2><a name="solaris_version_numbers_">Solaris Version Numbers.</a></h2>
<p>For consistency with common usage, perl's Configure script performs
some minor manipulations on the operating system name and version
number as reported by uname.  Here's a partial translation table:</p>
<pre>
          Sun:                      perl's Configure:
 uname    uname -r   Name           osname     osvers
 SunOS    4.1.3     Solaris 1.1     sunos      4.1.3
 SunOS    5.6       Solaris 2.6     solaris    2.6
 SunOS    5.8       Solaris 8       solaris    2.8
 SunOS    5.9       Solaris 9       solaris    2.9
 SunOS    5.10      Solaris 10      solaris    2.10</pre>
<p>The complete table can be found in the Sun Managers' FAQ
<a href="ftp://ftp.cs.toronto.edu/pub/jdd/sunmanagers/faq">ftp://ftp.cs.toronto.edu/pub/jdd/sunmanagers/faq</a> under
``9.1) Which Sun models run which versions of SunOS?''.</p>
<p>
</p>
<hr />
<h1><a name="resources">RESOURCES</a></h1>
<p>There are many, many sources for Solaris information.  A few of the
important ones for perl:</p>
<dl>
<dt><strong><a name="item_solaris_faq">Solaris FAQ</a></strong>

<dd>
<p>The Solaris FAQ is available at
<a href="http://www.science.uva.nl/pub/solaris/solaris2.html">http://www.science.uva.nl/pub/solaris/solaris2.html</a>.</p>
</dd>
<dd>
<p>The Sun Managers' FAQ is available at
<a href="ftp://ftp.cs.toronto.edu/pub/jdd/sunmanagers/faq">ftp://ftp.cs.toronto.edu/pub/jdd/sunmanagers/faq</a></p>
</dd>
</li>
<dt><strong><a name="item_precompiled_binaries">Precompiled Binaries</a></strong>

<dd>
<p>Precompiled binaries, links to many sites, and much, much more are
available at <a href="http://www.sunfreeware.com/">http://www.sunfreeware.com/</a> and
<a href="http://www.blastwave.org/">http://www.blastwave.org/</a>.</p>
</dd>
</li>
<dt><strong><a name="item_solaris_documentation">Solaris Documentation</a></strong>

<dd>
<p>All Solaris documentation is available on-line at <a href="http://docs.sun.com/">http://docs.sun.com/</a>.</p>
</dd>
</li>
</dl>
<p>
</p>
<hr />
<h1><a name="setting_up">SETTING UP</a></h1>
<p>
</p>
<h2><a name="file_extraction_problems_on_solaris_">File Extraction Problems on Solaris.</a></h2>
<p>Be sure to use a tar program compiled under Solaris (not SunOS 4.x)
to extract the perl-5.x.x.tar.gz file.  Do not use GNU tar compiled
for SunOS4 on Solaris.  (GNU tar compiled for Solaris should be fine.)
When you run SunOS4 binaries on Solaris, the run-time system magically
alters pathnames matching m#lib/locale# so that when tar tries to create
lib/locale.pm, a file named lib/oldlocale.pm gets created instead.
If you found this advice too late and used a SunOS4-compiled tar
anyway, you must find the incorrectly renamed file and move it back
to lib/locale.pm.</p>
<p>
</p>
<h2><a name="compiler_and_related_tools_on_solaris_">Compiler and Related Tools on Solaris.</a></h2>
<p>You must use an ANSI C compiler to build perl.  Perl can be compiled
with either Sun's add-on C compiler or with gcc.  The C compiler that
shipped with SunOS4 will not do.</p>
<p>
</p>
<h3><a name="include__usr_ccs_bin__in_your_path_">Include /usr/ccs/bin/ in your PATH.</a></h3>
<p>Several tools needed to build perl are located in /usr/ccs/bin/:  ar,
as, ld, and make.  Make sure that /usr/ccs/bin/ is in your PATH.</p>
<p>You need to make sure the following packages are installed
(this info is extracted from the Solaris FAQ):</p>
<p>for tools (sccs, lex, yacc, make, nm, truss, ld, as): SUNWbtool,
SUNWsprot, SUNWtoo</p>
<p>for libraries &amp; headers: SUNWhea, SUNWarc, SUNWlibm, SUNWlibms, SUNWdfbh,
SUNWcg6h, SUNWxwinc, SUNWolinc</p>
<p>for 64 bit development: SUNWarcx, SUNWbtoox, SUNWdplx, SUNWscpux,
SUNWsprox, SUNWtoox, SUNWlmsx, SUNWlmx, SUNWlibCx</p>
<p>If you are in doubt which package contains a file you are missing,
try to find an installation that has that file. Then do a</p>
<pre>
 $ grep /my/missing/file /var/sadm/install/contents</pre>
<p>This will display a line like this:</p>
<p>/usr/include/sys/errno.h f none 0644 root bin 7471 37605 956241356 SUNWhea</p>
<p>The last item listed (SUNWhea in this example) is the package you need.</p>
<p>
</p>
<h3><a name="avoid__usr_ucb_cc_">Avoid /usr/ucb/cc.</a></h3>
<p>You don't need to have /usr/ucb/ in your PATH to build perl.  If you
want /usr/ucb/ in your PATH anyway, make sure that /usr/ucb/ is NOT
in your PATH before the directory containing the right C compiler.</p>
<p>
</p>
<h3><a name="sun_s_c_compiler">Sun's C Compiler</a></h3>
<p>If you use Sun's C compiler, make sure the correct directory
(usually /opt/SUNWspro/bin/) is in your PATH (before /usr/ucb/).</p>
<p>
</p>
<h3><a name="gcc">GCC</a></h3>
<p>If you use gcc, make sure your installation is recent and complete.
perl versions since 5.6.0 build fine with gcc &gt; 2.8.1 on Solaris &gt;=
2.6.</p>
<p>You must Configure perl with</p>
<pre>
 $ sh Configure -Dcc=gcc</pre>
<p>If you don't, you may experience strange build errors.</p>
<p>If you have updated your Solaris version, you may also have to update
your gcc.  For example, if you are running Solaris 2.6 and your gcc is
installed under /usr/local, check in /usr/local/lib/gcc-lib and make
sure you have the appropriate directory, sparc-sun-solaris2.6/ or
i386-pc-solaris2.6/.  If gcc's directory is for a different version of
Solaris than you are running, then you will need to rebuild gcc for
your new version of Solaris.</p>
<p>You can get a precompiled version of gcc from
<a href="http://www.sunfreeware.com/">http://www.sunfreeware.com/</a> or <a href="http://www.blastwave.org/">http://www.blastwave.org/</a>. Make
sure you pick up the package for your Solaris release.</p>
<p>If you wish to use gcc to build add-on modules for use with the perl
shipped with Solaris, you should use the Solaris::PerlGcc module
which is available from CPAN.  The perl shipped with Solaris
is configured and built with the Sun compilers, and the compiler
configuration information stored in Config.pm is therefore only
relevant to the Sun compilers.  The Solaris:PerlGcc module contains a
replacement Config.pm that is correct for gcc - see the module for
details.</p>
<p>
</p>
<h3><a name="gnu_as_and_gnu_ld">GNU as and GNU ld</a></h3>
<p>The following information applies to gcc version 2.  Volunteers to
update it as appropropriate for gcc version 3 would be appreciated.</p>
<p>The versions of as and ld supplied with Solaris work fine for building
perl.  There is normally no need to install the GNU versions to
compile perl.</p>
<p>If you decide to ignore this advice and use the GNU versions anyway,
then be sure that they are relatively recent.  Versions newer than 2.7
are apparently new enough.  Older versions may have trouble with
dynamic loading.</p>
<p>If you wish to use GNU ld, then you need to pass it the -Wl,-E flag.
The hints/solaris_2.sh file tries to do this automatically by setting
the following Configure variables:</p>
<pre>
 ccdlflags=&quot;$ccdlflags -Wl,-E&quot;
 lddlflags=&quot;$lddlflags -Wl,-E -G&quot;</pre>
<p>However, over the years, changes in gcc, GNU ld, and Solaris ld have made
it difficult to automatically detect which ld ultimately gets called.
You may have to manually edit config.sh and add the -Wl,-E flags
yourself, or else run Configure interactively and add the flags at the
appropriate prompts.</p>
<p>If your gcc is configured to use GNU as and ld but you want to use the
Solaris ones instead to build perl, then you'll need to add
-B/usr/ccs/bin/ to the gcc command line.  One convenient way to do
that is with</p>
<pre>
 $ sh Configure -Dcc='gcc -B/usr/ccs/bin/'</pre>
<p>Note that the trailing slash is required.  This will result in some
harmless warnings as Configure is run:</p>
<pre>
 gcc: file path prefix `/usr/ccs/bin/' never used</pre>
<p>These messages may safely be ignored.
(Note that for a SunOS4 system, you must use -B/bin/ instead.)</p>
<p>Alternatively, you can use the GCC_EXEC_PREFIX environment variable to
ensure that Sun's as and ld are used.  Consult your gcc documentation
for further information on the -B option and the GCC_EXEC_PREFIX variable.</p>
<p>
</p>
<h3><a name="sun_and_gnu_make">Sun and GNU make</a></h3>
<p>The make under /usr/ccs/bin works fine for building perl.  If you
have the Sun C compilers, you will also have a parallel version of
make (dmake).  This works fine to build perl, but can sometimes cause
problems when running 'make test' due to underspecified dependencies
between the different test harness files.  The same problem can also
affect the building of some add-on modules, so in those cases either
specify '-m serial' on the dmake command line, or use
/usr/ccs/bin/make instead.  If you wish to use GNU make, be sure that
the set-group-id bit is not set.  If it is, then arrange your PATH so
that /usr/ccs/bin/make is before GNU make or else have the system
administrator disable the set-group-id bit on GNU make.</p>
<p>
</p>
<h3><a name="avoid_libucb_">Avoid libucb.</a></h3>
<p>Solaris provides some BSD-compatibility functions in /usr/ucblib/libucb.a.
Perl will not build and run correctly if linked against -lucb since it
contains routines that are incompatible with the standard Solaris libc.
Normally this is not a problem since the solaris hints file prevents
Configure from even looking in /usr/ucblib for libraries, and also
explicitly omits -lucb.</p>
<p>
</p>
<h2><a name="environment_for_compiling_perl_on_solaris">Environment for Compiling perl on Solaris</a></h2>
<p>
</p>
<h3><a name="path">PATH</a></h3>
<p>Make sure your PATH includes the compiler (/opt/SUNWspro/bin/ if you're
using Sun's compiler) as well as /usr/ccs/bin/ to pick up the other
development tools (such as make, ar, as, and ld).  Make sure your path
either doesn't include /usr/ucb or that it includes it after the
compiler and compiler tools and other standard Solaris directories.
You definitely don't want /usr/ucb/cc.</p>
<p>
</p>
<h3><a name="ld_library_path">LD_LIBRARY_PATH</a></h3>
<p>If you have the LD_LIBRARY_PATH environment variable set, be sure that
it does NOT include /lib or /usr/lib.  If you will be building
extensions that call third-party shared libraries (e.g. Berkeley DB)
then make sure that your LD_LIBRARY_PATH environment variable includes
the directory with that library (e.g. /usr/local/lib).</p>
<p>If you get an error message</p>
<pre>
 dlopen: stub interception failed</pre>
<p>it is probably because your LD_LIBRARY_PATH environment variable
includes a directory which is a symlink to /usr/lib (such as /lib).
The reason this causes a problem is quite subtle.  The file
libdl.so.1.0 actually *only* contains functions which generate 'stub
interception failed' errors!  The runtime linker intercepts links to
``/usr/lib/libdl.so.1.0'' and links in internal implementations of those
functions instead.  [Thanks to Tim Bunce for this explanation.]</p>
<p>
</p>
<hr />
<h1><a name="run_configure_">RUN CONFIGURE.</a></h1>
<p>See the INSTALL file for general information regarding Configure.
Only Solaris-specific issues are discussed here.  Usually, the
defaults should be fine.</p>
<p>
</p>
<h2><a name="64bit_perl_on_solaris_">64-bit perl on Solaris.</a></h2>
<p>See the INSTALL file for general information regarding 64-bit compiles.
In general, the defaults should be fine for most people.</p>
<p>By default, perl-5.6.0 (or later) is compiled as a 32-bit application
with largefile and long-long support.</p>
<p>
</p>
<h3><a name="general_32bit_vs__64bit_issues_">General 32-bit vs. 64-bit issues.</a></h3>
<p>Solaris 7 and above will run in either 32 bit or 64 bit mode on SPARC
CPUs, via a reboot. You can build 64 bit apps whilst running 32 bit
mode and vice-versa. 32 bit apps will run under Solaris running in
either 32 or 64 bit mode.  64 bit apps require Solaris to be running
64 bit mode.</p>
<p>Existing 32 bit apps are properly known as LP32, i.e. Longs and
Pointers are 32 bit.  64-bit apps are more properly known as LP64.
The discriminating feature of a LP64 bit app is its ability to utilise a
64-bit address space.  It is perfectly possible to have a LP32 bit app
that supports both 64-bit integers (long long) and largefiles (&gt; 2GB),
and this is the default for perl-5.6.0.</p>
<p>For a more complete explanation of 64-bit issues, see the
``Solaris 64-bit Developer's Guide'' at <a href="http://docs.sun.com/">http://docs.sun.com/</a></p>
<p>You can detect the OS mode using ``isainfo -v'', e.g.</p>
<pre>
 $ isainfo -v   # Ultra 30 in 64 bit mode
 64-bit sparcv9 applications
 32-bit sparc applications</pre>
<p>By default, perl will be compiled as a 32-bit application.  Unless
you want to allocate more than ~ 4GB of memory inside perl, or unless
you need more than 255 open file descriptors, you probably don't need
perl to be a 64-bit app.</p>
<p>
</p>
<h3><a name="large_file_support">Large File Support</a></h3>
<p>For Solaris 2.6 and onwards, there are two different ways for 32-bit
applications to manipulate large files (files whose size is &gt; 2GByte).
(A 64-bit application automatically has largefile support built in
by default.)</p>
<p>First is the ``transitional compilation environment'', described in
lfcompile64(5).  According to the man page,</p>
<pre>
 The transitional compilation  environment  exports  all  the
 explicit 64-bit functions (xxx64()) and types in addition to
 all the regular functions (xxx()) and types. Both xxx()  and
 xxx64()  functions  are  available to the program source.  A
 32-bit application must use the xxx64() functions in  order
 to  access  large  files.  See the lf64(5) manual page for a
 complete listing of the 64-bit transitional interfaces.</pre>
<p>The transitional compilation environment is obtained with the
following compiler and linker flags:</p>
<pre>
 getconf LFS64_CFLAGS        -D_LARGEFILE64_SOURCE
 getconf LFS64_LDFLAG        # nothing special needed
 getconf LFS64_LIBS          # nothing special needed</pre>
<p>Second is the ``large file compilation environment'', described in
lfcompile(5).  According to the man page,</p>
<pre>
 Each interface named xxx() that needs to access 64-bit entities
 to  access  large  files maps to a xxx64() call in the
 resulting binary. All relevant data types are defined to  be
 of correct size (for example, off_t has a typedef definition
 for a 64-bit entity).</pre>
<pre>
 An application compiled in this environment is able  to  use
 the  xxx()  source interfaces to access both large and small
 files, rather than having to explicitly utilize the  transitional
 xxx64()  interface  calls to access large files.</pre>
<p>Two exceptions are <code>fseek()</code> and ftell().  32-bit applications should
use <code>fseeko(3C)</code> and ftello(3C).  These will get automatically mapped
to <code>fseeko64()</code> and ftello64().</p>
<p>The large file compilation environment is obtained with</p>
<pre>
 getconf LFS_CFLAGS      -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
 getconf LFS_LDFLAGS     # nothing special needed
 getconf LFS_LIBS        # nothing special needed</pre>
<p>By default, perl uses the large file compilation environment and
relies on Solaris to do the underlying mapping of interfaces.</p>
<p>
</p>
<h3><a name="building_an_lp64_perl">Building an LP64 perl</a></h3>
<p>To compile a 64-bit application on an UltraSparc with a recent Sun Compiler,
you need to use the flag ``-xarch=v9''.  <code>getconf(1)</code> will tell you this, e.g.</p>
<pre>
 $ getconf -a | grep v9
 XBS5_LP64_OFF64_CFLAGS:         -xarch=v9
 XBS5_LP64_OFF64_LDFLAGS:        -xarch=v9
 XBS5_LP64_OFF64_LINTFLAGS:      -xarch=v9
 XBS5_LPBIG_OFFBIG_CFLAGS:       -xarch=v9
 XBS5_LPBIG_OFFBIG_LDFLAGS:      -xarch=v9
 XBS5_LPBIG_OFFBIG_LINTFLAGS:    -xarch=v9
 _XBS5_LP64_OFF64_CFLAGS:        -xarch=v9
 _XBS5_LP64_OFF64_LDFLAGS:       -xarch=v9
 _XBS5_LP64_OFF64_LINTFLAGS:     -xarch=v9
 _XBS5_LPBIG_OFFBIG_CFLAGS:      -xarch=v9
 _XBS5_LPBIG_OFFBIG_LDFLAGS:     -xarch=v9
 _XBS5_LPBIG_OFFBIG_LINTFLAGS:   -xarch=v9</pre>
<p>This flag is supported in Sun WorkShop Compilers 5.0 and onwards
(now marketed under the name Forte) when used on Solaris 7 or later on
UltraSparc systems.</p>
<p>If you are using gcc, you would need to use -mcpu=v9 -m64 instead.  This
option is not yet supported as of gcc 2.95.2; from install/SPECIFIC
in that release:</p>
<pre>
 GCC version 2.95 is not able to compile code correctly for sparc64
 targets. Users of the Linux kernel, at least, can use the sparc32
 program to start up a new shell invocation with an environment that
 causes configure to recognize (via uname -a) the system as sparc-*-*
 instead.</pre>
<p>All this should be handled automatically by the hints file, if
requested.</p>
<p>
</p>
<h3><a name="long_doubles_">Long Doubles.</a></h3>
<p>As of 5.8.1, long doubles are working if you use the Sun compilers
(needed for additional math routines not included in libm).</p>
<p>
</p>
<h2><a name="threads_in_perl_on_solaris_">Threads in perl on Solaris.</a></h2>
<p>It is possible to build a threaded version of perl on Solaris.  The entire
perl thread implementation is still experimental, however, so beware.</p>
<p>
</p>
<h2><a name="malloc_issues_with_perl_on_solaris_">Malloc Issues with perl on Solaris.</a></h2>
<p>Starting from perl 5.7.1 perl uses the Solaris malloc, since the perl
malloc breaks when dealing with more than 2GB of memory, and the Solaris
malloc also seems to be faster.</p>
<p>If you for some reason (such as binary backward compatibility) really
need to use perl's malloc, you can rebuild perl from the sources
and Configure the build with</p>
<pre>
 $ sh Configure -Dusemymalloc</pre>
<p>You should not use perl's malloc if you are building with gcc.  There
are reports of core dumps, especially in the PDL module.  The problem
appears to go away under -DDEBUGGING, so it has been difficult to
track down.  Sun's compiler appears to be okay with or without perl's
malloc. [XXX further investigation is needed here.]</p>
<p>
</p>
<hr />
<h1><a name="make_problems_">MAKE PROBLEMS.</a></h1>
<dl>
<dt><strong><a name="item_dynamic_loading_problems_with_gnu_as_and_gnu_ld">Dynamic Loading Problems With GNU as and GNU ld</a></strong>

<dd>
<p>If you have problems with dynamic loading using gcc on SunOS or
Solaris, and you are using GNU as and GNU ld, see the section
<a href="#gnu_as_and_gnu_ld">GNU as and GNU ld</a> above.</p>
</dd>
</li>
<dt><strong><a name="item_ld_2eso_2e1_3a__2e_2fperl_3a_fatal_3a_relocation_e">ld.so.1: ./perl: fatal: relocation error:</a></strong>

<dd>
<p>If you get this message on SunOS or Solaris, and you're using gcc,
it's probably the GNU as or GNU ld problem in the previous item
<a href="#gnu_as_and_gnu_ld">GNU as and GNU ld</a>.</p>
</dd>
</li>
<dt><strong><a name="item_dlopen_3a_stub_interception_failed">dlopen: stub interception failed</a></strong>

<dd>
<p>The primary cause of the 'dlopen: stub interception failed' message is
that the LD_LIBRARY_PATH environment variable includes a directory
which is a symlink to /usr/lib (such as /lib).  See
<a href="#ld_library_path">LD_LIBRARY_PATH</a> above.</p>
</dd>
</li>
<dt><strong><a name="item__23error__22no_datamodel_native_specified_22">#error ``No DATAMODEL_NATIVE specified''</a></strong>

<dd>
<p>This is a common error when trying to build perl on Solaris 2.6 with a
gcc installation from Solaris 2.5 or 2.5.1.  The Solaris header files
changed, so you need to update your gcc installation.  You can either
rerun the fixincludes script from gcc or take the opportunity to
update your gcc installation.</p>
</dd>
</li>
<dt><strong><a name="item_sh_3a_ar_3a_not_found">sh: ar: not found</a></strong>

<dd>
<p>This is a message from your shell telling you that the command 'ar'
was not found.  You need to check your PATH environment variable to
make sure that it includes the directory with the 'ar' command.  This
is a common problem on Solaris, where 'ar' is in the /usr/ccs/bin/
directory.</p>
</dd>
</li>
</dl>
<p>
</p>
<hr />
<h1><a name="make_test">MAKE TEST</a></h1>
<p>
</p>
<h2><a name="op_stat_t_test_4_in_solaris">op/stat.t test 4 in Solaris</a></h2>
<p>op/stat.t test 4 may fail if you are on a tmpfs of some sort.
Building in /tmp sometimes shows this behavior.  The
test suite detects if you are building in /tmp, but it may not be able
to catch all tmpfs situations.</p>
<p>
</p>
<h2><a name="nss_delete_core_dump_from_op_pwent_or_op_grent">nss_delete core dump from op/pwent or op/grent</a></h2>
<p>See <a href="perlhpux.html#nss_delete_core_dump_from_op_pwent_or_op_grent">nss_delete core dump from op/pwent or op/grent in the perlhpux manpage</a>.</p>
<p>
</p>
<hr />
<h1><a name="prebuilt_binaries_of_perl_for_solaris_">PREBUILT BINARIES OF PERL FOR SOLARIS.</a></h1>
<p>You can pick up prebuilt binaries for Solaris from
<a href="http://www.sunfreeware.com/">http://www.sunfreeware.com/</a>, <a href="http://www.blastwave.org">http://www.blastwave.org</a>,
ActiveState <a href="http://www.activestate.com/">http://www.activestate.com/</a>, and
<a href="http://www.perl.com/">http://www.perl.com/</a> under the Binaries list at the top of the
page.  There are probably other sources as well.  Please note that
these sites are under the control of their respective owners, not the
perl developers.</p>
<p>
</p>
<hr />
<h1><a name="runtime_issues_for_perl_on_solaris_">RUNTIME ISSUES FOR PERL ON SOLARIS.</a></h1>
<p>
</p>
<h2><a name="limits_on_numbers_of_open_files_on_solaris_">Limits on Numbers of Open Files on Solaris.</a></h2>
<p>The <code>stdio(3C)</code> manpage notes that for LP32 applications, only 255
files may be opened using fopen(), and only file descriptors 0
through 255 can be used in a stream.  Since perl calls <code>open()</code> and
then <code>fdopen(3C)</code> with the resulting file descriptor, perl is limited
to 255 simultaneous open files, even if <code>sysopen()</code> is used.  If this
proves to be an insurmountable problem, you can compile perl as a
LP64 application, see <a href="#building_an_lp64_perl">Building an LP64 perl</a> for details.  Note
also that the default resource limit for open file descriptors on
Solaris is 255, so you will have to modify your ulimit or rctl
(Solaris 9 onwards) appropriately.</p>
<p>
</p>
<hr />
<h1><a name="solarisspecific_modules_">SOLARIS-SPECIFIC MODULES.</a></h1>
<p>See the modules under the Solaris:: and Sun::Solaris namespaces on CPAN,
see <a href="http://www.cpan.org/modules/by-module/Solaris/">http://www.cpan.org/modules/by-module/Solaris/</a> and
<a href="http://www.cpan.org/modules/by-module/Sun/">http://www.cpan.org/modules/by-module/Sun/</a>.</p>
<p>
</p>
<hr />
<h1><a name="solarisspecific_problems_with_modules_">SOLARIS-SPECIFIC PROBLEMS WITH MODULES.</a></h1>
<p>
</p>
<h2><a name="proc__processtable_on_solaris">Proc::ProcessTable on Solaris</a></h2>
<p>Proc::ProcessTable does not compile on Solaris with perl5.6.0 and higher
if you have LARGEFILES defined.  Since largefile support is the
default in 5.6.0 and later, you have to take special steps to use this
module.</p>
<p>The problem is that various structures visible via procfs use off_t,
and if you compile with largefile support these change from 32 bits to
64 bits.  Thus what you get back from procfs doesn't match up with
the structures in perl, resulting in garbage.  See <code>proc(4)</code> for further
discussion.</p>
<p>A fix for Proc::ProcessTable is to edit Makefile to
explicitly remove the largefile flags from the ones MakeMaker picks up
from Config.pm.  This will result in Proc::ProcessTable being built
under the correct environment.  Everything should then be OK as long as
Proc::ProcessTable doesn't try to share off_t's with the rest of perl,
or if it does they should be explicitly specified as off64_t.</p>
<p>
</p>
<h2><a name="bsd__resource_on_solaris">BSD::Resource on Solaris</a></h2>
<p>BSD::Resource versions earlier than 1.09 do not compile on Solaris
with perl 5.6.0 and higher, for the same reasons as Proc::ProcessTable.
BSD::Resource versions starting from 1.09 have a workaround for the problem.</p>
<p>
</p>
<h2><a name="net__ssleay_on_solaris">Net::SSLeay on Solaris</a></h2>
<p>Net::SSLeay requires a /dev/urandom to be present. This device is
available from Solaris 9 onwards.  For earlier Solaris versions you
can either get the package SUNWski (packaged with several Sun
software products, for example the Sun WebServer, which is part of
the Solaris Server Intranet Extension, or the Sun Directory Services,
part of Solaris for ISPs) or download the ANDIrand package from
<a href="http://www.cosy.sbg.ac.at/~andi/">http://www.cosy.sbg.ac.at/~andi/</a>. If you use SUNWski, make a
symbolic link /dev/urandom pointing to /dev/random.  For more details,
see Document ID27606 entitled ``Differing /dev/random support requirements
within Solaris[TM] Operating Environments'', available at
<a href="http://sunsolve.sun.com">http://sunsolve.sun.com</a> .</p>
<p>It may be possible to use the Entropy Gathering Daemon (written in
Perl!), available from <a href="http://www.lothar.com/tech/crypto/">http://www.lothar.com/tech/crypto/</a>.</p>
<p>
</p>
<hr />
<h1><a name="sunos_4_x">SunOS 4.x</a></h1>
<p>In SunOS 4.x you most probably want to use the SunOS ld, /usr/bin/ld,
since the more recent versions of GNU ld (like 2.13) do not seem to
work for building Perl anymore.  When linking the extensions, the
GNU ld gets very unhappy and spews a lot of errors like this</p>
<pre>
  ... relocation truncated to fit: BASE13 ...</pre>
<p>and dies.  Therefore the SunOS 4.1 hints file explicitly sets the
ld to be /usr/bin/ld.</p>
<p>As of Perl 5.8.1 the dynamic loading of libraries (DynaLoader, XSLoader)
also seems to have become broken in in SunOS 4.x.  Therefore the default
is to build Perl statically.</p>
<p>Running the test suite in SunOS 4.1 is a bit tricky since the
<em>lib/Tie/File/t/09_gen_rs</em> test hangs (subtest #51, FWIW) for some
unknown reason.  Just stop the test and kill that particular Perl
process.</p>
<p>There are various other failures, that as of SunOS 4.1.4 and gcc 3.2.2
look a lot like gcc bugs.  Many of the failures happen in the Encode
tests, where for example when the test expects ``0'' you get ``&amp;#48;''
which should after a little squinting look very odd indeed.
Another example is earlier in <em>t/run/fresh_perl</em> where <code>chr(0xff)</code> is
expected but the test fails because the result is chr(0xff).  Exactly.</p>
<p>This is the ``make test'' result from the said combination:</p>
<pre>
  Failed 27 test scripts out of 745, 96.38% okay.</pre>
<p>Running the <code>harness</code> is painful because of the many failing
Unicode-related tests will output megabytes of failure messages,
but if one patiently waits, one gets these results:</p>
<pre>
 Failed Test                     Stat Wstat Total Fail  Failed  List of Failed
 -----------------------------------------------------------------------------
 ...
 ../ext/Encode/t/at-cn.t            4  1024    29    4  13.79%  14-17
 ../ext/Encode/t/at-tw.t           10  2560    17   10  58.82%  2 4 6 8 10 12
                                                                14-17
 ../ext/Encode/t/enc_data.t        29  7424    ??   ??       %  ??
 ../ext/Encode/t/enc_eucjp.t       29  7424    ??   ??       %  ??
 ../ext/Encode/t/enc_module.t      29  7424    ??   ??       %  ??
 ../ext/Encode/t/encoding.t        29  7424    ??   ??       %  ??
 ../ext/Encode/t/grow.t            12  3072    24   12  50.00%  2 4 6 8 10 12 14
                                                                16 18 20 22 24
  Failed Test                     Stat Wstat Total Fail  Failed  List of Failed
 ------------------------------------------------------------------------------
 ../ext/Encode/t/guess.t          255 65280    29   40 137.93%  10-29
 ../ext/Encode/t/jperl.t           29  7424    15   30 200.00%  1-15
 ../ext/Encode/t/mime-header.t      2   512    10    2  20.00%  2-3
 ../ext/Encode/t/perlio.t          22  5632    38   22  57.89%  1-4 9-16 19-20
                                                                23-24 27-32
 ../ext/List/Util/t/shuffle.t       0   139    ??   ??       %  ??
 ../ext/PerlIO/t/encoding.t                    14    1   7.14%  11
 ../ext/PerlIO/t/fallback.t                     9    2  22.22%  3 5
 ../ext/Socket/t/socketpair.t       0     2    45   70 155.56%  11-45
 ../lib/CPAN/t/vcmp.t                          30    1   3.33%  25
 ../lib/Tie/File/t/09_gen_rs.t      0    15    ??   ??       %  ??
 ../lib/Unicode/Collate/t/test.t              199   30  15.08%  7 26-27 71-75
                                                                81-88 95 101
                                                                103-104 106 108-
                                                                109 122 124 161
                                                                169-172
 ../lib/sort.t                      0   139   119   26  21.85%  107-119
 op/alarm.t                                     4    1  25.00%  4
 op/utfhash.t                                  97    1   1.03%  31
 run/fresh_perl.t                              91    1   1.10%  32
 uni/tr_7jis.t                                 ??   ??       %  ??
 uni/tr_eucjp.t                    29  7424     6   12 200.00%  1-6
 uni/tr_sjis.t                     29  7424     6   12 200.00%  1-6
 56 tests and 467 subtests skipped.
 Failed 27/811 test scripts, 96.67% okay. 1383/75399 subtests failed, 98.17% okay.</pre>
<p>The <code>alarm()</code> test failure is caused by <code>system()</code> apparently blocking
alarm().  That is probably a libc bug, and given that SunOS 4.x
has been end-of-lifed years ago, don't hold your breath for a fix.
In addition to that, don't try anything too Unicode-y, especially
with Encode, and you should be fine in SunOS 4.x.</p>
<p>
</p>
<hr />
<h1><a name="author">AUTHOR</a></h1>
<p>The original was written by Andy Dougherty <em><a href="mailto:doughera@lafayette.edu">doughera@lafayette.edu</a></em>
drawing heavily on advice from Alan Burlison, Nick Ing-Simmons, Tim Bunce,
and many other Solaris users over the years.</p>
<p>Please report any errors, updates, or suggestions to <em><a href="mailto:perlbug@perl.org">perlbug@perl.org</a></em>.</p>
<table border="0" width="100%" cellspacing="0" cellpadding="3">
<tr><td class="block" style="background-color: #cccccc" valign="middle">
<big><strong><span class="block">&nbsp;README.solaris - Perl version 5 on Solaris systems</span></strong></big>
</td></tr>
</table>

</body>

</html>
